var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { colors } from './theme';
import * as blackCharacters from './characterSets/black';
import * as whiteCharacters from './characterSets/white';
export var characterCodeColors = [
    {
        name: 'White',
        value: '',
        code: 69,
        color: colors.white,
    },
    {
        name: 'PoppyRed',
        value: '',
        code: 63,
        color: colors.poppyRed,
    },
    {
        name: 'Orange',
        value: '',
        code: 64,
        color: colors.orange,
    },
    {
        name: 'Yellow',
        value: '',
        code: 65,
        color: colors.yellow,
    },
    {
        name: 'Green',
        value: '',
        code: 66,
        color: colors.green,
    },
    {
        name: 'ParisBlue',
        value: '',
        code: 67,
        color: colors.parisBlue,
    },
    {
        name: 'Violet',
        value: '',
        code: 68,
        color: colors.violet,
    },
    {
        name: 'Black',
        value: '',
        code: 70,
        color: colors.black,
        previewColor: colors.darkBlack,
    },
    {
        name: 'Filled',
        value: '',
        code: 71,
        color: colors.white,
        previewColor: colors.white,
        inverseColor: colors.black,
        inversePreviewColor: colors.black,
    },
];
export var characterCodes = __spreadArray([
    {
        name: 'Blank',
        value: ' ',
        code: 0,
        color: colors.blank,
        keyCode: 32,
    },
    {
        name: 'A',
        value: 'A',
        code: 1,
        color: colors.blank,
        keyCode: 65,
        sprite: blackCharacters.A,
        spriteInverse: whiteCharacters.A,
    },
    {
        name: 'B',
        value: 'B',
        code: 2,
        color: colors.blank,
        keyCode: 66,
        sprite: blackCharacters.B,
        spriteInverse: whiteCharacters.B,
    },
    {
        name: 'C',
        value: 'C',
        code: 3,
        color: colors.blank,
        keyCode: 67,
        sprite: blackCharacters.C,
        spriteInverse: whiteCharacters.C,
    },
    {
        name: 'D',
        value: 'D',
        code: 4,
        color: colors.blank,
        keyCode: 68,
        sprite: blackCharacters.D,
        spriteInverse: whiteCharacters.D,
    },
    {
        name: 'E',
        value: 'E',
        code: 5,
        color: colors.blank,
        keyCode: 69,
        sprite: blackCharacters.E,
        spriteInverse: whiteCharacters.E,
    },
    {
        name: 'F',
        value: 'F',
        code: 6,
        color: colors.blank,
        keyCode: 70,
        sprite: blackCharacters.F,
        spriteInverse: whiteCharacters.F,
    },
    {
        name: 'G',
        value: 'G',
        code: 7,
        color: colors.blank,
        keyCode: 71,
        sprite: blackCharacters.G,
        spriteInverse: whiteCharacters.G,
    },
    {
        name: 'H',
        value: 'H',
        code: 8,
        color: colors.blank,
        keyCode: 72,
        sprite: blackCharacters.H,
        spriteInverse: whiteCharacters.H,
    },
    {
        name: 'I',
        value: 'I',
        code: 9,
        color: colors.blank,
        keyCode: 73,
        sprite: blackCharacters.I,
        spriteInverse: whiteCharacters.I,
    },
    {
        name: 'J',
        value: 'J',
        code: 10,
        color: colors.blank,
        keyCode: 74,
        sprite: blackCharacters.J,
        spriteInverse: whiteCharacters.J,
    },
    {
        name: 'K',
        value: 'K',
        code: 11,
        color: colors.blank,
        keyCode: 75,
        sprite: blackCharacters.K,
        spriteInverse: whiteCharacters.K,
    },
    {
        name: 'L',
        value: 'L',
        code: 12,
        color: colors.blank,
        keyCode: 76,
        sprite: blackCharacters.L,
        spriteInverse: whiteCharacters.L,
    },
    {
        name: 'M',
        value: 'M',
        code: 13,
        color: colors.blank,
        keyCode: 77,
        sprite: blackCharacters.M,
        spriteInverse: whiteCharacters.M,
    },
    {
        name: 'N',
        value: 'N',
        code: 14,
        color: colors.blank,
        keyCode: 78,
        sprite: blackCharacters.N,
        spriteInverse: whiteCharacters.N,
    },
    {
        name: 'O',
        value: 'O',
        code: 15,
        color: colors.blank,
        keyCode: 79,
        sprite: blackCharacters.O,
        spriteInverse: whiteCharacters.O,
    },
    {
        name: 'P',
        value: 'P',
        code: 16,
        color: colors.blank,
        keyCode: 80,
        sprite: blackCharacters.P,
        spriteInverse: whiteCharacters.P,
    },
    {
        name: 'Q',
        value: 'Q',
        code: 17,
        color: colors.blank,
        keyCode: 81,
        sprite: blackCharacters.Q,
        spriteInverse: whiteCharacters.Q,
    },
    {
        name: 'R',
        value: 'R',
        code: 18,
        color: colors.blank,
        keyCode: 82,
        sprite: blackCharacters.R,
        spriteInverse: whiteCharacters.R,
    },
    {
        name: 'S',
        value: 'S',
        code: 19,
        color: colors.blank,
        keyCode: 83,
        sprite: blackCharacters.S,
        spriteInverse: whiteCharacters.S,
    },
    {
        name: 'T',
        value: 'T',
        code: 20,
        color: colors.blank,
        keyCode: 84,
        sprite: blackCharacters.T,
        spriteInverse: whiteCharacters.T,
    },
    {
        name: 'U',
        value: 'U',
        code: 21,
        color: colors.blank,
        keyCode: 85,
        sprite: blackCharacters.U,
        spriteInverse: whiteCharacters.U,
    },
    {
        name: 'V',
        value: 'V',
        code: 22,
        color: colors.blank,
        keyCode: 86,
        sprite: blackCharacters.V,
        spriteInverse: whiteCharacters.V,
    },
    {
        name: 'W',
        value: 'W',
        code: 23,
        color: colors.blank,
        keyCode: 87,
        sprite: blackCharacters.W,
        spriteInverse: whiteCharacters.W,
    },
    {
        name: 'X',
        value: 'X',
        code: 24,
        color: colors.blank,
        keyCode: 88,
        sprite: blackCharacters.X,
        spriteInverse: whiteCharacters.X,
    },
    {
        name: 'Y',
        value: 'Y',
        code: 25,
        color: colors.blank,
        keyCode: 89,
        sprite: blackCharacters.Y,
        spriteInverse: whiteCharacters.Y,
    },
    {
        name: 'Z',
        value: 'Z',
        code: 26,
        color: colors.blank,
        keyCode: 90,
        sprite: blackCharacters.Z,
        spriteInverse: whiteCharacters.Z,
    },
    {
        name: 'One',
        value: '1',
        code: 27,
        color: colors.blank,
        keyCode: 49,
        shiftKey: false,
        sprite: blackCharacters.One,
        spriteInverse: whiteCharacters.One,
    },
    {
        name: 'Two',
        value: '2',
        code: 28,
        color: colors.blank,
        keyCode: 50,
        shiftKey: false,
        sprite: blackCharacters.Two,
        spriteInverse: whiteCharacters.Two,
    },
    {
        name: 'Three',
        value: '3',
        code: 29,
        color: colors.blank,
        keyCode: 51,
        shiftKey: false,
        sprite: blackCharacters.Three,
        spriteInverse: whiteCharacters.Three,
    },
    {
        name: 'Four',
        value: '4',
        code: 30,
        color: colors.blank,
        keyCode: 52,
        shiftKey: false,
        sprite: blackCharacters.Four,
        spriteInverse: whiteCharacters.Four,
    },
    {
        name: 'Five',
        value: '5',
        code: 31,
        color: colors.blank,
        keyCode: 53,
        shiftKey: false,
        sprite: blackCharacters.Five,
        spriteInverse: whiteCharacters.Five,
    },
    {
        name: 'Six',
        value: '6',
        code: 32,
        color: colors.blank,
        keyCode: 54,
        shiftKey: false,
        sprite: blackCharacters.Six,
        spriteInverse: whiteCharacters.Six,
    },
    {
        name: 'Seven',
        value: '7',
        code: 33,
        color: colors.blank,
        keyCode: 55,
        shiftKey: false,
        sprite: blackCharacters.Seven,
        spriteInverse: whiteCharacters.Seven,
    },
    {
        name: 'Eight',
        value: '8',
        code: 34,
        color: colors.blank,
        keyCode: 56,
        shiftKey: false,
        sprite: blackCharacters.Eight,
        spriteInverse: whiteCharacters.Eight,
    },
    {
        name: 'Nine',
        value: '9',
        code: 35,
        color: colors.blank,
        keyCode: 57,
        shiftKey: false,
        sprite: blackCharacters.Nine,
        spriteInverse: whiteCharacters.Nine,
    },
    {
        name: 'Zero',
        value: '0',
        code: 36,
        color: colors.blank,
        keyCode: 48,
        shiftKey: false,
        sprite: blackCharacters.Zero,
        spriteInverse: whiteCharacters.Zero,
    },
    {
        name: 'ExclamationMark',
        value: '!',
        code: 37,
        color: colors.blank,
        keyCode: 49,
        shiftKey: true,
        sprite: blackCharacters.ExclamationMark,
        spriteInverse: whiteCharacters.ExclamationMark,
    },
    {
        name: 'AtSign',
        value: '@',
        code: 38,
        color: colors.blank,
        keyCode: 50,
        shiftKey: true,
        sprite: blackCharacters.AtSign,
        spriteInverse: whiteCharacters.AtSign,
    },
    {
        name: 'PoundSign',
        value: '#',
        code: 39,
        color: colors.blank,
        keyCode: 51,
        shiftKey: true,
        sprite: blackCharacters.PoundSign,
        spriteInverse: whiteCharacters.PoundSign,
    },
    {
        name: 'DollarSign',
        value: '$',
        code: 40,
        color: colors.blank,
        keyCode: 52,
        shiftKey: true,
        sprite: blackCharacters.DollarSign,
        spriteInverse: whiteCharacters.DollarSign,
    },
    {
        name: 'LeftParen',
        value: '(',
        code: 41,
        color: colors.blank,
        keyCode: 57,
        shiftKey: true,
        sprite: blackCharacters.LeftParen,
        spriteInverse: whiteCharacters.LeftParen,
    },
    {
        name: 'RightParen',
        value: ')',
        code: 42,
        color: colors.blank,
        keyCode: 48,
        shiftKey: true,
        sprite: blackCharacters.RightParen,
        spriteInverse: whiteCharacters.RightParen,
    },
    {
        name: 'Hyphen',
        value: '-',
        code: 44,
        color: colors.blank,
        keyCode: 189,
        sprite: blackCharacters.Hyphen,
        spriteInverse: whiteCharacters.Hyphen,
    },
    {
        name: 'Hyphen',
        value: '-',
        code: 44,
        color: colors.blank,
        // firefox
        keyCode: 173,
        sprite: blackCharacters.Hyphen,
        spriteInverse: whiteCharacters.Hyphen,
    },
    {
        name: 'PlusSign',
        value: '+',
        code: 46,
        color: colors.blank,
        keyCode: 187,
        shiftKey: true,
        sprite: blackCharacters.PlusSign,
        spriteInverse: whiteCharacters.PlusSign,
    },
    {
        name: 'PlusSign',
        value: '+',
        code: 46,
        color: colors.blank,
        // firefox
        keyCode: 61,
        shiftKey: true,
        sprite: blackCharacters.PlusSign,
        spriteInverse: whiteCharacters.PlusSign,
    },
    {
        name: 'Ampersand',
        value: '&',
        code: 47,
        color: colors.blank,
        keyCode: 55,
        shiftKey: true,
        sprite: blackCharacters.Ampersand,
        spriteInverse: whiteCharacters.Ampersand,
    },
    {
        name: 'EqualsSign',
        value: '=',
        code: 48,
        color: colors.blank,
        keyCode: 187,
        shiftKey: false,
        sprite: blackCharacters.EqualsSign,
        spriteInverse: whiteCharacters.EqualsSign,
    },
    {
        name: 'EqualsSign',
        value: '=',
        code: 48,
        color: colors.blank,
        // firefox
        keyCode: 61,
        shiftKey: false,
        sprite: blackCharacters.EqualsSign,
        spriteInverse: whiteCharacters.EqualsSign,
    },
    {
        name: 'Semicolon',
        value: ';',
        code: 49,
        color: colors.blank,
        keyCode: 186,
        shiftKey: false,
        sprite: blackCharacters.Semicolon,
        spriteInverse: whiteCharacters.Semicolon,
    },
    {
        name: 'Semicolon',
        value: ';',
        code: 49,
        color: colors.blank,
        // firefox
        keyCode: 59,
        shiftKey: false,
        sprite: blackCharacters.Semicolon,
        spriteInverse: whiteCharacters.Semicolon,
    },
    {
        name: 'Colon',
        value: ':',
        code: 50,
        color: colors.blank,
        keyCode: 186,
        shiftKey: true,
        sprite: blackCharacters.Colon,
        spriteInverse: whiteCharacters.Colon,
    },
    {
        name: 'Colon',
        value: ':',
        code: 50,
        color: colors.blank,
        // firefox
        keyCode: 59,
        shiftKey: true,
        sprite: blackCharacters.Colon,
        spriteInverse: whiteCharacters.Colon,
    },
    {
        name: 'SingleQuote',
        value: "'",
        code: 52,
        color: colors.blank,
        keyCode: 222,
        shiftKey: false,
        sprite: blackCharacters.SingleQuote,
        spriteInverse: whiteCharacters.SingleQuote,
    },
    {
        name: 'DoubleQuote',
        value: '"',
        code: 53,
        color: colors.blank,
        keyCode: 222,
        shiftKey: true,
        sprite: blackCharacters.DoubleQuote,
        spriteInverse: whiteCharacters.DoubleQuote,
    },
    {
        name: 'PercentSign',
        value: '%',
        code: 54,
        color: colors.blank,
        keyCode: 53,
        shiftKey: true,
        sprite: blackCharacters.PercentSign,
        spriteInverse: whiteCharacters.PercentSign,
    },
    {
        name: 'Comma',
        value: ',',
        code: 55,
        color: colors.blank,
        keyCode: 188,
        shiftKey: false,
        sprite: blackCharacters.Comma,
        spriteInverse: whiteCharacters.Comma,
    },
    {
        name: 'Period',
        value: '.',
        code: 56,
        color: colors.blank,
        keyCode: 190,
        shiftKey: false,
        sprite: blackCharacters.Period,
        spriteInverse: whiteCharacters.Period,
    },
    {
        name: 'Slash',
        value: '/',
        code: 59,
        color: colors.blank,
        keyCode: 191,
        shiftKey: false,
        sprite: blackCharacters.Slash,
        spriteInverse: whiteCharacters.Slash,
    },
    {
        name: 'QuestionMark',
        value: '?',
        code: 60,
        color: colors.blank,
        keyCode: 191,
        shiftKey: true,
        sprite: blackCharacters.QuestionMark,
        spriteInverse: whiteCharacters.QuestionMark,
    },
    {
        name: 'DegreeSign',
        value: '°',
        code: 62,
        color: colors.blank,
        keyCode: 56,
        shiftKey: true,
        sprite: blackCharacters.DegreeSign,
        spriteInverse: whiteCharacters.DegreeSign,
    }
], characterCodeColors, true);
