import React from 'react';
import { colors } from '../theme';
import MaterialButton from '@mui/material/Button';
import { Theme } from './Theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function () {
    return {
        default: {
            borderRadius: '6px',
            textTransform: 'none',
            backgroundColor: colors.white,
            fontFamily: 'HelveticaNeue',
            fontSize: 12,
            fontWeight: 500,
            color: colors.grey,
            borderColor: 'transparent',
            borderWidth: 1,
            borderStyle: 'solid',
            '&:hover': {
                backgroundColor: colors.lightGrey,
                color: colors.woodSmoke,
            },
        },
    };
});
export var ActionButton = function (props) {
    var classes = useStyles();
    return (React.createElement(Theme, null,
        React.createElement(MaterialButton, { disabled: props.disabled, type: props.type, variant: "contained", sx: classes.default, onClick: props.onClick, size: "small" }, props.children)));
};
