var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useState } from 'react';
import Checkbox from '@mui/material/Checkbox';
import TextField from '@mui/material/TextField';
import Autocomplete from '@mui/material/Autocomplete';
import CheckBoxOutlineBlankIcon from '@mui/icons-material/CheckBoxOutlineBlank';
import CheckBoxIcon from '@mui/icons-material/CheckBox';
import { colors, radius, responsive } from '../theme';
import { Body, Small } from './Typography';
import { Box } from '@mui/material';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function () {
    var _a;
    return ({
        label: {
            color: colors.white,
        },
        checkbox: {
            color: colors.nevada,
        },
        input: {
            outline: 0,
            '& > div': {
                borderRadius: radius.medium,
                backgroundColor: colors.woodSmoke,
            },
            '& label': {
                color: "".concat(colors.alto, " !important"),
            },
            '& fieldset': {
                borderColor: colors.nevada,
            },
            '&:hover .MuiOutlinedInput-root .MuiOutlinedInput-notchedOutline': {
                borderColor: "".concat(colors.alto, " !important"),
            },
            '& input': (_a = {
                    color: colors['white'],
                    fontSize: 16
                },
                _a["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
                    fontSize: 12,
                    marginBottom: 0,
                },
                _a),
            '& textarea': {
                color: colors.white,
            },
        },
        optionContainer: {
            backgroundColor: colors['woodSmoke'],
            flexDirection: 'row',
            width: '100%',
        },
        optionTextContainer: {
            backgroundColor: 'transparent',
            flexDirection: 'column',
        },
        tag: {
            backgroundColor: colors['mineShaft'],
            zIndex: 0,
            '& .MuiChip-label': {
                color: colors['alto'],
            },
            '& .MuiChip-deleteIcon': {
                color: colors['poppyRed'],
            },
        },
        option: {
            backgroundColor: colors['shark'],
            width: '100%',
            '&:hover': {
                backgroundColor: colors['shuttleGray'],
            },
        },
        listbox: {
            backgroundColor: colors['shark'],
        },
        popupIndicator: {
            color: colors['alto'],
        },
        popupIndicatorOpen: {
            color: colors['alto'],
        },
        loading: {
            backgroundColor: colors['shark'],
            textColor: colors['alto'],
            color: colors['alto'],
        },
        noOptions: {
            backgroundColor: colors['shark'],
            textColor: colors['alto'],
            color: colors['alto'],
        },
        clearIndicator: {
            color: colors['alto'],
        },
        clearIndicatorDirty: {
            color: colors['poppyRed'],
        },
    });
});
var icon = (React.createElement(CheckBoxOutlineBlankIcon, { style: { color: colors['alto'] }, fontSize: "small" }));
var checkedIcon = (React.createElement(CheckBoxIcon, { style: { color: colors['tundra'] }, fontSize: "small" }));
export var AsyncMultiSelect = function (props) {
    var labelKeyName = props.labelKeyName || 'label';
    var classes = useStyles();
    var _a = useState(''), input = _a[0], setInput = _a[1];
    var _b = useState([]), selected = _b[0], setSelected = _b[1];
    var _c = React.useState(props.options), filteredOptions = _c[0], setFilteredOptions = _c[1];
    var onInputChange = function (value) {
        setInput(value);
        props.onInputChange(value);
    };
    var defaultOptions = props.defaultSelectedOptions || [];
    // reset filitered options if new option props are passed
    var optionString = JSON.stringify(props.options);
    React.useEffect(function () {
        setFilteredOptions(function () {
            if (props.filterLocally) {
                return props.options.filter(function (v) {
                    return ((v.description &&
                        v.description.toLowerCase().indexOf(input.toLowerCase()) > -1) ||
                        v.label.toLowerCase().indexOf(input.toLowerCase()) > -1);
                });
            }
            else {
                return props.options;
            }
        });
    }, [input, props.loading, optionString]);
    return (React.createElement(Autocomplete, { multiple: true, ListboxProps: {
            sx: classes.listbox,
        }, ChipProps: {
            sx: classes.tag,
        }, defaultValue: defaultOptions, getOptionDisabled: function () {
            return (props.maxOptions &&
                (selected.length === props.maxOptions ||
                    defaultOptions.length === props.maxOptions)) ||
                false;
        }, filterSelectedOptions: props.filterSelectedOptions, filterOptions: function (v) { return v; }, onChange: function (event, value) {
            console.log(event, value, ':::value');
            props.onOptionSelect(value);
            setSelected(value);
        }, disabled: props.disabled || false, fullWidth: props.fullWidth || false, id: "async-multiselect", options: filteredOptions.sort(function (o1, o2) {
            if (props.sortLocally) {
                return o1.label.localeCompare(o2.label);
            }
            else {
                return 0;
            }
        }), disableCloseOnSelect: props.disableCloseOnSelect, loading: props.loading, loadingText: props.loadingText || 'Loading...', getOptionLabel: function (option) { return option[labelKeyName]; }, sx: {
            '.MuiAutocomplete-clearIndicator': {
                color: colors.alto,
            },
            '.MuiAutocomplete-popupIndicator': {
                color: colors.alto,
            },
        }, renderOption: function (props2, option) {
            var selected = option.selected;
            return (
            // @ts-ignore
            React.createElement("div", __assign({}, props2),
                React.createElement(Box, { flexDirection: 'row', alignItems: 'center', display: 'flex', height: 72, key: option[labelKeyName] },
                    React.createElement(Checkbox, { icon: icon, checkedIcon: checkedIcon, style: { marginRight: 8 }, checked: selected || (props2 === null || props2 === void 0 ? void 0 : props2['aria-selected']) || false, sx: classes.checkbox }),
                    React.createElement(Box, null,
                        React.createElement(Body, null, option[labelKeyName]),
                        React.createElement(Small, null, option[props.descriptionKeyName])))));
        }, style: { width: '100%', maxWidth: '100%' }, renderInput: function (params) {
            return (React.createElement(TextField, __assign({}, params, { sx: classes.input, value: input, onChange: function (e) { return onInputChange(e.target.value); }, variant: "outlined", label: props.label, placeholder: props.placeholder })));
        } }));
};
