var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect } from 'react';
import { Boards } from './Boards';
import Box from '@mui/material/Box';
import { GalleryFooter } from './GalleryFooter';
import { GalleryHeader } from './GalleryHeader';
import { Pagination } from '../Pagination';
import { createBoard } from '../../utils';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        flexDirection: 'column',
        position: 'relative',
    },
});
export var BoardGallery = function (props) {
    var classes = useStyles();
    var boards = props.boards.map(function (board) { return (__assign(__assign({}, board), { message: board.message || createBoard() })); });
    useEffect(function () {
        var handleKeyPress = function (e) {
            // Right Arrow
            if (e.keyCode === 39 && props.currentPage < props.boards.length - 1) {
                props.setPage(props.currentPage + 1);
            }
            // Left Arrow
            if (e.keyCode === 37 && props.currentPage !== 0) {
                props.setPage(props.currentPage - 1);
            }
        };
        window.addEventListener('keydown', handleKeyPress);
        return function () {
            window.removeEventListener('keydown', handleKeyPress);
        };
    }, [props.currentPage, props.setPage]);
    var currentBoard = props.boards[props.currentPage];
    return (React.createElement(Box, { sx: classes.container },
        props.handleLeave || props.handleRename || props.handleDelete ? (React.createElement(GalleryHeader, { currentBoard: currentBoard, handleLeave: props.handleLeave, handleRename: props.handleRename, handleDelete: props.handleDelete, handleMuted: props.handleMuted, enableSettingsActions: props.enableSettingsActions })) : null,
        props.handleCopy || props.handlePublish || props.handleSettings ? (React.createElement(GalleryFooter, { currentBoard: currentBoard, handleCopy: props.handleCopy, handlePublish: props.handlePublish, handleSettings: props.handleSettings })) : null,
        React.createElement(Boards, { currentBoard: currentBoard, currentPage: props.currentPage, setPage: props.setPage, boards: boards, handleShare: props.handleShare, handleFavorite: props.handleFavorite, handleDuplicate: props.handleDuplicate, hasPadding: !!(props.handleLeave ||
                props.handleRename ||
                props.handleDelete ||
                props.handleCopy ||
                props.handlePublish ||
                props.handleSettings) }),
        React.createElement(Pagination, { numberOfPages: boards.length, currentPage: props.currentPage, setPage: props.setPage })));
};
