var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
import * as React from 'react';
import Box from '@mui/material/Box';
import ButtonBase from '@mui/material/ButtonBase';
import { createBoard } from '../../utils';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
import { responsive } from '../../theme';
import { MessageCard } from '../MessageCard';
var useStyles = makeVestaboardStyles({
    boards: {
        position: 'relative',
        perspective: 500,
    },
    boardsPadded: (_a = {
            height: 400
        },
        _a["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            height: 270,
        },
        _a),
    boardNotPadded: (_b = {
            height: 350
        },
        _b["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            height: 215,
        },
        _b),
    boardContainer: (_c = {
            position: 'absolute',
            width: 352,
            height: 216,
            top: 70,
            left: "calc(50% - 176px)",
            alignItems: 'center',
            justifyContent: 'center',
            flexDirection: 'column',
            transition: 'all 500ms ease 0s',
            transformStyle: 'preserve-3d',
            opacity: 0,
            display: 'block'
        },
        _c["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            top: 10,
        },
        _c),
    boardContainerCurrent: (_d = {
            transform: "none",
            zIndex: 999,
            opacity: 1
        },
        _d["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            transform: "scale(0.90)",
            top: 30,
        },
        _d),
    boardContainerPrevious: (_e = {
            transform: "translateX(-300px) translateZ(-400px) rotateY(35deg)",
            zIndex: 998,
            opacity: 1
        },
        _e["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            transform: "translateX(-140px) translateZ(-216px) rotateY(35deg) scale(0.8)",
            top: 30,
        },
        _e),
    boardContainerBeforePrevious: (_f = {
            transform: "translateX(-200px) translateZ(-500px) rotateY(35deg)",
            zIndex: 997,
            opacity: 1
        },
        _f["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            transform: "translateX(-120px) translateZ(-210px) rotateY(35deg) scale(0.55)",
            top: 30,
        },
        _f),
    boardContainerPreviousOffscreen: (_g = {
            transform: "translateX(480px) translateZ(-500px) rotateY(35deg)",
            zIndex: 996,
            opacity: 0
        },
        _g["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            transform: "translateX(-120px) translateZ(-210px) rotateY(35deg) scale(0.55)",
            top: 30,
        },
        _g),
    boardContainerNext: (_h = {
            transform: "translateX(300px) translateZ(-400px) rotateY(-35deg)",
            zIndex: 998,
            opacity: 1
        },
        _h["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            transform: "translateX(140px) translateZ(-216px) rotateY(-35deg) scale(0.8)",
            top: 30,
        },
        _h),
    boardContainerAfterNext: (_j = {
            transform: "translateX(200px) translateZ(-500px) rotateY(-35deg)",
            zIndex: 997,
            opacity: 1
        },
        _j["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            transform: "translateX(120px) translateZ(-210px) rotateY(-35deg) scale(0.55)",
            top: 30,
        },
        _j),
    boardContainerNextOffscreen: (_k = {
            transform: "translateX(-480px) translateZ(-500px) rotateY(-35deg)",
            zIndex: 996,
            opacity: 0
        },
        _k["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            transform: "translateX(120px) translateZ(-210px) rotateY(-35deg) scale(0.55)",
            top: 30,
        },
        _k),
    title: {},
    boardContainerButton: {
        width: 352,
        height: 216,
        display: 'flex',
        flexDirection: 'column',
        '& > div': {
            height: '100%',
            width: '100%',
        },
    },
});
//     width: 352,
// height: 216,
export var BoardsV2 = function (props) {
    var _a;
    var classes = useStyles();
    var singleButton = ((_a = [
        props.onSendPress,
        props.handleShare,
        props.handleDuplicate,
        props.onEditPress,
    ]) === null || _a === void 0 ? void 0 : _a.filter(Boolean).length) === 1;
    return (React.createElement(Box, { sx: __assign(__assign({}, classes.boards), (props.hasPadding ? classes.boardsPadded : classes.boardNotPadded)) }, props.boards.map(function (board, i) {
        var isCurrent = props.currentPage === i;
        var isPrevious = props.currentPage - 1 === i;
        var isNext = props.currentPage + 1 === i;
        var isBeforePrevious = props.currentPage - 2 === i;
        var isPreviousOffscreen = props.currentPage - 2 < i;
        var isAfterNext = props.currentPage + 2 === i;
        var isNextOffscreen = props.currentPage + 2 > i;
        var isSecondRow = isPrevious || isNext;
        var isThirdRow = isBeforePrevious || isAfterNext;
        var message = board.message || createBoard();
        return (React.createElement(Box, { sx: __assign(__assign({}, classes.boardContainer), (isCurrent
                ? classes.boardContainerCurrent
                : isNext
                    ? classes.boardContainerNext
                    : isPrevious
                        ? classes.boardContainerPrevious
                        : isBeforePrevious
                            ? classes.boardContainerBeforePrevious
                            : isAfterNext
                                ? classes.boardContainerAfterNext
                                : isNextOffscreen
                                    ? classes.boardContainerNextOffscreen
                                    : isPreviousOffscreen
                                        ? classes.boardContainerPreviousOffscreen
                                        : classes.boardContainerPreviousOffscreen)), key: board.id }, isCurrent ? (React.createElement(React.Fragment, null,
            React.createElement(MessageCard, { boardStyle: board.boardStyle || 'black', characters: message, isFavorite: board.isFavorite, messageId: '', sourceId: '', onSendPress: props.onSendPress, singleButton: singleButton, onFavoritePress: props.handleFavorite
                    ? function () {
                        return props.handleFavorite && props.handleFavorite(message);
                    }
                    : undefined, onDuplicatePress: props.handleDuplicate, onSharePress: props.handleShare, onEditPress: props.onEditPress, onDeletePress: props.onDeletePress, sentAt: board === null || board === void 0 ? void 0 : board.created, source: board === null || board === void 0 ? void 0 : board.author }))) : (React.createElement(ButtonBase, { onClick: function () {
                props.setPage(i);
            }, sx: classes.boardContainerButton },
            React.createElement(Box, { style: {
                    opacity: isSecondRow ? 1 : isThirdRow ? 0.1 : 1,
                } },
                React.createElement(MessageCard, { characters: message, boardStyle: board.boardStyle || 'black', messageId: '', sourceId: '', singleButton: true, onSendPress: function () { } }))))));
    })));
};
