var _a, _b, _c, _d;
import * as React from 'react';
import ButtonBase from '@mui/material/ButtonBase';
import { getIcon } from '../../utils/getIcon';
import { responsive } from '../../theme';
import { Box, useMediaQuery } from '@mui/material';
import { Icon } from '../Icon';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
var bottom = 100;
var useStyles = makeVestaboardStyles({
    copy: (_a = {
            opacity: 0.6,
            fontFamily: 'HelveticaNeue',
            fontSize: 12,
            position: 'absolute',
            left: "calc(50% - 230px)",
            bottom: 50,
            color: '#f5f5f7'
        },
        _a["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            left: "calc(12%)",
        },
        _a),
    publish: (_b = {
            position: 'absolute',
            right: "calc(50% - 200px)",
            bottom: 50
        },
        _b["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            right: "calc(22%)",
        },
        _b),
    settings: (_c = {
            position: 'absolute',
            right: "calc(50% - 240px)",
            bottom: 50
        },
        _c["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            right: "calc(12%)",
        },
        _c),
    mutedBoard: (_d = {
            position: 'absolute',
            backgroundColor: 'rgba(125, 135, 142, 0.2)',
            width: 50,
            height: 30,
            bottom: 40,
            borderRadius: '60px',
            right: "calc(50% - 25px)"
        },
        _d["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            height: 20,
            bottom: 50,
            right: "calc(50% - 55px)",
        },
        _d),
});
export var GalleryFooter = function (props) {
    var classes = useStyles();
    var currentBoard = props.currentBoard;
    var isMobile = useMediaQuery("(max-width: ".concat(responsive.MOBILE, "px)"));
    return (React.createElement(React.Fragment, null,
        currentBoard.friendlyIdentifier && props.handleCopy && (React.createElement(ButtonBase, { sx: classes.copy, onClick: function () {
                if (props.handleCopy) {
                    props.handleCopy(currentBoard);
                }
            } },
            "ID: ",
            currentBoard.friendlyIdentifier,
            " \u00A0",
            React.createElement("img", { src: getIcon('copy-icon'), alt: "Copy" }))),
        props.handleMuted && (currentBoard === null || currentBoard === void 0 ? void 0 : currentBoard.isMuted) && (React.createElement(Box, null,
            React.createElement(ButtonBase, { sx: classes.mutedBoard, onClick: function () { return props.handleMuted && props.handleMuted(currentBoard); } },
                React.createElement(Icon, { type: "mute", size: isMobile ? 12 : undefined })))),
        props.handlePublish ? (React.createElement(ButtonBase, { sx: classes.publish, onClick: function () {
                if (props.handlePublish) {
                    props.handlePublish(currentBoard);
                }
            } },
            React.createElement("img", { src: getIcon('publish-icon'), alt: "Publish" }))) : null,
        props.handleSettings ? (React.createElement(ButtonBase, { sx: classes.settings, onClick: function () {
                if (props.handleSettings) {
                    props.handleSettings(currentBoard);
                }
            } },
            React.createElement("img", { src: getIcon('settings'), alt: "Settings" }))) : null));
};
