var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useRef, useState } from 'react';
import { colors, fontFamily } from '../../theme';
import Box from '@mui/material/Box';
import ButtonBase from '@mui/material/ButtonBase';
import { getIcon } from '../../utils/getIcon';
import { responsive } from '../../theme';
import { useOutsideClick } from '../../hooks/useOutsideClick';
import { Icon } from '../Icon';
import { useMediaQuery } from '@mui/material';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function (props) {
    var _a, _b, _c;
    return ({
        currentHeader: {
            zIndex: 4,
            position: 'absolute',
            top: 0,
        },
        currentHeaderInner: {
            position: 'relative',
            display: 'flex',
            alignItems: 'center',
        },
        currentTitle: {
            fontFamily: 'HelveticaNeue',
            fontSize: 20,
            fontWeight: 'bold',
            color: '#f5f5f7',
        },
        statusIndicator: {
            height: 8,
            width: 8,
            backgroundColor: '#1f9a44',
            borderRadius: '50%',
            margin: '8px',
        },
        status: {
            color: '#f5f5f7',
            fontFamily: 'HelveticaNeue',
            fontSize: 12,
        },
        chevron: {
            transform: "rotate(-45deg)",
            borderLeft: "solid 1px #FFF",
            borderBottom: "solid 1px #FFF",
            height: 7,
            width: 7,
            marginLeft: '16px',
            marginRight: '7px',
            position: 'relative',
            top: -1,
            transition: 'all 350ms',
        },
        chevronActive: {
            transform: "rotate(-225deg)",
            top: 2,
        },
        toggleContent: (_a = {
                backdropFilter: 'blur(10px)',
                backgroundColor: "rgba(125, 135, 142, 0.2)",
                borderRadius: '6px',
                width: 177,
                position: 'absolute',
                right: -100,
                top: 36,
                opacity: 0,
                transition: 'all 1000ms',
                pointerEvents: 'none'
            },
            _a["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
                right: 0,
            },
            _a),
        toggleContentActive: {
            opacity: 1,
            pointerEvents: 'all',
        },
        toggleItem: {
            color: '#f5f5f7',
            fontSize: 14,
            fontFamily: fontFamily.default,
            padding: '14px 23px',
            width: '100%',
            display: 'flex',
            justifyContent: 'space-between',
        },
        toggleDivider: {
            height: 1,
            width: '100%',
            backgroundColor: colors.woodSmoke,
        },
        muteContainer: (_b = {
                display: 'flex',
                position: 'absolute',
                top: 346,
                zIndex: 99,
                alignItems: 'center',
                justifyContent: 'center',
                width: '100%'
            },
            _b["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
                top: 196,
            },
            _b),
        mutedBoard: (_c = {
                display: 'flex',
                backgroundColor: 'rgba(125, 135, 142, 0.2)',
                width: 50,
                height: 30,
                borderRadius: '60px',
                alignItems: 'center',
                justifyContent: 'center'
            },
            _c["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
                height: 20,
            },
            _c),
    });
});
export var GalleryHeader = function (props) {
    var _a = useState(false), currentBoardDropdownActive = _a[0], setCurrentBoardDropdownActive = _a[1];
    var ref = useRef(null);
    useOutsideClick(ref, function () {
        setCurrentBoardDropdownActive(false);
    });
    var classes = useStyles(props);
    var currentBoard = props.currentBoard;
    var isMobile = useMediaQuery("(max-width: ".concat(responsive.MOBILE, "px)"));
    if (!props.handleDelete && !props.handleLeave && !props.handleRename) {
        return null;
    }
    return (React.createElement(Box, { sx: classes.currentHeader },
        React.createElement(Box, { sx: classes.currentHeaderInner },
            React.createElement(ButtonBase, { disabled: currentBoardDropdownActive || !props.enableSettingsActions, onClick: function () {
                    setCurrentBoardDropdownActive(!currentBoardDropdownActive);
                } },
                React.createElement(Box, { sx: classes.currentTitle }, currentBoard.title),
                props.enableSettingsActions && (React.createElement(Box, { sx: __assign(__assign({}, classes.chevron), (currentBoardDropdownActive ? classes.chevronActive : {})) })),
                React.createElement(Box, { sx: classes.statusIndicator, style: {
                        backgroundColor: currentBoard.status === 'virtual'
                            ? '#1976d2'
                            : currentBoard.status === 'offline'
                                ? '#7d878e'
                                : '#1f9a44',
                    } }),
                React.createElement(Box, { sx: classes.status }, currentBoard.status))),
        props.handleMuted && (currentBoard === null || currentBoard === void 0 ? void 0 : currentBoard.isMuted) && (React.createElement(Box, { sx: classes.muteContainer },
            React.createElement(ButtonBase, { sx: classes.mutedBoard, onClick: function () { return props.handleMuted && props.handleMuted(currentBoard); } },
                React.createElement(Icon, { type: "mute", size: isMobile ? 12 : undefined })))),
        props.enableSettingsActions ? (React.createElement("div", { style: __assign(__assign({}, classes.toggleContent), (currentBoardDropdownActive
                ? classes.toggleContentActive
                : {})), ref: ref },
            props.handleRename ? (React.createElement(ButtonBase, { sx: classes.toggleItem, onClick: function () {
                    setCurrentBoardDropdownActive(false);
                    if (props.handleRename) {
                        props.handleRename(props.currentBoard);
                    }
                } },
                React.createElement(Box, null, "Rename"),
                React.createElement("img", { src: getIcon('edit-white'), alt: "Rename" }))) : null,
            React.createElement(Box, { sx: classes.toggleDivider }),
            currentBoard.isOwner ? (props.handleDelete ? (React.createElement(ButtonBase, { sx: classes.toggleItem, onClick: function () {
                    setCurrentBoardDropdownActive(false);
                    if (props.handleDelete) {
                        props.handleDelete(currentBoard);
                    }
                } },
                React.createElement(Box, null, "Delete"),
                React.createElement("img", { src: getIcon('trash-white'), alt: "Delete" }))) : null) : props.handleLeave ? (React.createElement(ButtonBase, { sx: classes.toggleItem, onClick: function () {
                    setCurrentBoardDropdownActive(false);
                    if (props.handleLeave) {
                        props.handleLeave(currentBoard);
                    }
                } },
                React.createElement(Box, null, "Leave"),
                React.createElement("img", { src: getIcon('leave'), alt: "Leave" }))) : null)) : null));
};
