var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a;
import { Button, Icon, SubTitle, Body, Modal, useToasts, Spacer, } from './';
import React, { useRef, useState } from 'react';
import Box from '@mui/material/Box';
import MaterialButton from '@mui/material/Button';
import { fontFamily, responsive } from '../theme';
import { getIcon } from '../utils/getIcon';
import { useOutsideClick } from '../hooks/useOutsideClick';
import { ButtonBase, Typography } from '@mui/material';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        position: 'relative',
    },
    mask: {
        opacity: 0,
        position: 'absolute',
        width: 'calc(100% - 4px)',
        height: 'calc(100% - 4px)',
        top: 0,
        left: 0,
        backdropFilter: 'blur(7px)',
        borderRadius: '3%',
        transition: 'opacity 0.5s',
        border: 'solid 2px #7d878e',
        backgroundImage: 'linear-gradient(to bottom, rgba(23, 24, 24, 0.59), rgba(23, 24, 24, 0.59))',
    },
    sendButtonContainer: {
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        height: 'calc(100% - 54px)',
        width: '100%',
        opacity: 1,
    },
    sendButtonContainerBlur: {
        opacity: 0.3,
    },
    showMask: {
        opacity: 1,
    },
    showMaskButton: {
        opacity: 0,
        position: 'absolute',
        width: '100%',
        height: '100%',
        top: 0,
        left: 0,
        cursor: 'pointer',
    },
    topButton: {
        position: 'absolute',
        top: 16,
        zIndex: 3,
        backgroundColor: 'transparent',
        fontFamily: fontFamily.default,
        fontSize: 12,
        textTransform: 'none',
        filter: 'invert(1)',
        color: 'transparent',
        transition: 'filter 1s, color 1s, background-color 1s',
        '&:hover': {
            backgroundColor: '#FFF',
            color: '#000',
            filter: 'invert(0)',
        },
    },
    deleteButton: {
        left: 16,
        right: 'unset',
        minWidth: 16,
    },
    codeButton: {
        right: 16,
    },
    bottomButtons: {
        zIndex: 3,
        height: 52,
        width: '100%',
        position: 'absolute',
        bottom: 0,
        left: 0,
        display: 'flex',
        borderTop: 'solid 1px #979797',
    },
    buttonIcon: {
        marginLeft: '8px',
    },
    bottomButton: {
        background: 'transparent',
        border: 0,
        height: '100%',
        flex: 1,
        cursor: 'pointer',
        fontFamily: fontFamily.default,
        fontSize: 14,
        color: '#FFF',
        borderRight: 'solid 1px #979797',
        outline: 'none',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        '&:first-child': {
            borderRadius: '0px 0px 0px 12%',
        },
        '&:last-child': {
            borderRadius: '0px 0px 12% 0px',
            borderRight: 'none',
        },
        '&:hover': {
            backgroundColor: '#FFF',
            color: '#000',
        },
    },
    modalContent: {
        textAlign: 'center',
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'flex-end',
        alignItems: 'center',
        padding: '24px',
        height: '100%',
    },
    modalBtnGroup: {
        display: 'flex',
        gap: '24px',
        justifyContent: 'space-between',
        marginTop: '24px',
        width: '100%',
    },
    pinTimeContainer: {
        padding: '0px 20px 40px',
        textAlign: 'center',
        maxWidth: 460,
    },
    pinFor: {
        fontSize: 16,
        fontWeight: 500,
        textAlign: 'center',
        color: '#f5f5f7',
    },
    inputRow: {
        display: 'flex',
        flexDirection: 'row',
    },
    inputBox: {
        display: 'flex',
        justifyContent: 'center',
    },
    timeBox: {
        width: 87,
        maxWidth: '30%',
    },
    input: (_a = {
            width: 'calc(100% - 16px)',
            paddingLeft: '16px',
            height: 48,
            borderRadius: '6px',
            border: 'solid 1px #f5f5f7',
            fontSize: 34,
            fontWeight: 500,
            background: 'transparent',
            textAlign: 'center',
            color: '#f5f5f7',
            outline: 'none'
        },
        _a["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            fontSize: 28,
        },
        _a),
    label: {
        margin: '7px 0px 0 0px',
        opacity: 0.75,
        fontSize: 14,
        letterSpacing: 0.2,
        textAlign: 'center',
        color: '#f5f5f7',
    },
    colon: {
        width: 12,
        height: 40,
        margin: '2px 8px 12px 12px',
        fontSize: 34,
        fontWeight: 500,
        textAlign: 'center',
        color: '#f5f5f7',
    },
});
var DeleteConfirmationModal = function (props) {
    var classes = useStyles();
    return (React.createElement(Modal, { fullScreenMobile: true, visible: props.visible, onClose: props.onClose },
        React.createElement(Box, { sx: classes.modalContent },
            React.createElement(Icon, { type: "delete", size: 18, color: "white" }),
            React.createElement(Spacer, { size: "large" }),
            React.createElement(SubTitle, null, "Delete Message"),
            React.createElement(Spacer, { size: "small" }),
            React.createElement(Body, null, "Are you sure you want to permanently delete this message from History? No users who manage this Vestaboard will be able to see the message in History again."),
            React.createElement(Box, { sx: classes.modalBtnGroup },
                React.createElement(Button, { onClick: props.onClose, buttonType: "outline" }, "Cancel"),
                React.createElement(Button, { onClick: props.onDelete, buttonType: "danger" }, "Delete Message")))));
};
var PinMessageModal = function (props) {
    var classes = useStyles();
    return (React.createElement(Modal, { fullScreenMobile: true, visible: props.visible, onClose: props.onClose },
        React.createElement(Box, { sx: classes.modalContent },
            React.createElement(Icon, { type: "pin", size: 38, color: "white" }),
            React.createElement(Spacer, { size: "large" }),
            React.createElement(SubTitle, null, "Pin this message on Vestaboard"),
            React.createElement(Spacer, { size: "large" }),
            React.createElement(Typography, { sx: classes.pinFor }, "No automated message will overwrite it for:"),
            React.createElement(Box, { sx: classes.pinTimeContainer },
                React.createElement(Spacer, { size: "large" }),
                React.createElement(Box, { sx: classes.inputRow },
                    React.createElement(Box, { sx: classes.timeBox },
                        React.createElement("input", { step: 1, min: 0, type: "number", style: classes.input, value: props.hourValue, onChange: function (e) {
                                return props.onHourValueChange &&
                                    props.onHourValueChange("".concat(+e.target.value));
                            } }),
                        React.createElement(Typography, { sx: classes.label }, "Hours")),
                    React.createElement(Box, { sx: classes.colon }, ":"),
                    React.createElement(Box, { sx: classes.timeBox },
                        React.createElement("input", { step: 1, min: 0, max: 59, type: "number", style: classes.input, value: props.minuteValue, onChange: function (e) {
                                return props.onMinuteValueChange &&
                                    props.onMinuteValueChange("".concat(+e.target.value));
                            } }),
                        React.createElement(Typography, { sx: classes.label }, "Minutes")),
                    React.createElement(Box, { sx: classes.colon }, ":"),
                    React.createElement(Box, { sx: classes.timeBox },
                        React.createElement("input", { step: 1, min: 0, max: 59, type: "number", style: classes.input, value: props.secondValue, onChange: function (e) {
                                return props.onSecondValueChange &&
                                    props.onSecondValueChange("".concat(+e.target.value));
                            } }),
                        React.createElement(Typography, { sx: classes.label }, "Seconds")))),
            React.createElement(Spacer, { size: "extraLarge" }),
            React.createElement(Box, { sx: classes.modalBtnGroup },
                React.createElement(Button, { onClick: props.onClose, buttonType: "outline" }, "Cancel"),
                React.createElement(Button, { onClick: props.onSend, buttonType: "white" },
                    "Send \u00A0",
                    React.createElement(Icon, { type: "send", size: 18, color: "black" }))))));
};
export var BoardPreviewMask = function (props) {
    var _a, _b;
    var addToast = useToasts().addToast;
    var classes = useStyles();
    var _c = useState('send'), activeButton = _c[0], setActiveButton = _c[1];
    var _d = useState(props.defaultShowMask || false), showMask = _d[0], setShowMask = _d[1];
    var _e = useState(false), showConfirmationModal = _e[0], setShowConfirmationModal = _e[1];
    var _f = useState(false), showPinModal = _f[0], setShowPinModal = _f[1];
    var ref = useRef(null);
    useOutsideClick(ref, function () {
        setShowMask(false);
    });
    var onPinClick = function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!props.handlePin) return [3 /*break*/, 2];
                    return [4 /*yield*/, props.handlePin()];
                case 1:
                    _a.sent();
                    setShowPinModal(false);
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); };
    var buttons = (props.isDraft
        ? [
            {
                title: 'Discard',
                icon: 'delete',
                onClick: props.handleDiscard,
            },
            {
                title: 'Edit',
                icon: 'edit',
                onClick: props.handleEdit,
            },
            {
                title: (_a = props.handleDuplicateTitle) !== null && _a !== void 0 ? _a : 'Duplicate',
                icon: 'copy',
                onClick: props.handleDuplicate,
            },
        ]
        : [
            {
                title: 'Share',
                icon: 'share',
                onClick: props.handleShare,
            },
            {
                title: props.isPinned ? 'Unpin' : 'Pin',
                icon: 'pin',
                onClick: props.handlePin ? function () { return setShowPinModal(true); } : undefined,
            },
            {
                title: props.isFavorite ? 'UnFavorite' : 'Favorite',
                icon: 'bookmark',
                onClick: props.handleFavorite,
            },
            {
                title: (_b = props.handleDuplicateTitle) !== null && _b !== void 0 ? _b : 'Duplicate',
                icon: 'copy',
                onClick: props.handleDuplicate,
            },
        ]).filter(function (button) { return !!button.onClick; });
    var maskStyle = showMask
        ? __assign(__assign({}, classes.mask), classes.showMask)
        : classes.mask;
    return (React.createElement("div", { style: classes.container, ref: ref },
        props.children,
        React.createElement(Box, { style: { zIndex: showMask ? 1 : undefined }, sx: maskStyle },
            props.handleDelete && (React.createElement(React.Fragment, null,
                React.createElement(MaterialButton, { onMouseEnter: function () { return setActiveButton('copy'); }, onMouseLeave: function () { return setActiveButton('send'); }, sx: __assign(__assign({}, classes.deleteButton), classes.topButton), onClick: function () { return setShowConfirmationModal(true); }, "aria-label": "Delete" },
                    React.createElement(Icon, { type: "delete", size: 15, color: "black" })))),
            props.topRightAction || null,
            !props.topRightAction && props.characters && (React.createElement(MaterialButton, { onMouseEnter: function () { return setActiveButton('copy'); }, onMouseLeave: function () { return setActiveButton('send'); }, sx: __assign(__assign({}, classes.codeButton), classes.topButton), onClick: function () { return __awaiter(void 0, void 0, void 0, function () {
                    var err_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4 /*yield*/, navigator.clipboard.writeText(JSON.stringify(props.characters))];
                            case 1:
                                _a.sent();
                                addToast("Copied message code to your clipboard.", {
                                    appearance: 'success',
                                    autoDismiss: true,
                                });
                                return [3 /*break*/, 3];
                            case 2:
                                err_1 = _a.sent();
                                addToast("Unable to copy message code to your clipboard.", {
                                    appearance: 'error',
                                    autoDismiss: true,
                                });
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); } },
                "Code ",
                React.createElement(Icon, { type: "code", margin: "0 0 0 6px", size: 18, color: "black" }))),
            React.createElement(Box, { sx: __assign(__assign({}, classes.sendButtonContainer), (activeButton !== 'send'
                    ? classes.sendButtonContainerBlur
                    : {})), onClick: function (e) {
                    e.stopPropagation();
                    setShowMask(false);
                } }, !!props.handleSend && (React.createElement(Button, { buttonType: "white", width: 112, onClick: props.handleSend, endIcon: React.createElement("img", { src: getIcon('send'), alt: "send" }) }, "Send"))),
            buttons.find(function (button) { return !!button.onClick; }) ? (React.createElement(Box, { sx: classes.bottomButtons }, buttons.map(function (button) { return (React.createElement(ButtonBase, { key: button.icon, sx: classes.bottomButton, onClick: button.onClick, onMouseEnter: function () { return setActiveButton(button.icon); }, onMouseLeave: function () { return setActiveButton('send'); } },
                button.title,
                React.createElement("div", { style: classes.buttonIcon },
                    React.createElement(Icon, { type: button.icon, color: button.icon === activeButton ? 'black' : 'white' })))); }))) : null),
        !showMask && !props.disabled && (React.createElement("button", { style: classes.showMaskButton, type: "button", onClick: function () {
                if (!props.disabled) {
                    setShowMask(true);
                }
            } })),
        props.handleDelete && showConfirmationModal && (React.createElement(DeleteConfirmationModal, { visible: showConfirmationModal, onClose: function () { return setShowConfirmationModal(false); }, onDelete: function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!props.handleDelete) return [3 /*break*/, 2];
                            return [4 /*yield*/, props.handleDelete()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            setShowConfirmationModal(false);
                            return [2 /*return*/];
                    }
                });
            }); } })),
        props.handlePin && showPinModal && (React.createElement(PinMessageModal, { visible: showPinModal, onClose: function () { return setShowPinModal(false); }, onSend: onPinClick, hourValue: props.hourValue || '0', onHourValueChange: props.onHourValueChange, minuteValue: props.minuteValue || '0', onMinuteValueChange: props.onMinuteValueChange, secondValue: props.secondValue || '0', onSecondValueChange: props.onSecondValueChange }))));
};
