var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { colors, fontFamily } from '../theme';
import MaterialButton from '@mui/material/Button';
import { Theme } from './Theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function () {
    var button = {
        paddingTop: '11px',
        paddingBottom: '11px',
        textTransform: 'none',
        fontSize: 16,
        fontFamily: fontFamily.default,
    };
    return {
        primary: __assign(__assign({}, button), { backgroundColor: colors.lightBlue, textTransform: 'none', '&:hover': {
                backgroundColor: colors.darkBlue,
            } }),
        danger: __assign(__assign({}, button), { textTransform: 'none', backgroundColor: colors.oldBrick, color: colors.white, '&:hover': {
                backgroundColor: colors.espresso,
            } }),
        white: __assign(__assign({}, button), { textTransform: 'none', backgroundColor: colors.white, color: colors.black, '&:hover': {
                backgroundColor: colors.white,
            } }),
        black: __assign(__assign({}, button), { textTransform: 'none', backgroundColor: colors.black, color: colors.white, '&:hover': {
                backgroundColor: colors.black,
            } }),
        outline: __assign(__assign({}, button), { textTransform: 'none', backgroundColor: 'transparent', borderColor: colors.white, borderWidth: 1, borderStyle: 'solid', color: colors.white, boxShadow: 'none', transition: 'filter 0.5s, background-color 0.5s, border-color 0.5s', '&:hover': {
                backgroundColor: colors.black,
                borderColor: colors.black,
                filter: 'invert(1)',
                boxShadow: 'none',
            } }),
        outlineBlack: __assign(__assign({}, button), { textTransform: 'none', backgroundColor: colors.white, borderColor: colors.black, borderWidth: 1, borderStyle: 'solid', color: colors.black, boxShadow: 'none', transition: 'filter 0.5s, background-color 0.5s, border-color 0.5s', '&:hover': {
                backgroundColor: colors.white,
                borderColor: colors.black,
                boxShadow: 'none',
            } }),
        ghost: __assign(__assign({}, button), { textTransform: 'none', backgroundColor: 'transparent', color: colors.white, boxShadow: 'none', '&:hover': {
                backgroundColor: 'transparent',
                boxShadow: 'none',
            } }),
        default: __assign(__assign({}, button), { textTransform: 'none', backgroundColor: colors.lightBlue, color: colors.white, borderColor: colors.nevada, borderWidth: 1, borderStyle: 'solid', '&:hover': {
                backgroundColor: colors.darkBlue,
            } }),
    };
});
export var Button = function (props) {
    var classes = useStyles();
    return (React.createElement(Theme, null,
        React.createElement(MaterialButton, { disabled: props.disabled, fullWidth: true, style: {
                width: props.width,
            }, type: props.type, variant: "contained", color: props.buttonType === 'primary' ? 'primary' : undefined, sx: props.buttonType === 'primary'
                ? classes.white
                : props.buttonType === 'danger'
                    ? classes.danger
                    : props.buttonType === 'white'
                        ? classes.white
                        : props.buttonType === 'outline'
                            ? classes.outline
                            : props.buttonType === 'outlineBlack'
                                ? classes.outlineBlack
                                : props.buttonType === 'ghost'
                                    ? classes.ghost
                                    : props.buttonType === 'black'
                                        ? classes.black
                                        : classes.white, onClick: props.onClick, size: "large", endIcon: props.endIcon }, props.children)));
};
