var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React from 'react';
import { Box, ButtonBase, Grid, Typography } from '@mui/material';
import { Field } from '../Field';
import { colors } from '../../theme';
import { DayOfWeek } from './types';
var DAYS = [
    DayOfWeek.Sunday,
    DayOfWeek.Monday,
    DayOfWeek.Tuesday,
    DayOfWeek.Wednesday,
    DayOfWeek.Thursday,
    DayOfWeek.Friday,
    DayOfWeek.Saturday,
];
export var WeekDaySelector = function (props) {
    var selection = props.value;
    return (React.createElement(Field, { label: "On", setLabel: function () { }, disabled: false },
        React.createElement(Grid, { container: true }, DAYS.map(function (day) {
            var selectedStyle = selection.includes(day)
                ? { background: '#cecece', color: colors.black }
                : {};
            return (React.createElement(Box, { style: {
                    paddingRight: 12,
                    paddingBottom: 7,
                } },
                React.createElement(ButtonBase, { key: day, sx: __assign({ width: 50, height: 50, maxWidth: 50, maxHeight: 50, color: colors.shuttleGray, background: colors.grey, borderRadius: '50%', '@media(max-width: 465px)': {
                            width: 40,
                            height: 40,
                        }, '@media(max-width: 425px)': {
                            width: 38,
                            height: 38,
                        }, '@media(max-width: 411px)': {
                            width: 36,
                            height: 36,
                        }, '@media(max-width: 397px)': {
                            width: 32,
                            height: 32,
                        }, '@media(max-width: 370px)': {
                            width: 28,
                            height: 28,
                        }, '@media(max-width: 351px)': {
                            width: 50,
                            height: 50,
                        } }, selectedStyle), onClick: function () {
                        props.onValueChange(selection.includes(day)
                            ? props.value.filter(function (d) { return d !== day; })
                            : __spreadArray(__spreadArray([], props.value, true), [day], false));
                    } },
                    React.createElement(Typography, null, day[0]))));
        }))));
};
