import Button from '@mui/material/Button';
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import React from 'react';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        paper: {
            backgroundColor: '#000',
        },
    },
});
export var Confirm = function (props) {
    var classes = useStyles();
    return (React.createElement(Dialog, { sx: classes.container, open: props.open, onClose: props.handleClose, "aria-labelledby": "alert-dialog-title", "aria-describedby": "alert-dialog-description" },
        React.createElement(DialogTitle, { id: "alert-dialog-title" }, props.title),
        React.createElement(DialogContent, null,
            props.children,
            !!props.message && (React.createElement(DialogContentText, { id: "alert-dialog-description" }, props.message))),
        React.createElement(DialogActions, null,
            React.createElement(Button, { onClick: props.handleClose, color: "secondary" }, props.declineTitle || 'No'),
            React.createElement(Button, { onClick: props.handleAccept, color: "primary", autoFocus: true }, props.acceptTitle || 'Yes'))));
};
