import * as React from 'react';
import { Box, Input } from '@mui/material';
import { colors } from '../theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        display: 'flex',
        flexWrap: 'wrap',
        alignItems: 'center',
    },
    field: {
        color: colors.alto,
        fontFamily: 'HelveticaNeue',
        fontSize: 16,
        fontWeight: 500,
    },
    input: {
        color: colors.alto,
        fontFamily: 'HelveticaNeue',
        fontSize: 16,
        fontWeight: 500,
        width: '100%',
    },
    inputWrapper: {
        marginLeft: 4,
    },
});
export var Field = function (props) {
    var classes = useStyles();
    return (React.createElement(Box, { sx: classes.container },
        React.createElement(Input, { readOnly: props.disabled, disableUnderline: true, multiline: false, margin: 'none', placeholder: props.label, value: props.label, sx: {
                '&.Mui-disabled': {
                    color: colors.alto,
                    textColor: colors.alto,
                },
                input: {
                    color: colors.alto,
                },
                color: colors.alto,
                fontFamily: 'HelveticaNeue',
                fontSize: 16,
                fontWeight: 500,
                width: '100%',
            }, onChange: function (e) { return props.setLabel(e.target.value); } }),
        props.children));
};
