import React from 'react';
import MuiButton from '@mui/material/Button';
import { colors } from '../theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function () { return ({
    button: {
        backgroundColor: colors.tundra,
        color: colors.white,
        marginRight: '3px',
        textTransform: 'none',
        padding: '7px 24px',
        borderRadius: 0,
        '&:first-child': {
            borderRadius: '7px 0px 0px 7px',
        },
        '&:last-child': {
            borderRadius: '0px 7px 7px 0px',
        },
        '&:hover': {
            backgroundColor: colors.tundra,
        },
    },
}); });
export var GroupedButton = function (props) {
    var classes = useStyles();
    return (React.createElement(MuiButton, { disabled: props.disabled, sx: classes.button, endIcon: props.endIcon, onClick: props.onClick }, props.children));
};
