var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import IconButton from '@mui/material/IconButton';
import { colors } from '../theme';
import { getIcon } from '../utils/getIcon';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
/*
The icons are hosted on hubspot at https://app.hubspot.com/files/1984131/?folderId=38284483101
Make all the icons black. If you need to support a new color, this tool is helpful: https://codepen.io/sosuke/pen/Pjoqqp
*/
var colorFilters = {
    black: 'invert(0%) sepia(6%) saturate(7476%) hue-rotate(328deg) brightness(94%) contrast(106%)',
    white: 'invert(100%) sepia(0%) saturate(7434%) hue-rotate(300deg) brightness(113%) contrast(103%)',
    shuttleGrey: 'invert(33%) sepia(10%) saturate(248%) hue-rotate(179deg) brightness(104%) contrast(85%)',
    default: 'invert(50%) sepia(0%) saturate(7434%) hue-rotate(300deg) brightness(113%) contrast(103%)',
    none: undefined,
};
export var icons = {
    edit: getIcon('icon-edit'),
    delete: getIcon('icon-delete'),
    schedule: getIcon('icon-schedule'),
    send: getIcon('icon-send'),
    arrow: getIcon('icon-arrow1'),
    auto: getIcon('icon-auto'),
    check: getIcon('icon-check'),
    close: getIcon('icon-close'),
    code: getIcon('icon-code'),
    copy: getIcon('icon-copy'),
    favorite: getIcon('icon-favorite'),
    leave: getIcon('icon-leave'),
    publish: getIcon('icon-publish'),
    settings: getIcon('icon-settings'),
    share: getIcon('icon-share'),
    text: getIcon('icon-text'),
    visual: getIcon('icon-visual'),
    bookmark: getIcon('icon-bookmark-off-1'),
    bookmark2: getIcon('icon-bookmark-on-1'),
    bookmarkoff: getIcon('bookmarkoff'),
    bookmarkon: getIcon('bookmarkon'),
    plus: getIcon('icon-plus-1'),
    pin: getIcon('icon-pin'),
    mute: getIcon('icon-mute'),
};
var useStyles = function (props) {
    return makeVestaboardStyles({
        icon: {
            color: colors.nevada,
            filter: colorFilters[props.color || 'default'],
            width: props.size || 20,
            margin: props.margin,
        },
    });
};
export var Icon = function (props) {
    var classes = useStyles(props)();
    var iconComponent = (React.createElement("img", { src: icons[props.type], style: __assign(__assign({}, classes.icon), (props.style || {})), alt: props.type }));
    return props.onClick ? (React.createElement(IconButton, { "aria-label": props.type }, iconComponent)) : (iconComponent);
};
