import React from 'react';
import { ReactEditor } from 'slate-react';
export declare const Portal: ({ children }: {
    children: any;
}) => React.ReactPortal | null;
export declare type CustomText = {
    bold?: boolean;
    italic?: boolean;
    code?: boolean;
    text: string;
};
export declare type IngredientElement = {
    type: 'ingredient';
    ingredientName: string;
    children: CustomText[];
};
export interface IIngredient {
    ingredientName: string;
    maxIngredientLength: number;
}
interface IIngredientTextEditor {
    ingredients: Array<IIngredient>;
    ingredientValues?: {
        [key: string]: string;
    };
    placeholder?: string;
    submit?: (value: string, length: number, raw: Array<any>) => void;
    submitTitle?: string;
    initialValue?: Array<any>;
    maxLength?: number;
    selectText?: string;
    editor: ReactEditor;
}
export declare const useIngredientEditor: (props: {
    ingredients: Array<IIngredient>;
    ingredientValues?: {
        [key: string]: string;
    } | undefined;
}) => {
    editor: any;
    getEditorState: () => {
        text: any;
        length: any;
        raw: any;
    };
};
export declare const IngredientTextEditor: (props: IIngredientTextEditor) => React.JSX.Element;
export {};
