var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useMemo, useCallback, useRef, useEffect, useState, } from 'react';
import ReactDOM from 'react-dom';
import { Editor, Transforms, Range, createEditor } from 'slate';
import { withHistory } from 'slate-history';
import { Slate, Editable, ReactEditor, withReact, useSelected, useFocused, } from 'slate-react';
import { Button } from '../Button';
import { colors, fontFamily, radius } from '../../theme';
import { Box } from '@mui/material';
import { Select } from '../Select';
import { Small } from '../Typography';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
export var Portal = function (_a) {
    var children = _a.children;
    return typeof document === 'object'
        ? ReactDOM.createPortal(children, document.body)
        : null;
};
var useStyles = makeVestaboardStyles({
    input: {
        color: colors['lightGrey'],
        fontSize: 16,
        colorScheme: 'dark',
        outline: 0,
        borderRadius: radius.small,
        backgroundColor: colors.woodSmoke,
        border: "1px solid ".concat(colors.alto),
        paddingLeft: 16,
        paddingRight: 16,
        fontFamily: fontFamily.default,
    },
});
var calculateStringValue = function (editor, ingredients, ingredientValues) {
    var _a = editor.children.reduce(function (acci, curi) {
        var _a = curi.children.reduce(function (accj, curj) {
            var _a;
            if (curj.type && curj.type === 'ingredient') {
                var variable = ingredientValues === null || ingredientValues === void 0 ? void 0 : ingredientValues[curj.ingredientName];
                var maxIngredientLength = (_a = ingredients.find(function (ingredient) { return ingredient.ingredientName === curj.ingredientName; })) === null || _a === void 0 ? void 0 : _a.maxIngredientLength;
                return variable
                    ? ["".concat(accj[0]).concat(variable), maxIngredientLength + accj[1]]
                    : [
                        "".concat(accj[0], "{{").concat(curj.ingredientName, "}}"),
                        maxIngredientLength + accj[1],
                    ];
            }
            return ["".concat(accj[0]).concat(curj.text), accj[1] + curj.text.length];
        }, ['', 0]), textj = _a[0], lengthj = _a[1];
        return ["".concat(acci[0], "\n").concat(textj), acci[1] + lengthj];
    }, ['', 0]), text = _a[0], length = _a[1];
    if (text.startsWith('\n')) {
        return [text.slice(1), length - 1];
    }
    return [text, length];
};
export var useIngredientEditor = function (props) {
    var editor = useMemo(function () { return withIngredients(withReact(withHistory(createEditor()))); }, []);
    var getEditorState = function () {
        var _a = calculateStringValue(editor, props.ingredients, props.ingredientValues), text = _a[0], length = _a[1];
        return {
            text: text,
            length: length,
            raw: editor.children,
        };
    };
    return { editor: editor, getEditorState: getEditorState };
};
export var IngredientTextEditor = function (props) {
    var _a, _b;
    var classes = useStyles();
    var ref = useRef();
    var _c = useState(), target = _c[0], setTarget = _c[1];
    var _d = useState(0), index = _d[0], setIndex = _d[1];
    var _e = useState(''), search = _e[0], setSearch = _e[1];
    var _f = useState(0), charCount = _f[0], setCharCount = _f[1];
    var renderElement = useCallback(function (props) { return React.createElement(Element, __assign({}, props)); }, []);
    var renderLeaf = useCallback(function (props) { return React.createElement(Leaf, __assign({}, props)); }, []);
    var editor = props.editor;
    var chars = props.ingredients
        .map(function (ingredient) { return ingredient.ingredientName; })
        .filter(function (c) { return c.toLowerCase().startsWith(search.toLowerCase()); })
        .slice(0, 10);
    useEffect(function () {
        if (target && chars.length > 0) {
            var el = ref.current;
            var domRange = ReactEditor.toDOMRange(editor, target);
            var rect = domRange.getBoundingClientRect();
            // @ts-ignore
            el.style.top = "".concat(rect.top + window.pageYOffset + 24, "px");
            // @ts-ignore
            el.style.left = "".concat(rect.left + window.pageXOffset, "px");
        }
    }, [chars.length, editor, index, search, target]);
    useEffect(function () {
        // keep text up to date
        var inerval = setInterval(function () {
            var _a = calculateStringValue(editor, props.ingredients, props.ingredientValues), length = _a[1];
            setCharCount(length);
        }, 500);
        return function () { return clearInterval(inerval); };
    }, []);
    return (React.createElement(React.Fragment, null,
        React.createElement(Slate, { editor: editor, initialValue: props.initialValue
                ? props.initialValue
                : [
                    {
                        // @ts-ignore
                        type: 'paragraph',
                        children: [
                            {
                                text: props.placeholder || '',
                            },
                        ],
                    },
                ], onChange: function () {
                var selection = editor.selection;
                if (selection && Range.isCollapsed(selection)) {
                    var start = Range.edges(selection)[0];
                    var wordBefore = Editor.before(editor, start, { unit: 'word' });
                    var before = wordBefore && Editor.before(editor, wordBefore);
                    var beforeRange = before && Editor.range(editor, before, start);
                    var beforeText = beforeRange && Editor.string(editor, beforeRange);
                    var beforeMatch = beforeText && beforeText.match(/^\{(\w+)$/);
                    var after = Editor.after(editor, start);
                    var afterRange = Editor.range(editor, start, after);
                    var afterText = Editor.string(editor, afterRange);
                    var afterMatch = afterText.match(/^(\s|$)/);
                    if (beforeMatch && afterMatch) {
                        setTarget(beforeRange);
                        setSearch(beforeMatch[1]);
                        setIndex(0);
                        return;
                    }
                }
                // @ts-ignore
                setTarget(null);
            } },
            React.createElement(Editable, { style: __assign({ height: 120 }, classes.input), renderElement: renderElement, renderLeaf: renderLeaf, onDOMBeforeInput: function (event) {
                    var _a;
                    var inputType = event.inputType;
                    var _b = calculateStringValue(editor, props.ingredients, props.ingredientValues), length = _b[1];
                    var textLength = length + (((_a = event === null || event === void 0 ? void 0 : event.data) === null || _a === void 0 ? void 0 : _a.length) || 0);
                    console.log(event.data, 'chars');
                    if (event.data === "{") {
                        event.preventDefault();
                        return;
                    }
                    if (inputType === 'insertText') {
                        if (textLength > 132) {
                            event.preventDefault();
                            return;
                        }
                    }
                    // possible to still go over, turn text red, disable submit
                    if (inputType === 'insertFromPaste') {
                        if (textLength > 132) {
                            event.preventDefault();
                            return;
                        }
                    }
                    setCharCount(textLength);
                    // // enter button
                    if (inputType === 'insertParagraph') {
                        chars.includes('Newline') && insertIngredient(editor, 'Newline');
                        event.preventDefault();
                        return;
                    }
                } })),
        React.createElement(Box, { style: {
                display: 'flex',
                justifyContent: 'flex-end',
                paddingBottom: 8,
                paddingTop: 8,
                width: '100%',
            } },
            React.createElement(Small, { color: charCount > (props.maxLength || 132)
                    ? colors.poppyRed
                    : colors.nevada },
                charCount,
                "/",
                props.maxLength || 132)),
        React.createElement(Box, { style: {
                display: 'flex',
                justifyContent: 'space-between',
                width: '100%',
            } },
            React.createElement(Box, null,
                React.createElement(Select, { value: props.selectText ? props.selectText : 'Select Ingredient', onValueChange: function (value) {
                        if (value === 'Select Ingredient' || value === props.selectText)
                            return;
                        var _a = calculateStringValue(editor, props.ingredients, props.ingredientValues), length = _a[1];
                        var ingredient = props.ingredients.find(function (ingredient) { return ingredient.ingredientName === value; });
                        if (length + (ingredient === null || ingredient === void 0 ? void 0 : ingredient.maxIngredientLength) > 132) {
                            return;
                        }
                        insertIngredient(editor, value);
                    }, options: __spreadArray([
                        {
                            name: (_a = props.selectText) !== null && _a !== void 0 ? _a : 'Select Ingredient',
                            id: (_b = props.selectText) !== null && _b !== void 0 ? _b : 'Select Ingredient',
                        }
                    ], props.ingredients.map(function (ingredient) { return ({
                        id: ingredient.ingredientName,
                        name: ingredient.ingredientName,
                    }); }), true) })),
            !!props.submit && (React.createElement(Button, { buttonType: 'white', width: 120, disabled: charCount > (props.maxLength || 132), onClick: function () { return __awaiter(void 0, void 0, void 0, function () {
                    var _a, value, length, _b;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                if (charCount > (props.maxLength || 132)) {
                                    return [2 /*return*/];
                                }
                                _a = calculateStringValue(editor, props.ingredients, props.ingredientValues), value = _a[0], length = _a[1];
                                _b = props.submit;
                                if (!_b) return [3 /*break*/, 2];
                                return [4 /*yield*/, props.submit(value, length, editor.children)];
                            case 1:
                                _b = (_c.sent());
                                _c.label = 2;
                            case 2:
                                _b;
                                return [2 /*return*/];
                        }
                    });
                }); } }, props.submitTitle ? props.submitTitle : 'Save')))));
};
// @ts-ignore
var withIngredients = function (editor) {
    var isInline = editor.isInline, isVoid = editor.isVoid, markableVoid = editor.markableVoid;
    // @ts-ignore
    editor.isInline = function (element) {
        return element.type === 'ingredient' ? true : isInline(element);
    };
    // @ts-ignore
    editor.isVoid = function (element) {
        return element.type === 'ingredient' ? true : isVoid(element);
    };
    // @ts-ignore
    editor.markableVoid = function (element) {
        return element.type === 'ingredient' || markableVoid(element);
    };
    return editor;
};
// @ts-ignore
var insertIngredient = function (editor, ingredientName) {
    var ingredient = {
        type: 'ingredient',
        ingredientName: ingredientName,
        children: [{ text: '' }],
    };
    Transforms.insertNodes(editor, { text: ' ' });
    Transforms.insertNodes(editor, ingredient);
    Transforms.move(editor);
};
// Borrow Leaf renderer from the Rich Text example.
// In a real project you would get this via `withRichText(editor)` or similar.
// @ts-ignore
var Leaf = function (_a) {
    var attributes = _a.attributes, children = _a.children, leaf = _a.leaf;
    if (leaf.bold) {
        children = React.createElement("strong", null, children);
    }
    if (leaf.code) {
        children = React.createElement("code", null, children);
    }
    if (leaf.italic) {
        children = React.createElement("em", null, children);
    }
    if (leaf.underline) {
        children = React.createElement("u", null, children);
    }
    return React.createElement("span", __assign({}, attributes), children);
};
// @ts-ignore
var Element = function (props) {
    var attributes = props.attributes, children = props.children, element = props.element;
    switch (element.type) {
        case 'ingredient':
            return React.createElement(Ingredient, __assign({}, props));
        default:
            return React.createElement("p", __assign({}, attributes), children);
    }
};
// @ts-ignore
var Ingredient = function (_a) {
    var attributes = _a.attributes, children = _a.children, element = _a.element;
    var selected = useSelected();
    var focused = useFocused();
    var style = {
        padding: '0px 3px 2px',
        margin: '0 1px',
        verticalAlign: 'baseline',
        display: 'inline-block',
        borderRadius: '4px',
        backgroundColor: colors.lightGrey,
        fontSize: 14,
        fontFamily: fontFamily.default,
        color: colors.woodSmoke,
        boxShadow: selected && focused ? '0 0 0 2px #B4D5FF' : 'none',
    };
    // See if our empty text child has any styling marks applied and apply those
    if (element.children[0].bold) {
        style.fontWeight = 'bold';
    }
    if (element.children[0].italic) {
        style.fontStyle = 'italic';
    }
    return (React.createElement("span", __assign({}, attributes, { contentEditable: false, "data-cy": "ingredient-".concat(element.ingredientName.replace(' ', '-')), style: style }), "{{".concat(element.ingredientName, "}}"),
        children));
};
