import { IColor } from '../theme';
import React, { FC } from 'react';
declare type IFontSizeName = 'small' | 'default';
interface IInput {
    value: string;
    onValueChange: (value: string) => void;
    label?: string;
    type?: 'password' | 'date' | 'time' | 'datetime-local' | 'number';
    multiline?: boolean;
    error?: string;
    disabled?: boolean;
    disableBorder?: boolean;
    textColor?: IColor;
    fontSize?: IFontSizeName;
    readOnly?: boolean;
    placeholder?: string;
    min?: string;
    max?: string;
    startAdornment?: React.ReactNode;
    startAdornmentWidth?: number;
}
export declare const Input: FC<IInput>;
export {};
