var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { Box, InputLabel } from '@mui/material';
import { colors, radius } from '../theme';
import React, { useRef, useState } from 'react';
import { Body } from './Typography';
import TextField from '@mui/material/TextField';
import { Theme } from './Theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = function (props) {
    return makeVestaboardStyles(function () { return ({
        container: {
            position: 'relative',
        },
        startAdornment: {
            position: 'absolute',
            top: '50%',
            left: '10px',
            transform: 'translateY(-50%)',
            zIndex: 1,
        },
        noBorder: {
            '& fieldset': {
                border: 'none !important',
            },
        },
        inputLabel: {
            color: colors.alto,
            fontFamily: 'HelveticaNeue',
            marginBottom: '10px',
            marginLeft: '4px',
        },
        datetimePlaceholderInput: {
            '& input': {
                textAlign: 'center',
                color: colors[props.textColor || 'alto'],
                fontSize: props.fontSize === 'small' ? 12 : 16,
            },
        },
        input: {
            colorScheme: 'dark',
            outline: 0,
            '& > div': {
                borderRadius: radius.small,
                backgroundColor: colors.woodSmoke,
            },
            '& label': {
                color: "".concat(colors.alto, " !important"),
            },
            '& fieldset': {
                borderColor: colors.alto,
            },
            '&:hover .MuiOutlinedInput-root .MuiOutlinedInput-notchedOutline': {
                borderColor: "".concat(colors.nevada, " !important"),
            },
            '&:focus .MuiOutlinedInput-root .MuiOutlinedInput-notchedOutline': {
                borderColor: "".concat(colors.alto, " !important"),
            },
            '& input': {
                color: colors[props.textColor || 'alto'],
                fontSize: props.fontSize === 'small' ? 12 : 16,
                '&:disabled': {
                    color: colors.nevada,
                    background: colors.mineShaft,
                    borderRadius: '14px',
                },
            },
            '&.Mui-focused fieldset': {
                border: '2px solid red',
            },
            '& textarea': {
                color: colors.white,
            },
        },
    }); });
};
export var Input = function (props) {
    var classes = useStyles({
        textColor: props.textColor,
        fontSize: props.fontSize,
    })();
    var _a = useState(props.value), value = _a[0], setValue = _a[1];
    var _b = useState(value), tempValue = _b[0], setTempValue = _b[1];
    var inputRef = useRef();
    var isDate = props.type === 'date' || props.type === 'datetime-local';
    var showDateTimePlaceholder = props.placeholder && isDate && !props.value;
    return (React.createElement(Theme, null,
        React.createElement(React.Fragment, null,
            props.label ? (React.createElement(InputLabel, { sx: classes.inputLabel, color: "primary", disableAnimation: true }, props.label)) : null,
            React.createElement(Box, { sx: classes.container },
                showDateTimePlaceholder ? (React.createElement(Box, { style: {
                        position: 'absolute',
                        top: 0,
                        left: 0,
                        width: 'calc(100% - 2px)',
                        height: 'calc(100% - 2px)',
                        zIndex: 1,
                        pointerEvents: 'none',
                        backgroundColor: colors.woodSmoke,
                        display: 'flex',
                        alignItems: 'center',
                        justifyContent: 'center',
                        borderRadius: radius.small,
                        borderWidth: 1,
                        borderStyle: 'solid',
                        borderColor: colors.alto,
                    } },
                    React.createElement(Body, null, props.placeholder))) : props.startAdornment ? (React.createElement(Box, { sx: classes.startAdornment }, props.startAdornment)) : null,
                React.createElement(TextField, { inputRef: inputRef, onClick: isDate
                        ? function () {
                            var _a;
                            // @ts-ignore
                            inputRef && ((_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.showPicker());
                        }
                        : undefined, inputProps: {
                        readOnly: props.readOnly,
                    }, error: !!props.error, helperText: props.error, sx: __assign(__assign(__assign({}, classes.input), (props.disableBorder ? classes.noBorder : {})), (props.startAdornment && !showDateTimePlaceholder
                        ? {
                            '& > div': {
                                paddingLeft: "".concat(props.startAdornmentWidth || 30, "px"),
                                borderRadius: radius.small,
                                backgroundColor: colors.woodSmoke,
                            },
                        }
                        : {})), fullWidth: true, disabled: props.disabled, variant: "outlined", value: props.value, onChange: function (e) {
                        if (props.readOnly) {
                            return;
                        }
                        if (isDate && e.target.value !== tempValue) {
                            setValue(e.target.value || '');
                            return;
                        }
                        props.onValueChange(e.target.value);
                    }, onFocus: function () { return setTempValue(props.value); }, onBlur: function () {
                        if (!isDate) {
                            return;
                        }
                        if (value === tempValue) {
                            props === null || props === void 0 ? void 0 : props.onValueChange(tempValue);
                            return;
                        }
                        else {
                            props === null || props === void 0 ? void 0 : props.onValueChange(value);
                        }
                    }, type: props.type, InputProps: {
                        inputProps: {
                            min: props.min,
                            max: props.max,
                        },
                    }, multiline: props.multiline, minRows: props.multiline ? 3 : undefined, placeholder: props.placeholder })))));
};
