var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React, { useCallback, useState } from 'react';
import { Toast, ToastProvider } from './Toast';
import { useShareMessage, useVestaboardSubscriptionConfigInformation, } from '../hooks';
import { BoardPreview } from './BoardPreview';
import { BoardPreviewMask } from './BoardPreviewMask';
import { LoadMask } from './LoadMask';
import { sendMessage } from '../api';
export var InstallableMessagePreview = function (_a) {
    var _b, _c, _d;
    var id = _a.id, boardStyle = _a.boardStyle, characters = _a.characters, isFavorite = _a.isFavorite, author = _a.author, created = _a.created, handleFavorite = _a.handleFavorite, handleDuplicate = _a.handleDuplicate, onMessageSendError = _a.onMessageSendError, onMessageSendSuccess = _a.onMessageSendSuccess;
    var _e = useState(false), loading = _e[0], setLoading = _e[1];
    var _f = useState(null), successMessage = _f[0], setSuccessMessage = _f[1];
    var _g = useState(null), errorMessage = _g[0], setErrorMessage = _g[1];
    var shareMessage = useShareMessage()[0];
    var config = useVestaboardSubscriptionConfigInformation();
    var apiKey = ((_b = config.data) === null || _b === void 0 ? void 0 : _b.subscription.installation.apiCredential.key) || '';
    var apiSecret = ((_c = config.data) === null || _c === void 0 ? void 0 : _c.subscription.installation.apiCredential.secret) || '';
    var subscriptionId = ((_d = config.data) === null || _d === void 0 ? void 0 : _d.subscription.id) || '';
    var handleSend = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    return [4 /*yield*/, sendMessage({
                            apiKey: apiKey,
                            apiSecret: apiSecret,
                            subscriptionId: subscriptionId,
                        })({
                            characters: characters,
                        })
                            .then(function () {
                            if (onMessageSendSuccess) {
                                onMessageSendSuccess();
                            }
                        })
                            .catch(function (error) {
                            if (onMessageSendError) {
                                onMessageSendError((error === null || error === void 0 ? void 0 : error.message) || (error === null || error === void 0 ? void 0 : error.title));
                            }
                        })];
                case 1:
                    _a.sent();
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); }, [characters, sendMessage]);
    var handleShare = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, error, result, err_1, link;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    setErrorMessage(null);
                    setSuccessMessage(null);
                    setLoading(true);
                    return [4 /*yield*/, shareMessage({
                            messageId: id,
                        })];
                case 1:
                    _a = _b.sent(), error = _a[0], result = _a[1];
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, navigator.clipboard.writeText(result.shareUrl || '')
                        // Fallback if the browser doesn't support clipboard interactions
                    ];
                case 3:
                    _b.sent();
                    return [3 /*break*/, 5];
                case 4:
                    err_1 = _b.sent();
                    setLoading(false);
                    link = document.createElement('a');
                    link.href = result.shareUrl || '';
                    link.target = '_blank';
                    link.click();
                    return [2 /*return*/];
                case 5:
                    setLoading(false);
                    if (error) {
                        setErrorMessage('There was an error generating your share URL');
                    }
                    else {
                        setSuccessMessage("Your share URL was copied to your clipboard");
                    }
                    return [2 /*return*/];
            }
        });
    }); }, [shareMessage, setErrorMessage, setSuccessMessage]);
    var toggleFavorite = useCallback(function () {
        handleFavorite === null || handleFavorite === void 0 ? void 0 : handleFavorite(isFavorite || false);
    }, [isFavorite]);
    return (React.createElement(ToastProvider, null,
        React.createElement(React.Fragment, null,
            React.createElement(BoardPreviewMask, { characters: characters, handleSend: handleSend, handleShare: handleShare, handleDuplicate: handleDuplicate, isFavorite: isFavorite, handleFavorite: handleFavorite ? toggleFavorite : undefined },
                React.createElement(BoardPreview, { characters: characters, isFavorite: isFavorite, boardStyle: boardStyle, handleFavorite: handleFavorite ? toggleFavorite : undefined }, [created || '', author || ''])),
            React.createElement(Toast, { severity: "success", message: successMessage, open: !!successMessage, onClose: function () { return setSuccessMessage(null); } }),
            React.createElement(Toast, { severity: "error", message: errorMessage, open: !!errorMessage, onClose: function () { return setErrorMessage(null); } }),
            loading ? React.createElement(LoadMask, null) : null)));
};
