var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useState } from 'react';
import { useAddFavorite, useListFavorites, useRemoveFavorite, useVestaboardSubscriptionConfigInformation, } from '../hooks';
import { FullModal } from './FullModal';
import { InstallableMessagePreview } from './InstallableMessagePreview';
import { NativeVisualEditorBridge } from './NativeVisualEditorBridge';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
import { sendMessage } from '../api';
import { useMediaQuery } from '@mui/material';
import { useToasts } from './Toast';
var useStyles = makeVestaboardStyles({
    boards: {
        marginTop: 42,
        width: '100%',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'space-between',
        flexWrap: 'wrap',
    },
    board: {
        position: 'relative',
        marginBottom: 24,
    },
});
export var InstallableMessagesList = function (_a) {
    var _b, _c, _d;
    var boardStyle = _a.boardStyle, messages = _a.messages;
    var classes = useStyles();
    var _e = useListFavorites(), favorites = _e.data, setFavorites = _e.setData;
    var _f = useState(null), setDuplicatingCharacters = _f[1];
    var addFavorite = useAddFavorite()[0];
    var removeFavorite = useRemoveFavorite()[0];
    var addToast = useToasts().addToast;
    var config = useVestaboardSubscriptionConfigInformation();
    var isMobile = useMediaQuery("@media(max-width: 750px)");
    var isTablet = useMediaQuery("@media(max-width: 1200px)");
    var isLaptop = useMediaQuery("@media(max-width: 2200px)");
    var apiKey = ((_b = config.data) === null || _b === void 0 ? void 0 : _b.subscription.installation.apiCredential.key) || '';
    var apiSecret = ((_c = config.data) === null || _c === void 0 ? void 0 : _c.subscription.installation.apiCredential.secret) || '';
    var subscriptionId = ((_d = config.data) === null || _d === void 0 ? void 0 : _d.subscription.id) || '';
    var handleFavorite = useCallback(function (messageId) { return __awaiter(void 0, void 0, void 0, function () {
        var favoriteIds, error_1, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    favoriteIds = favorites || [];
                    if (!favoriteIds.includes(messageId)) return [3 /*break*/, 2];
                    setFavorites(favoriteIds.filter(function (favoriteId) { return favoriteId !== messageId; }));
                    return [4 /*yield*/, removeFavorite({
                            messageId: messageId,
                        })];
                case 1:
                    error_1 = (_a.sent())[0];
                    if (error_1) {
                        setFavorites(favoriteIds);
                    }
                    return [2 /*return*/];
                case 2:
                    setFavorites(__spreadArray(__spreadArray([], favoriteIds, true), [messageId], false));
                    return [4 /*yield*/, addFavorite({
                            messageId: messageId,
                        })];
                case 3:
                    error = (_a.sent())[0];
                    if (error) {
                        setFavorites(favoriteIds);
                    }
                    return [2 /*return*/];
            }
        });
    }); }, [favorites]);
    return (React.createElement(NativeVisualEditorBridge, { boardStyle: boardStyle, renderWebVisualEditor: function (open, editor, setOpen) {
            return open ? (React.createElement(FullModal, { onClose: function () {
                    if (setOpen) {
                        setOpen(false);
                    }
                } }, editor)) : (React.createElement("div", null));
        }, onComplete: function (_id, _text, characters) { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!characters) return [3 /*break*/, 2];
                        return [4 /*yield*/, sendMessage({
                                apiKey: apiKey,
                                apiSecret: apiSecret,
                                subscriptionId: subscriptionId,
                            })({
                                characters: JSON.parse(characters),
                            })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        setDuplicatingCharacters(null);
                        return [2 /*return*/];
                }
            });
        }); } }, function (launch) { return (React.createElement(React.Fragment, null, messages && (React.createElement(React.Fragment, null,
        React.createElement("div", { style: classes.boards }, messages.map(function (message) {
            return (React.createElement("div", { style: __assign(__assign({}, classes.board), { width: isMobile
                        ? '100%'
                        : isTablet
                            ? '48%'
                            : isLaptop
                                ? '30%'
                                : '23%' }), key: message.id },
                React.createElement(InstallableMessagePreview, { boardStyle: boardStyle, id: message.id, characters: message.characters, author: message.author, created: message.created, isFavorite: favorites === null || favorites === void 0 ? void 0 : favorites.includes(message.id), handleFavorite: function () { return handleFavorite(message.id); }, onMessageSendError: function (errorMessage) {
                        addToast(errorMessage ||
                            'There was an error sending the message. Please try again.', {
                            appearance: 'error',
                        });
                    }, onMessageSendSuccess: function () {
                        addToast('Message sent to your Vestaboard', {
                            appearance: 'success',
                        });
                    }, handleDuplicate: function () {
                        var _a;
                        setDuplicatingCharacters(message.characters);
                        launch(JSON.stringify((_a = message.characters) !== null && _a !== void 0 ? _a : []), 'send');
                    } })));
        })))))); }));
};
