import MaterialLinearProgress from '@mui/material/LinearProgress';
import React from 'react';
import { Theme } from './Theme';
import { colors } from '../theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var limitProgress = function (progress) {
    if (!progress) {
        return;
    }
    if (progress > 100) {
        return 100;
    }
    if (progress < 0) {
        return 0;
    }
    return progress;
};
var useStyles = makeVestaboardStyles({
    colorPrimary: {
        backgroundColor: colors.grey,
        '.MuiLinearProgress-bar': {
            backgroundColor: colors.alto,
        },
    },
});
export var LinearProgress = function (props) {
    var progress = limitProgress(props.progress);
    var classes = useStyles();
    if (props.progress) {
        return (React.createElement(Theme, null,
            React.createElement("div", { style: { width: '100%' } },
                React.createElement(MaterialLinearProgress, { sx: classes.colorPrimary, color: "primary", variant: "determinate", value: progress }))));
    }
    return (React.createElement(Theme, null,
        React.createElement("div", { style: { width: '100%' } },
            React.createElement(MaterialLinearProgress, { sx: classes.colorPrimary, color: "primary" }))));
};
