import React, { useCallback } from 'react';
import { ButtonBase } from '@mui/material';
import discardBlack from '../../../assets/discardBlack.png';
import discardWhite from '../../../assets/discardWhite.png';
export var DeleteButton = function (_a) {
    var boardStyle = _a.boardStyle, onPress = _a.onPress, loading = _a.loading;
    var handlePressDelete = useCallback(function () {
        if (loading)
            return;
        if (onPress) {
            onPress();
        }
    }, [loading, onPress]);
    return (React.createElement(ButtonBase, { onClick: handlePressDelete, style: {
            width: 104,
            height: '100%',
            borderLeftWidth: 1,
            borderLeftColor: boardStyle === 'white' ? '#ffffff' : '#9999993d',
            borderRightWidth: 1,
            borderRightColor: boardStyle === 'white' ? '#17181866' : '#0a0a0b',
            borderStyle: 'solid',
        } },
        React.createElement("img", { style: {
                width: 17,
                height: 20,
            }, src: boardStyle === 'white' ? discardWhite : discardBlack })));
};
