import React, { useCallback } from 'react';
import { ButtonBase } from '@mui/material';
import duplicateBlack from '../../../assets/duplicateBlack.png';
import duplicateWhite from '../../../assets/duplicateWhite.png';
export var DuplicateButton = function (_a) {
    var boardStyle = _a.boardStyle, onPress = _a.onPress, loading = _a.loading;
    var handlePressDuplicate = useCallback(function () {
        if (loading)
            return;
        if (onPress) {
            onPress();
        }
    }, [loading, onPress]);
    return (React.createElement(ButtonBase, { onClick: handlePressDuplicate, style: {
            width: 104,
            height: '100%',
            borderLeftWidth: 1,
            borderLeftColor: boardStyle === 'white' ? '#ffffff' : '#9999993d',
            borderRightWidth: 1,
            borderRightColor: boardStyle === 'white' ? '#17181866' : '#0a0a0b',
            borderStyle: 'solid',
        } },
        React.createElement("img", { style: {
                width: 15,
                height: 15,
            }, src: boardStyle === 'white' ? duplicateWhite : duplicateBlack })));
};
