import React, { useCallback } from 'react';
import { ButtonBase } from '@mui/material';
import editIcon from '../../../assets/edit.svg';
import editIconWhite from '../../../assets/editWhite.svg';
export var EditButton = function (_a) {
    var boardStyle = _a.boardStyle, loading = _a.loading, onPress = _a.onPress;
    var handlePressEdit = useCallback(function () {
        if (loading)
            return;
        if (onPress) {
            onPress();
        }
    }, [loading, onPress]);
    return (React.createElement(ButtonBase, { onClick: handlePressEdit, style: {
            width: 104,
            height: '100%',
            borderLeftWidth: 1,
            borderLeftColor: boardStyle === 'white' ? '#ffffff' : '#9999993d',
            borderRightWidth: 1,
            borderRightColor: boardStyle === 'white' ? '#17181866' : '#0a0a0b',
            borderStyle: 'solid',
        } },
        React.createElement("img", { style: {
                width: 20,
                height: 20,
                opacity: boardStyle === 'white' ? 0.5 : 1,
            }, src: boardStyle === 'white' ? editIconWhite : editIcon })));
};
