import { ButtonBase, Typography } from '@mui/material';
import React, { memo, useCallback, useRef, useState, } from 'react';
import { makeVestaboardStyles } from '../../../hooks/useVestaboardStyles';
import { useOutsideClick } from '../../../hooks';
import dotsBlack from '../../../assets/dotsBlack.png';
import dotsBlackActive from '../../../assets/dotsBlackActive.png';
import dotsWhite from '../../../assets/dotsWhite.png';
import dotsWhiteActive from '../../../assets/dotsWhiteActive.png';
import duplicate from '../../../assets/duplicate.svg';
import deleteIcon from '../../../assets/delete.svg';
import pin from '../../../assets/pin.svg';
var useStyles = makeVestaboardStyles(function () { return ({
    container: {
        position: 'relative',
        height: '100%',
        borderLeftWidth: 1,
    },
    pressable: {
        height: '100%',
        width: 40,
    },
    button: {
        height: '100%',
        width: 40,
        alignItems: 'center',
        justifyContent: 'center',
    },
    moreItem: {
        display: 'flex',
        paddingRight: '24px !important',
        paddingLeft: '24px !important',
        height: 48,
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
        borderBottomColor: 'rgba(0,0,0,0.5)',
        borderBottomWidth: 1,
        borderBottomStyle: 'solid',
        width: 240,
        backdropFilter: 'blur(6px)',
    },
    moreItemSpace: {
        width: 12,
    },
}); });
export var MoreButton = memo(function (_a) {
    var more = _a.more, loading = _a.loading, boardStyle = _a.boardStyle;
    var onDuplicatePress = more.onDuplicatePress, onDeletePress = more.onDeletePress, onPinPress = more.onPinPress;
    var _b = useState(false), visible = _b[0], setVisible = _b[1];
    var styles = useStyles();
    var ref = useRef(null);
    useOutsideClick(ref, function () {
        setVisible(false);
    });
    var handleOpenMorePopover = useCallback(function () {
        if (loading)
            return;
        if (visible) {
            return;
        }
        setVisible(!visible);
    }, [loading, visible]);
    return (React.createElement("div", { style: {
            position: 'relative',
            height: 50,
            borderWidth: 0,
            borderLeftWidth: 1,
            borderLeftColor: boardStyle === 'white' ? '#ffffff' : '#9999993d',
            borderStyle: 'solid',
        } },
        React.createElement(ButtonBase, { disabled: !!visible, onClick: handleOpenMorePopover, sx: styles.pressable },
            React.createElement("div", { style: {
                    height: 50,
                    width: 40,
                    alignItems: 'center',
                    justifyContent: 'center',
                    display: 'flex',
                } },
                React.createElement("img", { src: visible && boardStyle === 'black'
                        ? dotsBlackActive
                        : !visible && boardStyle === 'black'
                            ? dotsBlack
                            : visible && boardStyle === 'white'
                                ? dotsWhiteActive
                                : dotsWhite, style: {
                        width: 3,
                        height: 19,
                    } }))),
        visible ? (React.createElement("div", { style: {
                position: 'absolute',
                bottom: 36,
                right: 8,
                borderRadius: 12,
                backgroundColor: 'rgba(60, 60, 60, 0.75)',
                overflow: 'hidden',
                width: 232,
            }, ref: ref },
            onDuplicatePress ? (React.createElement(ButtonBase, { onClick: onDuplicatePress, sx: styles.moreItem },
                React.createElement(Typography, { fontSize: "14px", color: "#FFF" }, "Duplicate"),
                React.createElement("img", { src: duplicate, style: {
                        width: 17,
                        height: 17,
                    } }))) : null,
            onDeletePress ? (React.createElement(ButtonBase, { onClick: onDeletePress, sx: styles.moreItem },
                React.createElement(Typography, { fontSize: "14px", color: "#FFF" }, "Delete"),
                React.createElement("img", { src: deleteIcon, style: {
                        width: 16,
                        height: 23,
                    } }))) : null,
            onPinPress ? (React.createElement(ButtonBase, { onClick: onPinPress, sx: styles.moreItem },
                React.createElement(Typography, { fontSize: "14px", color: "#FFF" }, "Pin"),
                React.createElement("img", { src: pin, style: {
                        width: 24,
                        height: 22,
                    } }))) : null)) : null));
});
MoreButton.displayName = 'MoreButton';
