import React, { useCallback, useRef } from 'react';
import { ButtonBase } from '@mui/material';
import { Player as LottieView } from '@lottiefiles/react-lottie-player';
import sendAnimation from './sendAnimation.json';
import sendAnimationWhite from './sendAnimationWhite.json';
export var SendButton = function (_a) {
    var boardStyle = _a.boardStyle, onPress = _a.onPress, loading = _a.loading, noBorders = _a.noBorders;
    var animation = useRef(null);
    var sendMessage = useCallback(function () {
        var _a;
        (_a = animation.current) === null || _a === void 0 ? void 0 : _a.play();
        onPress();
    }, [onPress]);
    var handleSendPress = useCallback(function () {
        if (loading)
            return;
        sendMessage();
    }, [loading, sendMessage]);
    return (React.createElement(ButtonBase, { onClick: handleSendPress, style: {
            width: 104,
            height: 48,
            borderLeftWidth: noBorders ? 0 : 1,
            borderLeftColor: boardStyle === 'white' ? '#ffffff' : '#9999993d',
            borderRightWidth: noBorders ? 0 : 1,
            borderRightColor: boardStyle === 'white' ? '#17181866' : '#0a0a0b',
            borderStyle: 'solid',
        } },
        React.createElement(LottieView, { ref: animation, style: {
                width: 120,
                height: 120,
            }, loop: false, src: boardStyle === 'white' ? sendAnimationWhite : sendAnimation })));
};
SendButton.displayName = 'SendButton';
