import React, { memo, useCallback } from 'react';
import { ButtonBase } from '@mui/material';
import shareBlack from '../../../assets/shareBlack.png';
import shareWhite from '../../../assets/shareWhite.png';
export var ShareButton = memo(function (_a) {
    var boardStyle = _a.boardStyle, onPress = _a.onPress, loading = _a.loading;
    var handlePress = useCallback(function () {
        if (loading)
            return;
        onPress();
    }, [loading, onPress]);
    return (React.createElement(ButtonBase, { style: {
            width: 104,
            height: '100%',
            borderLeftWidth: 1,
            borderLeftColor: boardStyle === 'white' ? '#ffffff' : '#9999993d',
            borderRightWidth: 1,
            borderRightColor: boardStyle === 'white' ? '#17181866' : '#0a0a0b',
            borderStyle: 'solid',
        }, onClick: handlePress },
        React.createElement("img", { style: {
                width: 23,
                height: 16,
            }, src: boardStyle === 'white' ? shareWhite : shareBlack })));
});
ShareButton.displayName = 'ShareButton';
