var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Box, ButtonBase, Typography } from '@mui/material';
import { MoreButton } from './MoreButton';
import { DeleteButton } from './DeleteButton';
import { Draggable } from './Draggable';
import { DuplicateButton } from './DuplicateButton';
import { EditButton } from './EditButton';
import { FavoriteButton } from './FavoriteButton';
import React from 'react';
import { SendButton } from './SendButton';
import { ShareButton } from './ShareButton';
import { colors } from '../../theme';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function (props) {
    var _a, _b;
    return ({
        board: {
            position: 'relative',
            width: 352,
            height: 216,
            display: 'flex',
            borderRadius: '6px',
            borderLeft: "1px solid ".concat(colors.black),
            borderRight: "1px solid ".concat(colors.darkBlack),
            borderBottom: "1px solid ".concat(colors.darkBlack),
            borderTop: "1px solid ".concat(colors.black),
            flexDirection: 'column',
            backgroundColor: props.boardStyle === 'black' ? "transparent" : colors.white,
            background: props.boardStyle === 'black'
                ? "radial-gradient(ellipse at bottom,\n      #202325, ".concat(colors.darkBlack, ")\n    ")
                : "radial-gradient(ellipse at bottom,\n          ".concat(colors.white, ", ").concat(colors.alto, ")"),
            boxShadow: '0px 60px 85px -22px rgba(0,0,0,0.83)',
        },
        content: {
            borderBottom: "1px solid ".concat(colors.darkBlack),
        },
        svg: { fill: 'transparent', background: 'transparent' },
        icon: {
            color: props.boardStyle === 'black' ? colors.grey : colors.woodSmoke,
            height: '100%',
            minHeight: 15,
        },
        iconButton: {
            flex: 5,
            borderRight: "1px solid ".concat(colors.darkBlack),
            height: '100%',
            color: props.boardStyle === 'black' ? colors.grey : colors.woodSmoke,
            borderLeft: "1px solid ".concat(colors.grey),
        },
        firstIconButton: {
            flex: 5,
            borderRight: "1px solid ".concat(colors.darkBlack),
            height: '100%',
            color: props.boardStyle === 'black' ? colors.grey : colors.woodSmoke,
        },
        likesCount: {
            marginLeft: '6px',
        },
        moreActions: {
            color: props.boardStyle === 'black' ? colors.shuttleGray : colors.woodSmoke,
        },
        moreButton: {
            flex: 1,
            height: '100%',
            color: props.boardStyle === 'black' ? colors.grey : colors.woodSmoke,
            borderLeft: "1px solid ".concat(colors.grey),
        },
        actionContainer: {
            display: 'flex',
            flexDirection: 'row',
            justifyContent: 'flex-start',
            alignItems: 'center',
            height: 48,
            borderTop: props.boardStyle == 'white'
                ? "0.5px solid #17181866"
                : "1px solid ".concat(colors.grey),
            boxShadow: props.boardStyle === 'black'
                ? '0px 0px 10px 0px rgba(0,0,0,0.75)'
                : undefined,
            borderBottomLeftRadius: 6,
            borderBottomRightRadius: 6,
        },
        headerContainer: {
            display: 'flex',
            flexDirection: 'row',
            justifyContent: 'space-between',
            paddingLeft: '24px',
            paddingRight: '16px',
        },
        metaDataBox: {
            display: 'flex',
            flexDirection: 'row',
            alignItems: 'flex-start',
            paddingTop: '12px',
            textAlign: 'left',
            width: '100%',
            maxWidth: 300,
        },
        sentAt: (_a = {
                paddingLeft: '8px',
                textAlign: 'left',
                whiteSpace: 'nowrap',
                height: 20
            },
            _a["@media(max-width: 467px)"] = {
                marginLeft: '4px',
            },
            _a),
        source: (_b = {
                textAlign: 'left',
                overflow: 'hidden',
                whiteSpace: 'nowrap',
                textOverflow: 'ellipsis',
                height: 20
            },
            _b["@media(max-width: 550px)"] = {
                marginLeft: '0px',
            },
            _b["@media(max-width: 467px)"] = {
                marginLeft: '-2px',
            },
            _b),
    });
});
var characterCodesMap = function (boardStyle) { return ({
    0: ' ',
    1: 'A',
    2: 'B',
    3: 'C',
    4: 'D',
    5: 'E',
    6: 'F',
    7: 'G',
    8: 'H',
    9: 'I',
    10: 'J',
    11: 'K',
    12: 'L',
    13: 'M',
    14: 'N',
    15: 'O',
    16: 'P',
    17: 'Q',
    18: 'R',
    19: 'S',
    20: 'T',
    21: 'U',
    22: 'V',
    23: 'W',
    24: 'X',
    25: 'Y',
    26: 'Z',
    27: '1',
    28: '2',
    29: '3',
    30: '4',
    31: '5',
    32: '6',
    33: '7',
    34: '8',
    35: '9',
    36: '0',
    37: '!',
    38: '@',
    39: '#',
    40: '$',
    41: '(',
    42: ')',
    44: '-',
    46: '+',
    47: '&',
    48: '=',
    49: ';',
    50: ':',
    52: "'",
    53: '"',
    54: '%',
    55: ',',
    56: '.',
    59: '/',
    60: '?',
    62: '°',
    63: '🟥',
    64: '🟧',
    65: '🟨',
    66: '🟩',
    67: '🟦',
    68: '🟪',
    69: '⬜',
    70: '⬛',
    71: boardStyle === 'black' ? '⬜' : '⬛',
}); };
export var MessageCard = function (props) {
    var _a;
    var classes = useStyles(props);
    var text = (_a = props.characters) === null || _a === void 0 ? void 0 : _a.map(function (row) {
        return row
            .map(function (bit) { var _a; return ((_a = characterCodesMap(props.boardStyle || 'black')) === null || _a === void 0 ? void 0 : _a[bit]) || ' '; })
            .join('');
    }).map(function (row, i) { return (React.createElement("span", { key: i, style: {
            whiteSpace: 'pre',
        } },
        row,
        React.createElement("br", null))); });
    return (React.createElement("div", { "aria-label": "Vestaboard Message: ".concat(props.ariaMessageText), id: 'vestaboard-message' },
        React.createElement(Box, { sx: classes.board },
            React.createElement(Box, { sx: classes.content },
                React.createElement(Box, { sx: classes.headerContainer },
                    React.createElement(Box, { sx: classes.metaDataBox },
                        React.createElement(ButtonBase, { onClick: function () { return __awaiter(void 0, void 0, void 0, function () {
                                var _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            _a = props.onSourcePress;
                                            if (!_a) return [3 /*break*/, 2];
                                            return [4 /*yield*/, props.onSourcePress({
                                                    messageId: props.messageId,
                                                    messageAppearanceId: props === null || props === void 0 ? void 0 : props.messageAppearanceId,
                                                    sourceId: props.sourceId,
                                                })];
                                        case 1:
                                            _a = (_b.sent());
                                            _b.label = 2;
                                        case 2: return [2 /*return*/, _a];
                                    }
                                });
                            }); } },
                            React.createElement(Box, { sx: classes.source },
                                React.createElement(Typography, { fontSize: 12, color: props.boardStyle === 'black'
                                        ? colors.white
                                        : colors.woodSmoke }, props.source))),
                        React.createElement(Box, { sx: classes.sentAt },
                            React.createElement(Typography, { fontSize: 12, color: "#7d868c" }, props.sentAt))),
                    props.draggable ? (React.createElement(Draggable, { boardStyle: props.boardStyle })) : props.onFavoritePress ? (React.createElement(FavoriteButton, { isFavorite: !!props.isFavorite, onPress: function () { return __awaiter(void 0, void 0, void 0, function () {
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _a = props.onFavoritePress;
                                        if (!_a) return [3 /*break*/, 2];
                                        return [4 /*yield*/, props.onFavoritePress({
                                                messageId: props.messageId,
                                                messageAppearanceId: props === null || props === void 0 ? void 0 : props.messageAppearanceId,
                                                sourceId: props.sourceId,
                                            })];
                                    case 1:
                                        _a = (_b.sent());
                                        _b.label = 2;
                                    case 2: return [2 /*return*/, _a];
                                }
                            });
                        }); } })) : null),
                React.createElement(Box, { style: {
                        display: 'flex',
                        justifyContent: 'center',
                        height: 134,
                    } },
                    React.createElement(Box, { style: {
                            width: 248,
                            paddingTop: 16,
                            marginLeft: 2,
                        } },
                        React.createElement(Typography, { style: {
                                fontFamily: 'VestaEmojis',
                                fontSize: '12px',
                                letterSpacing: 3.8,
                                lineHeight: '15.9px',
                                color: props.boardStyle === 'black' ? colors.white : colors.black,
                            } }, text)))),
            React.createElement(Box, { id: 'vestaboard-actions', sx: classes.actionContainer, style: {
                    justifyContent: props.singleButton ? 'center' : 'flex-start',
                } },
                props.onEditPress ? (React.createElement(EditButton, { onPress: props.onEditPress, boardStyle: props.boardStyle })) : null,
                props.onSharePress ? (React.createElement(ShareButton, { onPress: props.onSharePress, boardStyle: props.boardStyle })) : null,
                props.onSendPress ? (React.createElement(SendButton, { onPress: props.onSendPress, boardStyle: props.boardStyle, noBorders: props.singleButton })) : null,
                props.onDuplicatePress ? (React.createElement(DuplicateButton, { onPress: props.onDuplicatePress, boardStyle: props.boardStyle })) : null,
                props.onDeletePress ? (React.createElement(DeleteButton, { onPress: props.onDeletePress, boardStyle: props.boardStyle })) : null,
                props.more ? (React.createElement(MoreButton, { boardStyle: props.boardStyle || 'black', more: props.more })) : null))));
};
