var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { Box, ButtonBase, Typography } from '@mui/material';
import React, { useLayoutEffect, useRef, useState } from 'react';
import { colors } from '../theme';
import { GroupedButton } from './GroupedButton';
import { Button } from './Button';
import { BoardPreview } from './BoardPreview';
import { Padding } from './Padding';
import MaterialCheckbox from '@mui/material/Checkbox';
import { Body } from './Typography';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        position: 'fixed',
        bottom: 0,
        background: colors.grey,
        height: '100%',
        width: '100%',
        zIndex: 1001,
        left: 0,
        transition: 'bottom 0.3s',
        display: 'flex',
        flexDirection: 'column',
    },
    cover: {
        top: 0,
        left: 0,
        zIndex: 999,
        width: '100%',
        height: '100%',
        position: 'fixed',
        backgroundImage: 'linear-gradient(to bottom, rgba(23, 24, 24, 0.59), rgba(23, 24, 24, 0.59))',
        backdropFilter: 'blur(2px)',
    },
    header: {
        display: 'flex',
        justifyContent: 'space-between',
    },
    buttons: {
        display: 'flex',
        justifyContent: 'center',
        padding: '20px',
    },
    messagesContainer: {
        background: '#252729',
        flex: 1,
        overflow: 'auto',
    },
    buttonSpace: {
        width: 20,
    },
    title: {
        padding: '20px',
        borderBottom: 'solid 1px #FFF',
    },
    titleText: {
        color: colors.white,
        fontSize: 18,
    },
    actionButtons: {
        padding: '20px',
    },
    messages: {
        display: 'flex',
        width: '100%',
        flexWrap: 'wrap',
        gap: '20px',
        rowGap: '20px',
    },
    message: {
        width: '32%',
        position: 'relative',
        '@media(max-width: 1100px)': {
            width: '48%',
        },
        '@media(max-width: 700px)': {
            width: '100%',
        },
    },
    checkboxWrapper: {
        position: 'absolute',
        top: 0,
        right: 0,
    },
    checkbox: {
        color: colors.white,
        width: 30,
        height: 30,
    },
});
export var MessagePicker = function (props) {
    var _a;
    var classes = useStyles();
    var ref = useRef();
    var _b = useState(0), bottom = _b[0], setBottom = _b[1];
    var _c = useState(props.visible), initialized = _c[0], setInitialized = _c[1];
    var visible = props.visible;
    useLayoutEffect(function () {
        var _a;
        setBottom(visible ? 0 : -(((_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.offsetHeight) || 0));
        if (visible) {
            setInitialized(true);
        }
    }, [visible]);
    return (React.createElement(React.Fragment, null,
        React.createElement(ButtonBase, { onClick: props.onCancel },
            React.createElement("div", { style: __assign({ display: props.visible ? 'block' : 'none' }, classes.cover) })),
        React.createElement("div", { ref: ref, style: __assign({ opacity: initialized ? 1 : 0, bottom: bottom }, classes.container) },
            React.createElement(Box, { sx: classes.header },
                React.createElement(Box, { sx: classes.title },
                    React.createElement(Typography, { sx: classes.titleText }, props.title)),
                React.createElement(Box, { sx: classes.actionButtons },
                    React.createElement(GroupedButton, { onClick: function () {
                            props.setSelected(props.messages.map(function (message) { return message.id; }));
                        } }, "Select All"),
                    React.createElement(GroupedButton, { onClick: function () {
                            props.setSelected([]);
                        } }, "Clear"))),
            React.createElement(Box, { sx: classes.messagesContainer },
                React.createElement(Padding, null, !((_a = props.messages) === null || _a === void 0 ? void 0 : _a.length) ? (React.createElement(Body, null, props.noMessages)) : (React.createElement(Box, { sx: classes.messages }, props.messages.map(function (message) { return (React.createElement(Box, { key: message.id, sx: classes.message },
                    React.createElement(BoardPreview, { characters: message.characters }),
                    React.createElement(Box, { sx: classes.checkboxWrapper },
                        React.createElement(MaterialCheckbox, { checked: props.selected.includes(message.id), sx: classes.checkbox, color: "default", onChange: function () {
                                if (props.selected.includes(message.id)) {
                                    props.setSelected(props.selected.filter(function (item) { return item != message.id; }));
                                }
                                else {
                                    props.setSelected(__spreadArray(__spreadArray([], props.selected, true), [message.id], false));
                                }
                            } })))); }))))),
            React.createElement(Box, { sx: classes.buttons },
                React.createElement(Button, { buttonType: "outline", onClick: props.onCancel, width: 200 }, "Cancel"),
                React.createElement(Box, { sx: classes.buttonSpace }),
                React.createElement(Button, { buttonType: "white", onClick: props.onComplete, width: 200 }, "Add")))));
};
