import { Time } from '../utils/time';
import React from 'react';
interface iPublicTimeSelect {
    label: string;
    setLabel?: (value: string) => void;
    disableLabelEdit?: boolean;
    onChange: (time: Time) => void;
    condenseOnMobile?: boolean;
    value?: Time;
}
export declare const useTimeSelect: (initial?: Time) => {
    value: Time;
    setValue: React.Dispatch<React.SetStateAction<Time>>;
};
export declare const PublicTimeSelect: (props: iPublicTimeSelect) => React.JSX.Element;
interface IControlledTimeSelectProps {
    value?: Time;
    onChange: (v: Time) => any;
}
declare type ControlledTimeSelectProps = IControlledTimeSelectProps & iPublicTimeSelect;
export declare const ControlledTimeSelect: (props: ControlledTimeSelectProps) => React.JSX.Element;
interface iTimeSelect {
    value: Time;
    setValue: (time: Time) => void;
    label: string;
    setLabel?: (value: string) => void;
    disableLabel: boolean;
    condenseOnMobile?: boolean;
    children?: React.ReactChild;
    hasButtons?: boolean;
    isTwentyFourHourTime?: boolean;
}
export declare const TimeSelect: (props: iTimeSelect) => React.JSX.Element;
interface iMultiTimeSelect {
    onChange: (times: Times[]) => void;
    maxTimes: number;
    value: Times[];
    isTwentyFourHourTime?: boolean;
}
export interface Times {
    time: Time;
    label: string;
    index: number;
}
export declare const EMPTY_DEFAULT_TIMES: Times[];
export declare const MultiTimeSelect: (props: iMultiTimeSelect) => React.JSX.Element;
export {};
