var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var _a, _b;
import { Box, MenuItem, Select as MuiSelect, Typography } from '@mui/material';
import { HOURS, HOURS_MILITARY, MINUTES } from '../utils/time';
import React from 'react';
import { colors, responsive } from '../theme';
import { AddRemoveButton } from './AddRemoveButton';
import { Field } from './Field';
import { BoxSpacer as Spacer } from './BoxSpacer';
import { ToggleButton } from './ToggleButton';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    timeSelectContainer: {
        display: 'flex',
        flexDirection: 'row',
        marginBottom: '3px',
        width: '100%',
        maxHeight: '100px',
        position: 'relative',
    },
    addRemoveButtons: (_a = {
            marginLeft: '12px',
            display: 'flex'
        },
        _a["@media(max-width: ".concat(responsive.SMALL_MOBILE, "px)")] = {
            flexDirection: 'column',
        },
        _a),
    select: {
        borderColor: colors.alto,
        border: '1px',
        backgroundColor: colors.woodSmoke,
        color: colors.alto,
    },
    container: {
        borderColor: 'white',
        color: 'white',
    },
    icon: {
        fill: colors.alto,
    },
    outlined: {
        borderColor: colors.alto,
        color: colors.alto,
    },
    input: {
        borderColor: colors.alto,
        color: colors.alto,
        border: '1px white',
    },
    timePicker: {
        borderColor: 'white',
        marginBottom: '8px',
    },
    timePickerInner: (_b = {
            display: 'flex'
        },
        _b["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            height: 60,
        },
        _b),
    colon: {
        fontSize: 24,
        fontWeight: 500,
        paddingLeft: '8px',
        paddingRight: '8px',
        paddingTop: '8px',
        color: colors.alto,
    },
    menuItem: {
        backgroundColor: colors.woodSmoke,
        borderColor: colors.alto,
        color: colors.alto,
        '& hover .MuiMenuItem-root': {
            color: colors.woodSmoke,
            backgroundColor: colors.alto,
        },
    },
});
var useMenuStyles = makeVestaboardStyles({
    paper: {
        backgroundColor: colors.woodSmoke,
        borderColor: colors.alto,
        color: colors.alto,
    },
    list: {
        backgroundColor: colors.woodSmoke,
        borderColor: colors.alto,
        color: colors.alto,
    },
});
var Select = function (props) {
    var menuClasses = useMenuStyles();
    return (React.createElement(MuiSelect, { MenuProps: {
            PaperProps: {
                sx: __assign({}, menuClasses.paper),
            },
            MenuListProps: {
                variant: 'menu',
                sx: __assign({}, menuClasses.list),
            },
        }, sx: {
            borderColor: colors.alto,
            color: colors.alto,
            backgroundColor: colors.woodSmoke,
            '& .MuiSvgIcon-root': {
                color: colors.alto,
            },
            '.MuiOutlinedInput-notchedOutline': {
                borderColor: colors.alto,
            },
            '&.Mui-focused .MuiOutlinedInput-notchedOutline': {
                borderColor: colors.alto,
            },
            '&:hover .MuiOutlinedInput-notchedOutline': {
                borderColor: colors.nevada,
            },
        }, variant: "outlined", value: props.value, onChange: function (e) { return props.onValueChange(e.target.value); }, fullWidth: props.fullWidth, disabled: props.disabled, style: {
            width: props.fullWidth ? '100%' : undefined,
        } },
        !props.required && React.createElement(MenuItem, { value: "" }, "--"),
        props.options.map(function (option) { return (React.createElement(MenuItem, { style: {
                backgroundColor: colors.woodSmoke,
                color: colors.alto,
            }, value: option.key, key: option.key }, option.value)); })));
};
export var useTimeSelect = function (initial) {
    var _a = React.useState(initial !== null && initial !== void 0 ? initial : {
        hour: '12',
        minutes: '00',
        amPm: 'AM',
    }), value = _a[0], setValue = _a[1];
    return {
        value: value,
        setValue: setValue,
    };
};
export var PublicTimeSelect = function (props) {
    var _a = useTimeSelect(props.value), value = _a.value, setValue = _a.setValue;
    var handleLabelChange = function (value) {
        if (props.disableLabelEdit)
            return;
        if (props.setLabel) {
            return props.setLabel(value);
        }
    };
    return (React.createElement(TimeSelect, { value: value, condenseOnMobile: props.condenseOnMobile, setValue: setValue, label: props.label, disableLabel: props.disableLabelEdit || false, setLabel: handleLabelChange }));
};
export var ControlledTimeSelect = function (props) {
    var _a;
    var handleLabelChange = function (value) {
        if (props.disableLabelEdit)
            return;
        if (props.setLabel) {
            return props.setLabel(value);
        }
    };
    return (React.createElement(TimeSelect, { value: (_a = props.value) !== null && _a !== void 0 ? _a : {
            hour: '12',
            minutes: '00',
            amPm: 'AM',
        }, condenseOnMobile: props.condenseOnMobile, setValue: props.onChange, label: props.label, disableLabel: props.disableLabelEdit || false, setLabel: handleLabelChange }));
};
var getTwentyFourHourTime = function (hour, amPm) {
    if (amPm === 'PM') {
        return (parseInt(hour, 10) + 12).toString().padStart(2, '0');
    }
    return hour;
};
var convertToTwelveHourTime = function (hour) {
    if (parseInt(hour, 10) > 12) {
        return (parseInt(hour, 10) - 12).toString().padStart(2, '0');
    }
    return hour;
};
var getTwentyFourHourAmPm = function (hour) {
    if (parseInt(hour, 10) >= 12) {
        return 'PM';
    }
    return 'AM';
};
export var TimeSelect = function (props) {
    var classes = useStyles();
    var setValue = props.setValue, label = props.label, value = props.value;
    var hourStandard = value.hour, minutes = value.minutes, amPm = value.amPm;
    var hour = props.isTwentyFourHourTime
        ? getTwentyFourHourTime(hourStandard, amPm)
        : hourStandard;
    return (React.createElement(Box, { style: {
            width: !props.hasButtons ? 293 : undefined,
        }, sx: {
            display: 'flex',
            flexDirection: 'row',
            marginBottom: 3,
            width: '100%',
            maxHeight: '100px',
            position: 'relative',
        } },
        React.createElement(Field, { disabled: props.disableLabel, label: label, setLabel: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                if (props.setLabel) {
                    props.setLabel.apply(props, args);
                }
            } },
            React.createElement(React.Fragment, null,
                React.createElement(Box, { sx: classes.timePickerInner },
                    React.createElement(Select, { required: true, value: hour, onValueChange: function (hour) {
                            var time = __assign(__assign({}, value), { hour: convertToTwelveHourTime(hour), amPm: props.isTwentyFourHourTime
                                    ? getTwentyFourHourAmPm(hour)
                                    : amPm });
                            setValue(time);
                        }, options: (props.isTwentyFourHourTime
                            ? HOURS_MILITARY
                            : HOURS).map(function (key) { return ({
                            key: key,
                            value: key,
                        }); }) }),
                    React.createElement(Typography, { sx: classes.colon }, " : "),
                    React.createElement(Select, { required: true, value: minutes, onValueChange: function (minutes) {
                            setValue(__assign(__assign({}, value), { minutes: minutes }));
                        }, options: MINUTES.map(function (key) { return ({
                            key: key,
                            value: key,
                        }); }) }),
                    props.isTwentyFourHourTime ? null : (React.createElement(React.Fragment, null,
                        React.createElement(Spacer, { width: 12 }),
                        React.createElement(ToggleButton, { condenseOnMobile: props.condenseOnMobile, options: [
                                {
                                    key: 'AM',
                                    value: 'AM',
                                },
                                {
                                    key: 'PM',
                                    value: 'PM',
                                },
                            ], value: amPm, onToggle: function (amPm) { return setValue(__assign(__assign({}, value), { amPm: amPm })); } })))),
                props.children))));
};
export var EMPTY_DEFAULT_TIMES = [
    {
        time: {
            hour: '12',
            minutes: '00',
            amPm: 'AM',
        },
        label: 'Time',
        index: 0,
    },
];
export var MultiTimeSelect = function (props) {
    var classes = useStyles();
    var times = props.value;
    var isFull = (times === null || times === void 0 ? void 0 : times.length) === props.maxTimes;
    React.useEffect(function () {
        props.onChange(times);
    }, [times]);
    React.useEffect(function () {
        if (!times.length) {
            handlePlusPressed();
        }
    }, [times]);
    var handlePickerChange = function (index, label, timeData) {
        var filteredTimes = times.filter(function (time) { return time.index !== index; });
        filteredTimes.push({ time: timeData, label: label, index: index });
        var newTimes = filteredTimes.sort(function (a, b) { return a.index - b.index; });
        props.onChange(newTimes);
    };
    var handlePlusPressed = function () {
        var next = times.length; // length disregards first index
        var newTimes = __spreadArray(__spreadArray([], times, true), [__assign(__assign({}, EMPTY_DEFAULT_TIMES[0]), { index: next })], false);
        props.onChange(newTimes);
    };
    var handleRemovePressed = function (index) {
        var newTimes = times
            .filter(function (time) { return time.index !== index; })
            .map(function (time, i) { return (__assign(__assign({}, time), { index: i })); })
            .sort(function (a, b) { return a.index - b.index; });
        props.onChange(newTimes);
    };
    var setNewLabel = function (index, labelValue) {
        var newTimes = times.map(function (time) {
            if (time.index === index) {
                return __assign(__assign({}, time), { label: labelValue });
            }
            return time;
        });
        props.onChange(newTimes);
    };
    return (React.createElement(Box, { style: { flex: 1, display: 'flex', maxWidth: '100%' }, flexDirection: "column" }, times.map(function (time) {
        var label = time.label, index = time.index, timeData = time.time;
        var isLast = index === times.length - 1;
        var isFirst = index === 0;
        return (React.createElement(Box, { sx: classes.timeSelectContainer, key: index },
            React.createElement(TimeSelect, { isTwentyFourHourTime: props.isTwentyFourHourTime, condenseOnMobile: true, disableLabel: false, key: index, setLabel: function (labelValue) { return setNewLabel(index, labelValue); }, label: label, value: timeData, setValue: function (timeData) {
                    return handlePickerChange(index, label, timeData);
                }, hasButtons: true },
                React.createElement("div", { style: classes.addRemoveButtons },
                    isLast && !isFirst && !isFull && (React.createElement(React.Fragment, null,
                        React.createElement(AddRemoveButton, { isGrouped: true, add: false, onPress: function () { return handleRemovePressed(index); } }),
                        React.createElement(AddRemoveButton, { isGrouped: true, add: true, onPress: handlePlusPressed }))),
                    isLast && isFirst && !isFull && (React.createElement(AddRemoveButton, { add: true, onPress: handlePlusPressed })),
                    !isLast && (React.createElement(AddRemoveButton, { add: false, onPress: function () { return handleRemovePressed(index); } })),
                    isLast && isFull && (React.createElement(AddRemoveButton, { add: false, onPress: function () { return handleRemovePressed(index); } }))))));
    })));
};
