import React, { FC } from 'react';
import { IBoardStyle } from '..';
declare type WebRenderFn = (open: boolean, editor: React.ReactElement, setOpen?: (v: boolean) => any) => React.ReactElement;
interface INativeVisualEditorBridge {
    children: (launch: (prefilledLayout?: string, composerType?: string) => any) => React.ReactElement;
    onComplete: (id: string | undefined, text: string | undefined, characters: string | undefined) => any;
    renderWebVisualEditor?: WebRenderFn;
    boardStyle?: IBoardStyle;
    maxReconnectionDelay?: number;
    minReconnectionDelay?: number;
    connectionTimeout?: number;
    debugWs?: boolean;
    keepSocketOpen?: boolean;
    setVisualEditorId?: (id: string) => any;
}
export declare enum VestaboardInstallablePlatformKey {
    Android = "android",
    iOS = "ios",
    Web = "web",
    Other = "other"
}
export declare const useVestaboardInstallablePlatformKey: () => VestaboardInstallablePlatformKey;
export declare const NativeVisualEditorBridge: FC<INativeVisualEditorBridge>;
export {};
