var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import Box from '@mui/material/Box';
import ButtonBase from '@mui/material/ButtonBase';
import { colors } from '../theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {},
    dot: {
        height: 8,
        width: 8,
        borderRadius: '50%',
        border: "solid 1px ".concat(colors.shuttleGray),
        margin: '4px',
    },
    dotActive: {
        backgroundColor: colors.white,
        border: "solid 1px ".concat(colors.white),
    },
});
var createPages = function (numberOfPages) {
    var i = 0;
    return Array.from(Array(numberOfPages), function () { return i++; });
};
export var Pagination = function (props) {
    var classes = useStyles();
    var pages = createPages(props.numberOfPages);
    if (pages.length === 1) {
        return null;
    }
    return (React.createElement(Box, { sx: classes.container }, pages.map(function (page) { return (React.createElement(ButtonBase, { key: page, sx: __assign(__assign({}, classes.dot), (page === props.currentPage ? classes.dotActive : {})), onClick: function () { return props.setPage(page); } })); })));
};
