import FormControlLabel from '@mui/material/FormControlLabel';
import Radio from '@mui/material/Radio';
import RadioGroup from '@mui/material/RadioGroup';
import React from 'react';
import { Theme } from './Theme';
import { colors } from '../theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function () { return ({
    group: {
        color: colors.white,
    },
    radio: {
        color: colors.nevada,
    },
}); });
export var RadioButtons = function (props) {
    var classes = useStyles();
    return (React.createElement(Theme, null,
        React.createElement(RadioGroup, { sx: classes.group, value: props.value, onChange: function (e) { return props.onValueChange(e.target.value || null); } }, props.options.map(function (option) { return (React.createElement(FormControlLabel, { disabled: option.disabled, value: option.id, control: React.createElement(Radio, { sx: classes.radio }), label: option.name })); }))));
};
