var _a, _b, _c;
import React, { useEffect, useState } from 'react';
import Box from '@mui/material/Box';
import { Button } from './Button';
import ScheduleIcon from '@mui/icons-material/Schedule';
import { Typography } from '@mui/material';
import { responsive } from '../theme';
import MaterialButton from '@mui/material/Button';
import { Icon } from './Icon';
import { getIcon } from '../utils/getIcon';
import { Modal } from './Modal';
import { SubTitle } from './Typography';
import { Spacer } from './Spacer';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100vw',
        height: '100vh',
        backgroundColor: 'rgba(10, 10, 11, 0.9)',
        zIndex: 999,
        overflow: 'hidden',
        backdropFilter: 'blur(6px)',
        justifyContent: 'center',
        alignItems: 'center',
        display: 'flex',
    },
    modal: {
        width: 512,
        minHeight: 378,
        padding: '34px 44px 48px 44px',
        borderRadius: '6px',
        backdropFilter: 'blur(10px)',
        backgroundColor: 'rgba(125, 135, 142, 0.2)',
        maxWidth: 'calc(100% - 88px)',
    },
    headerBox: {
        textAlign: 'center',
    },
    sendIn: {
        margin: '0 14px 14px 13px',
        fontSize: 16,
        fontWeight: 500,
        textAlign: 'center',
        color: '#f5f5f7',
    },
    buttons: (_a = {
            display: 'flex'
        },
        _a["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            flexDirection: 'column',
        },
        _a),
    buttonsSpace: (_b = {
            width: 32
        },
        _b["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            height: 14,
        },
        _b),
    inputBox: {
        display: 'flex',
        justifyContent: 'center',
    },
    timeBox: {
        width: 87,
        maxWidth: '30%',
    },
    input: (_c = {
            width: 'calc(100% - 16px)',
            paddingLeft: '16px',
            height: 48,
            borderRadius: '6px',
            border: 'solid 1px #f5f5f7',
            fontSize: 34,
            fontWeight: 500,
            background: 'transparent',
            textAlign: 'center',
            color: '#f5f5f7',
            outline: 'none'
        },
        _c["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            fontSize: 28,
        },
        _c),
    label: {
        margin: '7px 0px 0 0px',
        opacity: 0.75,
        fontSize: 14,
        letterSpacing: 0.2,
        textAlign: 'center',
        color: '#f5f5f7',
    },
    colon: {
        width: 12,
        height: 40,
        margin: '2px 8px 12px 12px',
        fontSize: 34,
        fontWeight: 500,
        textAlign: 'center',
        color: '#f5f5f7',
    },
    estimate: {
        margin: '18px 0px 43px 0px',
        fontSize: 18,
        lineHeight: 1.44,
        textAlign: 'center',
        color: '#a0a7ac',
    },
    scheduledMessageWarningContainer: {
        display: 'flex',
        flexDirection: 'row',
        justifyContent: 'center',
        marginBottom: '20px',
    },
    scheduledMessageWarningText: {
        fontFamily: 'HelveticaNeue',
        textAlign: 'right',
        fontSize: '12px',
        color: 'red',
    },
    scheduledMessagePreviewContainer: {
        width: '320px',
        display: 'flex',
        flexDirection: 'column',
        height: '80px',
        borderRadius: '6px',
        backgroundColor: '#393b3e',
        alignSelf: 'center',
        justifyContent: 'center',
        alignItems: 'center',
    },
    scheduledMessageText: {
        margin: '5px 4px 12px 3px',
        paddingTop: '5px',
        fontFamily: 'Roboto',
        fontSize: '11px',
        fontWeight: 500,
        lineHeight: 1.27,
        letterSpacing: '0.1px',
        textAlign: 'center',
        color: 'white',
    },
    scheduledMessageLowerContainer: {
        display: 'flex',
        flexDirection: 'row',
    },
    scheduledMessageLowerText: {
        margin: '5px 90px 0 0',
        fontSize: '10px',
        fontFamily: 'HelveticaNeue',
        textAlign: 'right',
        color: '#a0a7ac',
        alightSelf: 'flex-start',
    },
    scheduledMessageCancelButtonText: {
        fontSize: '10px',
        margin: '0px 0px 0px 0',
        bottom: '3px',
        fontFamily: 'HelveticaNeue',
        color: '#a0a7ac',
        width: '75px',
        alightSelf: 'flex-end',
    },
    scheduledMessageCancelButton: {
        width: '20%',
        whiteSpace: 'nowrap',
        margin: '0 0 0 0px',
        textTransform: 'none',
        left: '20px',
        top: '1px',
    },
    scheduledMessageWarningIcon: {
        color: 'red',
        marginRight: '2px',
    },
});
export var ScheduleMessage = function (props) {
    var _a = useState(0), hours = _a[0], setHours = _a[1];
    var _b = useState(0), minutes = _b[0], setMinutes = _b[1];
    var _c = useState(0), seconds = _c[0], setSeconds = _c[1];
    var _d = useState(''), dateString = _d[0], setDateString = _d[1];
    var classes = useStyles();
    useEffect(function () {
        var interval = setInterval(function () {
            var date = new Date();
            date.setHours(date.getHours() + hours || 0);
            date.setMinutes(date.getMinutes() + minutes || 0);
            date.setSeconds(date.getSeconds() + seconds || 0);
            var dateArray = date.toString().split(' ');
            setDateString("".concat(dateArray[1], " ").concat(dateArray[2], " ").concat(dateArray[3], " / ").concat(dateArray[4]));
            // update every half second
        }, 500);
        return function () { return clearInterval(interval); };
    }, [hours, minutes, seconds]);
    var onCancel = props.onCancel;
    useEffect(function () {
        var handleEscape = function (e) {
            if (e.key === 'Escape') {
                onCancel();
            }
        };
        window.addEventListener('keydown', handleEscape);
        return function () {
            window.removeEventListener('keydown', handleEscape);
        };
    }, []);
    return (React.createElement(Modal, { fullScreenMobile: true, visible: props.visible, onClose: props.onClose || props.onCancel },
        React.createElement(Box, { sx: classes.headerBox },
            React.createElement(SubTitle, null, "Schedule Message"),
            React.createElement(Spacer, { size: "large" }),
            React.createElement(Typography, { sx: classes.sendIn }, "Send In")),
        React.createElement(Box, { sx: classes.inputBox },
            React.createElement(Box, { sx: classes.timeBox },
                React.createElement("input", { step: 1, min: 0, type: "number", style: classes.input, value: hours, onChange: function (e) { return setHours(+e.target.value); } }),
                React.createElement(Typography, { sx: classes.label }, "Hours")),
            React.createElement(Box, { sx: classes.colon }, ":"),
            React.createElement(Box, { sx: classes.timeBox },
                React.createElement("input", { step: 1, min: 0, max: 59, type: "number", style: classes.input, value: minutes, onChange: function (e) { return setMinutes(+e.target.value); } }),
                React.createElement(Typography, { sx: classes.label }, "Minutes")),
            React.createElement(Box, { sx: classes.colon }, ":"),
            React.createElement(Box, { sx: classes.timeBox },
                React.createElement("input", { step: 1, min: 0, max: 59, type: "number", style: classes.input, value: seconds, onChange: function (e) { return setSeconds(+e.target.value); } }),
                React.createElement(Typography, { sx: classes.label }, "Seconds"))),
        React.createElement(Typography, { sx: classes.estimate, style: props.scheduledMessage && { marginBottom: 30 } }, dateString),
        props.scheduledMessage && (React.createElement(Box, { sx: classes.scheduledMessageWarningContainer, style: { flexDirection: 'column' } },
            React.createElement(Box, { sx: classes.scheduledMessageWarningContainer },
                React.createElement("img", { src: getIcon('warning'), style: classes.scheduledMessageWarningIcon, alt: "warning" }),
                React.createElement(Typography, { sx: classes.scheduledMessageWarningText }, "This will delete this prior scheduled message")),
            React.createElement(Box, { sx: classes.scheduledMessagePreviewContainer },
                React.createElement(Typography, { sx: classes.scheduledMessageText }, props.scheduledMessage.text.toUpperCase()),
                React.createElement(Box, { sx: classes.scheduledMessageLowerContainer },
                    React.createElement(Typography, { sx: classes.scheduledMessageLowerText }, props.scheduledMessage.sendAtFormatted),
                    React.createElement(MaterialButton, { size: "small", sx: classes.scheduledMessageCancelButton, onClick: props.scheduledMessage.onCancelScheduledMessage },
                        React.createElement(Icon, { type: "close", size: 11, margin: "0 2px 0 0" }),
                        React.createElement(Typography, { sx: classes.scheduledMessageCancelButtonText }, "Cancel Message")))))),
        React.createElement(Box, { sx: classes.buttons },
            React.createElement(Button, { buttonType: "outline", onClick: props.onCancel }, "Cancel"),
            React.createElement(Box, { sx: classes.buttonsSpace }),
            React.createElement(Button, { buttonType: "white", onClick: function () { return props.onSend(hours, minutes, seconds); } },
                "Schedule ",
                React.createElement(ScheduleIcon, null)))));
};
