var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React from 'react';
import { colors } from '../theme';
import FormControl from '@mui/material/FormControl';
import FormHelperText from '@mui/material/FormHelperText';
import InputLabel from '@mui/material/InputLabel';
import MaterialSelect from '@mui/material/Select';
import MenuItem from '@mui/material/MenuItem';
import { Theme } from './Theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useMenuItemStyles = makeVestaboardStyles({
    root: {
        color: colors.alto,
        backgroundColor: colors.black,
        '&:hover': {
            color: colors.black,
            backgroundColor: "".concat(colors.alto, " !important"),
        },
    },
});
var usePopoverStyles = makeVestaboardStyles({
    root: {
    // top: 50,
    },
    paper: {
        marginTop: '10px',
    },
});
export var Select = function (props) {
    var menuItemClasses = useMenuItemStyles();
    var popoverClasses = usePopoverStyles();
    var options = props.displayNone
        ? __spreadArray([{ id: 'none', name: 'None' }], props.options, true) : props.options;
    return (React.createElement(Theme, null,
        props.label && (React.createElement(InputLabel, { style: {
                color: colors.alto,
                fontFamily: 'HelveticaNeue',
                marginBottom: 10,
                marginLeft: 4,
            }, color: "primary", disableAnimation: true }, props.label)),
        React.createElement(FormControl, { disabled: props.disabled, variant: "outlined", style: {
                flex: 1,
                display: 'flex',
                outline: 0,
                color: colors.alto,
            }, sx: {
                '& .MuiInputBase-input.Mui-disabled': {
                    WebkitTextFillColor: colors.grey,
                },
            }, error: !!props.error },
            React.createElement(MaterialSelect, { SelectDisplayProps: {
                    style: {
                        borderColor: colors.alto,
                        color: colors.alto,
                    },
                }, sx: {
                    borderColor: colors.alto,
                    borderRadius: 2,
                    color: colors.alto,
                    '& .MuiSvgIcon-root': {
                        color: colors.alto,
                    },
                    '.MuiOutlinedInput-notchedOutline': {
                        borderColor: colors.alto,
                    },
                    '&.Mui-focused .MuiOutlinedInput-notchedOutline': {
                        borderColor: colors.alto,
                    },
                    '&:hover .MuiOutlinedInput-notchedOutline': {
                        borderColor: colors.nevada,
                    },
                }, style: {
                    borderColor: colors.alto,
                    color: colors.alto,
                    background: colors.woodSmoke,
                }, variant: "outlined", value: props.value, onChange: function (e) { return props.onValueChange(e.target.value); }, fullWidth: true, MenuProps: {
                    anchorOrigin: {
                        vertical: 'bottom',
                        horizontal: 'left',
                    },
                    transformOrigin: {
                        vertical: 'top',
                        horizontal: 'left',
                    },
                    anchorPosition: {
                        left: 20,
                        top: -100,
                    },
                    MenuListProps: {
                        style: {
                            color: colors.alto,
                            backgroundColor: colors.black,
                            border: '1px solid',
                            borderColor: colors.alto,
                            borderRadius: '6px',
                        },
                    },
                    sx: popoverClasses.paper,
                }, error: !!props.error }, options.map(function (option) { return (React.createElement(MenuItem, { sx: menuItemClasses.root, key: option.id, value: option.id }, option.name)); })),
            !!props.error && React.createElement(FormHelperText, null, props.error))));
};
