import { Box, ButtonBase } from '@mui/material';
import { Check } from '@mui/icons-material';
import React from 'react';
import { TextButton } from './TextButton';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    selectBtnContainer: {
        display: 'flex',
        justifyContent: 'flex-end',
    },
    selectBtnGroup: {
        width: 250,
        display: 'flex',
        gap: '16px',
        justifyContent: 'flex-end',
        marginTop: '24px',
    },
    selectBtnStyle: {
        backgroundColor: '#585f64',
        borderRadius: '6px',
        paddingLeft: '8px',
        paddingRight: '8px',
    },
    boardContainer: {
        display: 'flex',
        justifyContent: 'space-between',
        alignItems: 'space-between',
        flexDirection: 'row',
        flex: 1,
    },
    buttonBase: {
        width: '100%',
        height: 50,
    },
});
export var SelectMenu = function (props) {
    var classes = useStyles();
    return (React.createElement(Box, { style: {
            width: '100%',
        } },
        React.createElement(Box, { style: {
                flexDirection: 'column',
            } }, props.options.map(function (option, index) {
            var isSelected = props.selected.includes(option.id);
            return (React.createElement(Box, { key: "".concat(option.id, "-broadcast-button"), borderBottom: index === props.options.length - 1 ? 0 : 1, style: {
                    borderColor: isSelected ? '#ffffff' : '#444646',
                } },
                React.createElement(ButtonBase, { sx: classes.buttonBase, onClick: function () {
                        props.onPress(option.id);
                    } },
                    React.createElement(Box, { sx: classes.boardContainer },
                        React.createElement(Box, { style: {
                                display: 'flex',
                                flex: 1,
                                color: isSelected ? '#ffffff' : '#444646',
                            } }, "".concat(option.name)),
                        React.createElement(Box, { style: {
                                display: 'flex',
                                flex: 1,
                                justifyContent: 'flex-end',
                                color: isSelected ? '#ffffff' : '#444646',
                            } }, isSelected && React.createElement(Check, null))))));
        })),
        props.selectAll && props.clear && (React.createElement(Box, { sx: classes.selectBtnContainer },
            React.createElement(Box, { sx: classes.selectBtnGroup },
                React.createElement(Box, { sx: classes.selectBtnStyle },
                    React.createElement(TextButton, { onClick: function () {
                            props.selectAll && props.selectAll();
                        } }, "Select All")),
                React.createElement(Box, { sx: classes.selectBtnStyle },
                    React.createElement(TextButton, { onClick: function () {
                            props.clear && props.clear();
                        } }, "Clear")))))));
};
