var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as React from 'react';
import { colors, fontFamily } from '../theme';
import Box from '@mui/material/Box';
import ButtonBase from '@mui/material/ButtonBase';
import ScheduleIcon from '@mui/icons-material/Schedule';
import { getIcon } from '../utils/getIcon';
import { useState } from 'react';
import { Close, KeyboardArrowDown } from '@mui/icons-material';
import { Typography } from '@mui/material';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        width: 150,
        display: 'flex',
    },
    singleContainer: {
        width: 103,
        display: 'flex',
    },
    sendButton: {
        width: 103,
        height: 48,
        borderRadius: '7px 0px 0px 7px',
        backgroundColor: colors.white,
        display: 'flex',
        alignItems: 'center',
        fontFamily: fontFamily.default,
        fontSize: 16,
        color: colors.black,
    },
    scheduleButton: {
        width: 47,
        height: 48,
        backgroundColor: colors.white,
        borderRadius: '0px 7px 7px 0px',
        marginLeft: '1px',
        color: colors.black,
    },
    dropdownActionContainer: {
        position: 'absolute',
    },
    dropdownOffset: {
        position: 'relative',
        backgroundColor: '#383d3f',
        // left: 60,
        top: -90,
        borderRadius: '6px',
    },
    dropdownAction: {
        paddingLeft: '8px',
        paddingRight: '8px',
        height: 40,
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'space-between',
    },
    dropdownButton: {
        color: '#ffffff',
        width: 134,
    },
    iconActionContatiner: {
        display: 'flex',
        flex: 1,
        justifyContent: 'flex-end',
    },
    actionTitleContainer: {
        display: 'flex',
        flex: 1,
    },
});
export var SendButton = function (props) {
    var classes = useStyles();
    var buttonLabel = props.buttonLabel || 'Send';
    var _a = useState(false), dropdownOpen = _a[0], setDropdownOpen = _a[1];
    return !!props.dropdownActions ? (React.createElement(Box, { sx: classes.container },
        React.createElement(ButtonBase, { sx: classes.sendButton, onClick: props.onSend },
            buttonLabel,
            " \u00A0 ",
            React.createElement("img", { src: getIcon('send') })),
        dropdownOpen && !!props.dropdownActions && (React.createElement(Box, { sx: classes.dropdownActionContainer },
            React.createElement(Box, { sx: classes.dropdownOffset, style: {
                    top: -40 * props.dropdownActions.length + -10,
                } }, props.dropdownActions.map(function (action, index) { return (React.createElement(Box, { key: action.title, sx: classes.dropdownAction, style: {
                    borderBottom: index <
                        (props.dropdownActions ? props.dropdownActions.length : 0) -
                            1
                        ? '1px solid #000000'
                        : '',
                } },
                React.createElement(ButtonBase, { sx: classes.dropdownButton, onClick: function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, action.onPress()];
                                case 1:
                                    _a.sent();
                                    setDropdownOpen(false);
                                    return [2 /*return*/];
                            }
                        });
                    }); } },
                    React.createElement(Box, { sx: classes.actionTitleContainer },
                        React.createElement(Typography, null, action.title)),
                    React.createElement(Box, { sx: classes.iconActionContatiner }, action.icon)))); })))),
        React.createElement(ButtonBase, { sx: classes.scheduleButton, onClick: function () {
                return dropdownOpen ? setDropdownOpen(false) : setDropdownOpen(true);
            } }, dropdownOpen ? React.createElement(Close, null) : React.createElement(KeyboardArrowDown, null)))) : !!props.onSchedule ? (React.createElement(Box, { sx: classes.container },
        React.createElement(ButtonBase, { sx: classes.sendButton, onClick: props.onSend },
            buttonLabel,
            " \u00A0 ",
            React.createElement("img", { src: getIcon('send') })),
        React.createElement(ButtonBase, { sx: classes.scheduleButton, onClick: props.onSchedule },
            React.createElement(ScheduleIcon, null)))) : (React.createElement(Box, { sx: classes.singleContainer },
        React.createElement(ButtonBase, { sx: classes.sendButton, onClick: props.onSend, style: {
                borderRadius: 7,
            } },
            buttonLabel,
            " \u00A0 ",
            React.createElement("img", { src: getIcon('send') }))));
};
