var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { ButtonBase } from '@mui/material';
import React, { useLayoutEffect, useRef, useState } from 'react';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: {
        backgroundColor: '#FFF',
        position: 'fixed',
        bottom: 0,
        left: 0,
        width: '100%',
        borderTopRightRadius: 8,
        borderTopLeftRadius: 8,
        transition: 'bottom 0.2s',
        zIndex: 1000,
    },
    cover: {
        top: 0,
        left: 0,
        zIndex: 999,
        width: '100%',
        height: '100%',
        position: 'fixed',
        backgroundImage: 'linear-gradient(to bottom, rgba(23, 24, 24, 0.59), rgba(23, 24, 24, 0.59))',
        backdropFilter: 'blur(2px)',
    },
});
export var SlideUpMenu = function (props) {
    var classes = useStyles();
    var ref = useRef();
    var _a = useState(0), bottom = _a[0], setBottom = _a[1];
    var _b = useState(props.visible), initialized = _b[0], setInitialized = _b[1];
    var visible = props.visible;
    useLayoutEffect(function () {
        var _a;
        setBottom(visible ? 0 : -(((_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.offsetHeight) || 0));
        if (visible) {
            setInitialized(true);
        }
    }, [visible]);
    return (React.createElement(React.Fragment, null,
        React.createElement(ButtonBase, { onClick: props.onClose },
            React.createElement("div", { style: __assign(__assign({}, classes.cover), { display: props.visible ? 'block' : 'none' }) })),
        React.createElement("div", { ref: ref, style: __assign(__assign({}, classes.container), { bottom: bottom, opacity: initialized ? 1 : 0 }) }, props.children)));
};
