var _a, _b, _c;
import * as React from 'react';
import { Box, ButtonBase } from '@mui/material';
import { characterCodeColors } from '../characterCodes';
import { getIcon } from '../utils/getIcon';
import { responsive } from '../theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    container: (_a = {
            display: 'flex',
            justifyContent: 'flex-start'
        },
        _a["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            bottom: 0,
            left: 0,
            padding: '12px 16px 11px 20px',
            backgroundColor: '#0a0a0b',
            width: '100vw',
            justifyContent: 'flex-start',
            marginTop: '14px',
        },
        _a),
    unpaddedContainer: {
        display: 'flex',
        justifyContent: 'space-evenly',
        flex: 1,
        width: '100%',
        minWidth: 290,
    },
    color: (_b = {
            height: 30,
            width: 20,
            borderRadius: '3px',
            marginRight: '8px',
            minWidth: 20,
            '&:last-child': {
                marginRight: '0px',
            }
        },
        _b["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            '&:first-child': {
                marginLeft: '28px',
            },
        },
        _b),
    unpaddedColor: {
        height: 30,
        width: 20,
        minWidth: 20,
        borderRadius: '3px',
        marginRight: '8px',
        '&:last-child': {
            marginRight: '0px',
        },
    },
    rainbowContainer: {
        display: 'flex',
        flexDirection: 'column',
    },
    spacer: (_c = {
            width: 20
        },
        _c["@media(max-width: ".concat(responsive.MOBILE, "px)")] = {
            display: 'none',
        },
        _c),
    mobileSpacing: {},
});
export var SwatchPicker = function (props) {
    var classes = useStyles();
    var colors = characterCodeColors.filter(function (bit) { return bit.code !== 69 && bit.code !== 70 && bit.code !== 71; });
    var spacerClass = props.spaceEvenly ? classes.mobileSpacing : classes.spacer;
    return (React.createElement(Box, { sx: props.spaceEvenly ? classes.unpaddedContainer : classes.container },
        characterCodeColors.map(function (bit, key) {
            return bit.code === 71 && !props.showFilledColor ? (React.createElement(React.Fragment, null)) : (React.createElement(React.Fragment, { key: bit.code },
                !!key && React.createElement(Box, { sx: spacerClass }),
                React.createElement(ButtonBase, { key: bit.name, sx: props.spaceEvenly ? classes.unpaddedColor : classes.color, onClick: function () {
                        props.setValue(bit.code);
                    }, style: {
                        borderColor: bit.code === 70 ? 'rgb(57 59 62)' : 'transparent',
                        borderWidth: 1,
                        borderStyle: 'solid',
                        backgroundColor: bit.color,
                        boxShadow: props.value === bit.code
                            ? 'white 0px 0px 0px 2px, white 0px 0px 0px 1px'
                            : '',
                    } })));
        }),
        props.rainbowSwatch && (React.createElement(React.Fragment, null,
            React.createElement(Box, { sx: spacerClass }),
            React.createElement(ButtonBase, { key: 'rainbow', sx: props.spaceEvenly ? classes.unpaddedColor : classes.color, onClick: function () {
                    props.setValue('rainbow');
                }, style: {
                    borderColor: 'rgb(57 59 62)',
                    borderWidth: 1,
                    borderStyle: 'solid',
                    boxShadow: props.value === 'rainbow'
                        ? 'white 0px 0px 0px 2px, white 0px 0px 0px 1px'
                        : '',
                } },
                React.createElement(Box, { sx: classes.rainbowContainer }, colors.map(function (bit, index) { return (React.createElement("div", { style: {
                        borderTopLeftRadius: index === 0 ? 3 : 0,
                        borderTopRightRadius: index === 0 ? 3 : 0,
                        borderBottomLeftRadius: index === colors.length - 1 ? 3 : 0,
                        borderBottomRightRadius: index === colors.length - 1 ? 3 : 0,
                        backgroundColor: bit.color,
                        height: '5px',
                        width: 20,
                    } })); }))))),
        props.isPaintMode && !props.hideEditTools && (React.createElement(React.Fragment, null,
            React.createElement(Box, { sx: spacerClass }),
            React.createElement(ButtonBase, { onClick: function () {
                    props.setValue(0);
                } },
                React.createElement("img", { src: getIcon('eraser-off') })),
            React.createElement(Box, { sx: spacerClass }),
            React.createElement(ButtonBase, { onClick: props.endPaintMode },
                React.createElement("img", { src: getIcon('text-off') }))))));
};
