import React from 'react';
import MuiTabs from '@mui/material/Tabs';
import Tab from '@mui/material/Tab';
import { Theme } from './Theme';
import { colors } from '../theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function () { return ({
    root: {
        color: colors.white,
        textTransform: 'none',
        fontFamily: 'HelveticaNeue',
        minWidth: 80,
    },
}); });
export var TabBar = function (props) {
    var classes = useStyles();
    return (React.createElement(Theme, null,
        React.createElement(MuiTabs, { TabIndicatorProps: {
                sx: {
                    backgroundColor: colors.white,
                    height: '1px',
                },
            }, variant: props.fullWidth ? 'fullWidth' : 'standard', indicatorColor: "primary", value: props.value, onChange: function (_e, newValue) {
                props.setValue(newValue);
            } }, props.tabs.map(function (tab) { return (React.createElement(Tab, { disableRipple: props.disableRipple, label: tab.label, key: tab.key, sx: classes.root, style: {
                color: colors.white,
            } })); }))));
};
