import React from 'react';
import { createTheme, StyledEngineProvider, ThemeProvider, } from '@mui/material/styles';
import CssBaseline from '@mui/material/CssBaseline';
import { colors } from '../theme';
export var theme = createTheme({
    components: {
        MuiCssBaseline: {
            styleOverrides: {
                html: {
                    WebkitFontSmoothing: 'auto',
                },
                body: {
                    backgroundColor: colors.woodSmoke,
                    overscrollBehaviorX: 'none',
                },
            },
        },
    },
    palette: {
        primary: {
            main: colors.lightGrey,
        },
        secondary: {
            main: colors.white,
        },
        background: {
            default: colors.woodSmoke,
        },
        error: {
            main: colors.oldBrick,
        },
    },
});
export var Theme = function (props) { return (React.createElement(StyledEngineProvider, { injectFirst: true },
    React.createElement(ThemeProvider, { theme: theme },
        props.isRoot && React.createElement(CssBaseline, null),
        props.children))); };
