import { Box } from '@mui/material';
import * as React from 'react';
import { useVestaboardTimezone } from '../context/VestaboardSubscriptionContext';
import { useVestaboardQueryParams } from '../hooks/useVestaboardParams';
import { Body } from './Typography';
export var TimezoneCTA = function (props) {
    var _a = useVestaboardTimezone(), timezone = _a.value, loading = _a.loading;
    var platform = useVestaboardQueryParams().platform;
    var text = React.useMemo(function () {
        switch (platform) {
            case 'ios':
            case 'android':
                return (React.createElement("a", { style: { color: 'red' }, href: "#", onClick: function () {
                        return window.open('https://platform.vestaboard.com/deeplink/settings/timezone');
                    } }, "Set"));
            default:
                return 'Set';
        }
    }, [platform]);
    if (loading)
        return null;
    if (!timezone) {
        return (React.createElement(Box, { style: { color: 'red', textAlign: 'center' } },
            React.createElement(Body, { color: "red" },
                text,
                " your Vestaboard time zone to continue.")));
    }
    else {
        return null;
    }
};
