import Box from '@mui/material/Box';
import ButtonBase from '@mui/material/ButtonBase';
import React from 'react';
import Snackbar from '@mui/material/Snackbar';
import { getIcon } from '../../utils/getIcon';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles({
    closeIcon: {
        width: 24,
        height: 24,
    },
    messageContainer: {
        display: 'flex',
        position: 'relative',
        color: '#FFF',
    },
    severityIconWrapper: {
        backgroundColor: 'rgba(245, 245, 247, 0.08)',
        height: 48,
        position: 'absolute',
        top: -14,
        left: -15,
        width: 48,
        borderRadius: '4px 0px 0px 4px',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
    },
    severityIconWrapperGlow: {
        height: 24,
        width: 48,
        backgroundColor: '#333',
        position: 'absolute',
        bottom: 0,
        left: 0,
        zIndex: 1,
        borderRadius: '0px 0px 0px 4px',
        opacity: 0.4,
    },
    severityIcon: {
        width: 16,
        position: 'relative',
        zIndex: 2,
    },
    message: {
        paddingLeft: '54px',
    },
});
// const useSnackbarStyles = makeVestaboardStyles({
//   root: {
//     backgroundColor: 'rgb(49, 49, 49)',
//     '& > div': {
//       backgroundColor: 'transparent !important',
//     },
//   },
// })
export var Toast = function (props) {
    var classes = useStyles();
    var autoHideTime = props.autoHideDurationSeconds
        ? props.autoHideDurationSeconds * 1000
        : null;
    return (React.createElement(Snackbar, { autoHideDuration: autoHideTime, style: {
            marginTop: props.topOffset || 0,
        }, sx: {
            '.MuiSnackbarContent-root': {
                backgroundColor: 'rgb(49, 49, 49)',
            },
        }, anchorOrigin: { vertical: 'top', horizontal: 'right' }, open: props.open, onClose: props.onClose, message: React.createElement(Box, { sx: classes.messageContainer },
            React.createElement(Box, { sx: classes.severityIconWrapper },
                React.createElement(Box, { sx: classes.severityIconWrapperGlow }),
                React.createElement("img", { alt: "close", src: getIcon(props.severity === 'success' ? 'check' : 'close'), style: classes.severityIcon })),
            React.createElement(Box, { sx: classes.message }, props.message)), key: props.message, action: React.createElement(React.Fragment, null,
            React.createElement(ButtonBase, { "aria-label": "close", color: "inherit", onClick: function () {
                    props.onClose();
                } },
                React.createElement("img", { alt: "close", src: getIcon('close'), style: classes.closeIcon }))) }));
};
