var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { Box, Button } from '@mui/material';
import { colors, responsive } from '../theme';
export var ToggleButton = function (props) {
    return (React.createElement(Box, { sx: {
            display: 'flex',
            flex: 1,
            border: 'solid 1px #7e878e',
            borderRadius: '5px',
            minWidth: 80,
        } }, props.options.map(function (option) {
        var _a;
        var isSelected = option.value === props.value;
        var activeStyle = isSelected
            ? {
                backgroundColor: colors.alto,
                color: colors.woodSmoke,
                '&:hover': {
                    backgroundColor: 'white',
                },
            }
            : {};
        return (React.createElement(Button, { disabled: props.disabled, style: {
                fontFamily: 'HelveticaNeue',
            }, sx: __assign((_a = { height: '100%', fontSize: 16, paddingLeft: 0, paddingRight: 0, backgroundColor: colors.woodSmoke, color: colors.alto, flexGrow: 1, textTransform: 'none', borderRadius: '0', '&:first-child': {
                        borderRadius: '5px 0px 0px 5px',
                    }, '&:last-child': {
                        borderRadius: '0px 5px 5px 0px',
                    } }, _a["@media(max-width: ".concat(responsive.SMALL_MOBILE, "px)")] = {
                minWidth: '50%',
                maxWidth: '50%',
                height: '100%',
                fontSize: 12,
            }, _a), activeStyle), key: option.key, onClick: function () {
                if (!isSelected) {
                    props.onToggle(option.value);
                }
            } }, option.key));
    })));
};
