import React from 'react';
import { colors, fontFamily } from '../theme';
import Box from '@mui/material/Box';
import TextField from '@mui/material/TextField';
import { Theme } from './Theme';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function () { return ({
    input: {
        padding: '0px',
        outline: 0,
        '& > div': {},
        '& label': {
            color: "".concat(colors.nevada, " !important"),
        },
        '& fieldset': {
            borderWidth: 0,
        },
        '&:hover .MuiOutlinedInput-root .MuiOutlinedInput-notchedOutline': {
            borderWidth: '0 !important',
        },
        '& input': {
            color: colors.white,
            outline: 'none',
        },
        '& textarea': {
            color: colors.white,
            outline: 'none',
        },
    },
    container: {
        position: 'relative',
    },
    countdown: {
        opacity: '0.31',
        fontSize: 12,
        color: '#FFF',
        fontFamily: fontFamily.default,
        position: 'absolute',
        right: 0,
        bottom: 0,
    },
}); });
export var TransparentTextArea = function (props) {
    var classes = useStyles();
    return (React.createElement(Theme, null,
        React.createElement(Box, { sx: classes.container },
            React.createElement(TextField, { inputProps: {
                    readOnly: props.readOnly,
                }, error: !!props.error, helperText: props.error, sx: classes.input, fullWidth: true, label: props.label, variant: "outlined", value: props.value, onChange: function (e) { return props.onValueChange(e.target.value); }, multiline: true, rows: 3, placeholder: props.placeholder }),
            typeof props.countDown === 'number' && (React.createElement(Box, { sx: classes.countdown }, props.countDown - props.value.length)))));
};
