import React from 'react';
import Typography from '@mui/material/Typography';
import { typographyStyles } from './typographyStyles';
import { makeVestaboardStyles } from '../hooks/useVestaboardStyles';
var useStyles = makeVestaboardStyles(function (props) { return ({
    title: typographyStyles.title(props),
    subTitle: typographyStyles.subTitle(props),
    subTitle2: typographyStyles.subTitle2(props),
    body: typographyStyles.body(props),
    medium: typographyStyles.medium(props),
    mediumTruncated: typographyStyles.mediumTruncated(props),
    small: typographyStyles.small(props),
}); });
export var Title = function (props) {
    var classes = useStyles(props);
    return (React.createElement(Typography, { variant: "h3", component: "h1", sx: classes.title }, props.children));
};
export var SubTitle = function (props) {
    var classes = useStyles(props);
    return (React.createElement(Typography, { variant: "h3", component: "h2", sx: classes.subTitle }, props.children));
};
export var SubTitle2 = function (props) {
    var classes = useStyles(props);
    return (React.createElement(Typography, { variant: "h3", component: "h2", sx: classes.subTitle2 }, props.children));
};
export var Body = function (props) {
    var classes = useStyles(props);
    return React.createElement(Typography, { sx: classes.body }, props.children);
};
export var Medium = function (props) {
    var classes = useStyles(props);
    return React.createElement(Typography, { sx: classes.medium }, props.children);
};
export var MediumTruncated = function (props) {
    var classes = useStyles(props);
    return React.createElement(Typography, { sx: classes.mediumTruncated }, props.children);
};
export var Small = function (props) {
    var classes = useStyles(props);
    return React.createElement(Typography, { sx: classes.small }, props.children);
};
