import * as React from 'react';
import { characterCodes } from '../../characterCodes';
export var PreviewBit = function (props) {
    var characterCode = characterCodes.find(function (code) { return code.code === props.bit; });
    var x = props.bitIndex * 0.166 + 0.2;
    var y = props.rowIndex * 0.24 + 0.2;
    var leftOffset = props.leftOffset || 0;
    var topOffset = props.topOffset || 0;
    if (!characterCode) {
        return null;
    }
    if (characterCode.value === '' || characterCode.value === ' ') {
        return (React.createElement("rect", { x: x + leftOffset, y: y + topOffset, width: "0.09", height: "0.13", style: {
                fill: props.transparentBlank && characterCode.name === 'Blank'
                    ? 'transparent'
                    : characterCode.name === 'Filled' && props.boardStyle === 'white'
                        ? '#000000'
                        : characterCode.name === 'Blank' && props.boardStyle === 'white'
                            ? 'rgb(245,245,247)'
                            : characterCode.color,
            } }));
    }
    if (characterCode.sprite) {
        return (React.createElement("image", { x: x + leftOffset - 0.05, y: y + topOffset - 0.05, width: "0.245", height: "0.245", href: props.boardStyle === 'white'
                ? characterCode.spriteInverse
                : characterCode.sprite }));
    }
    return null;
};
