var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Box, ButtonBase, Popover } from '@mui/material';
import React from 'react';
import { colors } from '../../theme';
import { Body } from '../Typography';
import { Icon } from '../Icon';
import { makeVestaboardStyles } from '../../hooks/useVestaboardStyles';
var opacity = 0.9;
var buttonHeight = 50;
var padding = 16;
var containerWidth = 260;
var useStyles = makeVestaboardStyles({
    buttonContainer: {
        display: 'flex',
        flexDirection: 'column',
        width: containerWidth,
        backgroundColor: '#2e3133',
    },
    popover: {
        opacity: opacity,
        backgroundColor: 'transparent',
        borderRadius: 6,
    },
});
export var PreviewPopover = function (props) {
    var _a, _b;
    var classes = useStyles();
    var containerHeight = buttonHeight * (((_a = props.actions) === null || _a === void 0 ? void 0 : _a.length) || 4) + 2 * padding;
    return (React.createElement(Popover, { open: props.open, anchorEl: props.anchorEl, onClose: props.onClose, anchorOrigin: {
            vertical: -containerHeight + 16,
            horizontal: -containerWidth + 32,
        }, sx: classes.popover },
        React.createElement(Box, { sx: classes.buttonContainer },
            React.createElement(Box, null, (_b = props.actions) === null || _b === void 0 ? void 0 : _b.map(function (action, index) { return (React.createElement(MenuButton, { key: "popover-".concat(index), style: {
                    borderTop: index !== 0 ? "1px solid ".concat(colors.darkBlack) : '',
                    padding: padding,
                }, onClick: function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, action.onClick({
                                    messageId: props.messageId,
                                    messageAppearanceId: props === null || props === void 0 ? void 0 : props.messageAppearanceId,
                                    sourceId: props.sourceId,
                                })];
                            case 1:
                                _a.sent();
                                props.onClose();
                                return [2 /*return*/];
                        }
                    });
                }); } },
                React.createElement(Body, null, action.text),
                ' ',
                typeof action.icon === 'string' ? (React.createElement(Icon, { type: action.icon, color: 'white' })) : (action.icon),
                ' ')); })))));
};
var MenuButton = function (props) { return (React.createElement(ButtonBase, { onClick: props.onClick, style: __assign({ height: buttonHeight, width: containerWidth, textAlign: 'left', alignItems: 'center', justifyContent: 'space-between', display: 'flex', color: colors.white, backdropFilter: "blur(4px)", backgroundColor: '#2e3133' }, props.style) }, props.children)); };
