var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { AsyncMultiSelect } from '../..';
import React, { useState, useEffect } from 'react';
export default {
    title: 'Components/AsyncMultiSelect',
    component: AsyncMultiSelect,
};
var STOCKS = [
    {
        id: 'tsla',
        label: 'TSLA',
        description: 'Tesla, Inc',
    },
    {
        id: 'aapl',
        label: 'AAPL',
        description: 'Apple, Inc.',
    },
    {
        id: 'googl',
        label: 'GOOGL',
        description: 'Alphabet, Inc.',
    },
    {
        id: 'amzn',
        label: 'AMZN',
        description: 'Amazon.com, Inc.',
    },
    {
        id: 'nvda',
        label: 'NVDA',
        description: 'NVIDIA Corporation',
    },
    {
        id: 'amd',
        label: 'AMD',
        description: 'Advanced Micro Devices, Inc.',
    },
];
export var Default = function () {
    var _a = useState(false), loading = _a[0], setLoading = _a[1];
    var _b = useState([]), filteredOptions = _b[0], setFilteredOptions = _b[1];
    var _c = useState([]), selected = _c[0], setSelected = _c[1];
    var _d = useState(''), input = _d[0], setInput = _d[1];
    var fetchAndFilterOptions = function (input) { return __awaiter(void 0, void 0, void 0, function () {
        var filtered;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    return [4 /*yield*/, new Promise(function (resolve) {
                            // api call mock
                            setTimeout(function () {
                                if (!input) {
                                    return resolve(STOCKS);
                                }
                                return resolve(STOCKS.filter(function (stock) {
                                    return stock.label.toLowerCase().includes(input.toLowerCase()) ||
                                        (stock.description &&
                                            stock.description.toLowerCase().includes(input.toLowerCase()));
                                }));
                            }, 500);
                        })];
                case 1:
                    filtered = _a.sent();
                    setFilteredOptions(filtered);
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        fetchAndFilterOptions(input);
    }, [input]);
    return (React.createElement(AsyncMultiSelect, { labelKeyName: "label", descriptionKeyName: "description", disableCloseOnSelect: false, onOptionSelect: setSelected, label: "Stocks", placeholder: "Select from options", filterSelectedOptions: false, options: filteredOptions, loading: loading, onInputChange: setInput }));
};
export var WithOptionLimit = function () {
    var _a = useState(false), loading = _a[0], setLoading = _a[1];
    var _b = useState([]), filteredOptions = _b[0], setFilteredOptions = _b[1];
    var _c = useState([]), selected = _c[0], setSelected = _c[1];
    var _d = useState(''), input = _d[0], setInput = _d[1];
    var fetchAndFilterOptions = function (input) { return __awaiter(void 0, void 0, void 0, function () {
        var filtered;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    return [4 /*yield*/, new Promise(function (resolve) {
                            // api call mock
                            setTimeout(function () {
                                if (!input) {
                                    return resolve(STOCKS);
                                }
                                return resolve(STOCKS.filter(function (stock) {
                                    return stock.label.toLowerCase().includes(input.toLowerCase()) ||
                                        (stock.description &&
                                            stock.description.toLowerCase().includes(input.toLowerCase()));
                                }));
                            }, 500);
                        })];
                case 1:
                    filtered = _a.sent();
                    setFilteredOptions(filtered);
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        fetchAndFilterOptions(input);
    }, [input]);
    return (React.createElement(AsyncMultiSelect, { maxOptions: 3, labelKeyName: "label", descriptionKeyName: "description", disableCloseOnSelect: false, onOptionSelect: setSelected, label: "Stocks", placeholder: "Select 3 options", filterSelectedOptions: false, options: filteredOptions, loading: loading, onInputChange: setInput }));
};
export var WithPreselectedOptions = function () {
    var _a = useState(false), loading = _a[0], setLoading = _a[1];
    var _b = useState([]), filteredOptions = _b[0], setFilteredOptions = _b[1];
    var _c = useState([]), selected = _c[0], setSelected = _c[1];
    var _d = useState(''), input = _d[0], setInput = _d[1];
    var fetchAndFilterOptions = function (input) { return __awaiter(void 0, void 0, void 0, function () {
        var filtered;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    return [4 /*yield*/, new Promise(function (resolve) {
                            // api call mock
                            setTimeout(function () {
                                if (!input) {
                                    return resolve(STOCKS);
                                }
                                return resolve(STOCKS.filter(function (stock) {
                                    return stock.label.toLowerCase().includes(input.toLowerCase()) ||
                                        (stock.description &&
                                            stock.description.toLowerCase().includes(input.toLowerCase()));
                                }));
                            }, 500);
                        })];
                case 1:
                    filtered = _a.sent();
                    setFilteredOptions(filtered);
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        fetchAndFilterOptions(input);
    }, [input]);
    return (React.createElement(AsyncMultiSelect, { maxOptions: 1, labelKeyName: "label", descriptionKeyName: "description", defaultSelectedOptions: [STOCKS[0]], disableCloseOnSelect: false, onOptionSelect: setSelected, label: "Stocks", placeholder: "Select from options", filterSelectedOptions: false, options: filteredOptions, loading: loading, onInputChange: setInput }));
};
var CustomStocks = [
    {
        id: 'tsla',
        label: 'TSLA',
        description: 'Tesla, Inc',
        ceo: 'Elon Musk',
    },
    {
        id: 'aapl',
        label: 'AAPL',
        description: 'Apple, Inc.',
        ceo: 'Tim Cook',
    },
    {
        id: 'googl',
        label: 'GOOGL',
        description: 'Alphabet, Inc.',
        ceo: 'Sundar Pichai',
    },
    {
        id: 'amzn',
        label: 'AMZN',
        description: 'Amazon.com, Inc.',
        ceo: 'Andy Jassy',
    },
    {
        id: 'nvda',
        label: 'NVDA',
        description: 'NVIDIA Corporation',
        ceo: 'Jensen Huang',
    },
    {
        id: 'amd',
        label: 'AMD',
        description: 'Advanced Micro Devices, Inc.',
        ceo: 'Lisa Su',
    },
];
export var WithCustomFiltering = function () {
    var _a = useState(false), loading = _a[0], setLoading = _a[1];
    var _b = useState([]), filteredOptions = _b[0], setFilteredOptions = _b[1];
    var _c = useState([]), selected = _c[0], setSelected = _c[1];
    var _d = useState(''), input = _d[0], setInput = _d[1];
    var filterAll = function (input) { return function (stock) {
        return Object.keys(stock).some(function (key) {
            return stock[key].toLowerCase().includes(input.toLowerCase());
        });
    }; };
    var fetchAndFilterOptions = function (input) { return __awaiter(void 0, void 0, void 0, function () {
        var filtered;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    return [4 /*yield*/, new Promise(function (resolve) {
                            // api call mock
                            setTimeout(function () {
                                if (!input) {
                                    return resolve(STOCKS);
                                }
                                return resolve(STOCKS.filter(filterAll(input)));
                            }, 500);
                        })];
                case 1:
                    filtered = _a.sent();
                    setFilteredOptions(filtered);
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        fetchAndFilterOptions(input);
    }, [input]);
    return (React.createElement(AsyncMultiSelect, { labelKeyName: "label", descriptionKeyName: "description", defaultSelectedOptions: [STOCKS[0]], disableCloseOnSelect: false, onOptionSelect: setSelected, label: "Stocks", placeholder: "Select from options", filterSelectedOptions: false, options: filteredOptions, loading: loading, onInputChange: setInput }));
};
export var WithLocalFiltering = function () {
    var _a = useState(false), loading = _a[0], setLoading = _a[1];
    var _b = useState([]), filteredOptions = _b[0], setFilteredOptions = _b[1];
    var _c = useState([]), selected = _c[0], setSelected = _c[1];
    var _d = useState(''), input = _d[0], setInput = _d[1];
    return (React.createElement(AsyncMultiSelect, { labelKeyName: "label", descriptionKeyName: "description", defaultSelectedOptions: [STOCKS[0]], disableCloseOnSelect: false, onOptionSelect: setSelected, label: "Stocks", placeholder: "Select from options", filterSelectedOptions: false, options: STOCKS, loading: loading, onInputChange: setInput, filterLocally: true }));
};
export var WithLocalSorting = function () {
    var _a = useState(false), loading = _a[0], setLoading = _a[1];
    var _b = useState([]), filteredOptions = _b[0], setFilteredOptions = _b[1];
    var _c = useState([]), selected = _c[0], setSelected = _c[1];
    var _d = useState(''), input = _d[0], setInput = _d[1];
    return (React.createElement(AsyncMultiSelect, { labelKeyName: "label", descriptionKeyName: "description", defaultSelectedOptions: [STOCKS[0]], disableCloseOnSelect: false, onOptionSelect: setSelected, label: "Stocks", placeholder: "Select from options", filterSelectedOptions: false, options: STOCKS, loading: loading, onInputChange: setInput, sortLocally: true }));
};
