var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { BoardEditor, Drafts, ScheduleMessage, Toast } from '../..';
import React, { useState } from 'react';
import { Schedule, WifiTethering } from '@mui/icons-material';
import Box from '@mui/material/Box';
import { Dialog } from '@mui/material';
import { createBoard } from '../../utils';
export default {
    title: 'Components/BoardEditor',
    component: BoardEditor,
};
var message = [
    [63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63],
    [0, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0],
    [0, 0, 65, 66, 67, 68, 0, 0, 0, 0, 69, 69, 0, 0, 0, 0, 68, 67, 66, 65, 0, 0],
    [0, 0, 65, 66, 67, 68, 0, 0, 0, 0, 69, 69, 0, 0, 0, 0, 68, 67, 66, 65, 0, 0],
    [0, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0],
    [63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63],
];
export var Default = function (props) {
    var _a = useState(false), isSchedulingLater = _a[0], setIsSchedulingLater = _a[1];
    var _b = useState(null), toastMessage = _b[0], setToastMessage = _b[1];
    var _c = useState(createBoard({
        rows: props.rows || 6,
        columns: props.columns || 22,
    })), boardValue = _c[0], setBoardValue = _c[1];
    var _d = useState([]), drafts = _d[0], setDrafts = _d[1];
    var _e = useState([
        {
            message: message,
            timeStamp: '1 day ago',
        },
    ]), availableDrafts = _e[0], setAvailableDrafts = _e[1];
    return (React.createElement(Box, null,
        !!(drafts === null || drafts === void 0 ? void 0 : drafts.length) && (React.createElement(Drafts, { onSelect: function (value) {
                setBoardValue(value);
                setDrafts([]);
            }, drafts: drafts, onClose: function () {
                setDrafts([]);
            } })),
        React.createElement(BoardEditor, { rows: props.rows, columns: props.columns, boardValue: boardValue, setBoardValue: setBoardValue, onSelectDraft: function () {
                setDrafts(availableDrafts);
            }, onTemplatesClick: function () { }, onSaveDraft: function () {
                setAvailableDrafts(__spreadArray([
                    {
                        message: boardValue,
                        timeStamp: 'Just now',
                    }
                ], availableDrafts, true));
                setToastMessage('Message saved to drafts library');
            }, onSend: function () {
                setToastMessage('Message sent');
            }, dropdownActions: [
                {
                    onPress: function () {
                        setIsSchedulingLater(true);
                    },
                    icon: React.createElement(Schedule, null),
                    title: 'Schedule',
                },
                {
                    onPress: function () { },
                    icon: React.createElement(WifiTethering, null),
                    title: 'Broadcast',
                },
            ] }),
        React.createElement(Toast, { severity: "success", message: toastMessage, open: !!toastMessage, onClose: function () {
                setToastMessage(null);
            } }),
        isSchedulingLater && (React.createElement(ScheduleMessage, { onSend: function (hours, minutes, seconds) {
                setIsSchedulingLater(false);
                setToastMessage("Message will be sent in ".concat(hours, " hours, ").concat(minutes, " minutes and ").concat(seconds, " seconds"));
            }, onCancel: function () {
                setIsSchedulingLater(false);
            }, visible: isSchedulingLater }))));
};
export var OnSchedule = function () {
    var _a = useState(false), isSchedulingLater = _a[0], setIsSchedulingLater = _a[1];
    var _b = useState(null), toastMessage = _b[0], setToastMessage = _b[1];
    var _c = useState(createBoard()), boardValue = _c[0], setBoardValue = _c[1];
    var _d = useState([]), drafts = _d[0], setDrafts = _d[1];
    var _e = useState([
        {
            message: message,
            timeStamp: '1 day ago',
        },
    ]), availableDrafts = _e[0], setAvailableDrafts = _e[1];
    return (React.createElement(Box, null,
        !!(drafts === null || drafts === void 0 ? void 0 : drafts.length) && (React.createElement(Drafts, { onSelect: function (value) {
                setBoardValue(value);
                setDrafts([]);
            }, drafts: drafts, onClose: function () {
                setDrafts([]);
            } })),
        React.createElement(BoardEditor, { boardValue: boardValue, setBoardValue: setBoardValue, onSelectDraft: function () {
                setDrafts(availableDrafts);
            }, onSaveDraft: function () {
                setAvailableDrafts(__spreadArray([
                    {
                        message: boardValue,
                        timeStamp: 'Just now',
                    }
                ], availableDrafts, true));
                setToastMessage('Message saved to drafts library');
            }, onSend: function () {
                setToastMessage('Message sent');
            }, onSchedule: function () {
                setIsSchedulingLater(true);
            } }),
        React.createElement(Toast, { severity: "success", message: toastMessage, open: !!toastMessage, onClose: function () {
                setToastMessage(null);
            } }),
        isSchedulingLater && (React.createElement(ScheduleMessage, { onSend: function (hours, minutes, seconds) {
                setIsSchedulingLater(false);
                setToastMessage("Message will be sent in ".concat(hours, " hours, ").concat(minutes, " minutes and ").concat(seconds, " seconds"));
            }, onCancel: function () {
                setIsSchedulingLater(false);
            }, visible: isSchedulingLater }))));
};
export var WithCancel = function () {
    var _a = useState(null), toastMessage = _a[0], setToastMessage = _a[1];
    var _b = useState(createBoard()), boardValue = _b[0], setBoardValue = _b[1];
    return (React.createElement(Box, null,
        React.createElement(BoardEditor, { boardValue: boardValue, setBoardValue: setBoardValue, onSend: function () {
                setToastMessage('Message sent');
            }, onCancel: function () { } }),
        React.createElement(Toast, { severity: "success", message: toastMessage, open: !!toastMessage, onClose: function () {
                setToastMessage(null);
            } })));
};
export var InModal = function () {
    var _a = useState(false), isSchedulingLater = _a[0], setIsSchedulingLater = _a[1];
    var _b = useState(null), toastMessage = _b[0], setToastMessage = _b[1];
    var _c = useState(createBoard()), boardValue = _c[0], setBoardValue = _c[1];
    var _d = useState([]), drafts = _d[0], setDrafts = _d[1];
    var _e = useState([
        {
            message: message,
            timeStamp: '1 day ago',
        },
    ]), availableDrafts = _e[0], setAvailableDrafts = _e[1];
    return (React.createElement(Box, null,
        !!(drafts === null || drafts === void 0 ? void 0 : drafts.length) && (React.createElement(Drafts, { onSelect: function (value) {
                setBoardValue(value);
                setDrafts([]);
            }, drafts: drafts, onClose: function () {
                setDrafts([]);
            } })),
        React.createElement(Dialog, { PaperProps: {
                style: {
                    backgroundColor: 'transparent',
                    boxShadow: 'none',
                },
            }, open: true },
            React.createElement(BoardEditor, { boardValue: boardValue, setBoardValue: setBoardValue, onSelectDraft: function () {
                    setDrafts(availableDrafts);
                }, onSaveDraft: function () {
                    setAvailableDrafts(__spreadArray([
                        {
                            message: boardValue,
                            timeStamp: 'Just now',
                        }
                    ], availableDrafts, true));
                    setToastMessage('Message saved to drafts library');
                }, onSend: function () {
                    setToastMessage('Message sent');
                }, onSchedule: function () {
                    setIsSchedulingLater(true);
                } })),
        React.createElement(Toast, { severity: "success", message: toastMessage, open: !!toastMessage, onClose: function () {
                setToastMessage(null);
            } }),
        isSchedulingLater && (React.createElement(ScheduleMessage, { onSend: function (hours, minutes, seconds) {
                setIsSchedulingLater(false);
                setToastMessage("Message will be sent in ".concat(hours, " hours, ").concat(minutes, " minutes and ").concat(seconds, " seconds"));
            }, onCancel: function () {
                setIsSchedulingLater(false);
            }, visible: isSchedulingLater }))));
};
export var WithoutSend = function () {
    var _a = useState(createBoard()), boardValue = _a[0], setBoardValue = _a[1];
    return (React.createElement(Box, null,
        React.createElement(BoardEditor, { boardValue: boardValue, setBoardValue: setBoardValue })));
};
export var VestaboardWhite = function () {
    var _a = useState(createBoard()), boardValue = _a[0], setBoardValue = _a[1];
    return (React.createElement(Box, null,
        React.createElement(BoardEditor, { boardValue: boardValue, setBoardValue: setBoardValue, boardStyle: "white" })));
};
export var VestaboardWhiteCharachterCode71 = function () {
    var _a = useState(createInverseBoard()), boardValue = _a[0], setBoardValue = _a[1];
    return (React.createElement(Box, null,
        React.createElement(BoardEditor, { boardValue: boardValue, setBoardValue: setBoardValue, boardStyle: "white" })));
};
var createInverseBoard = function () { return [
    [
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
    ],
    [
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
    ],
    [
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
    ],
    [
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
    ],
    [
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
    ],
    [
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
        71,
    ],
]; };
export var SixByOne = function () {
    return React.createElement(Default, { rows: 1, columns: 6 });
};
export var TwelveByOne = function () {
    return React.createElement(Default, { rows: 1, columns: 12 });
};
export var TwelveByTwo = function () {
    return React.createElement(Default, { rows: 2, columns: 12 });
};
export var TwelveByThree = function () {
    return React.createElement(Default, { rows: 3, columns: 12 });
};
export var FifteenByThree = function () {
    return React.createElement(Default, { rows: 3, columns: 15 });
};
export var EighteenByTwo = function () {
    return React.createElement(Default, { rows: 2, columns: 18 });
};
