var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { BoardGallery, ToastProvider } from '../../';
import React, { useState } from 'react';
import { action } from '@storybook/addon-actions';
import { encodeBoardCharacters } from '../../utils';
export default {
    title: 'Components/BoardGallery',
    component: BoardGallery,
};
var boards = [
    {
        title: 'Living Room',
        message: encodeBoardCharacters("Friends don't owe friends, silly. They just do favors because they want to."),
        author: 'Oswald Cobblepot',
        id: '0000-0000-00000000-00000000',
        friendlyIdentifier: 'ABC1234567',
        status: 'virtual',
        created: '8 min ago',
        isOwner: false,
        messageId: '0000-0000-00000000-00000000',
    },
    {
        title: 'Kitchen',
        message: encodeBoardCharacters('I know plenty about bats, Alfred. Tell me what you know about owls.'),
        author: 'Bruce Wayne',
        id: '0000-0000-00000000-00000001',
        friendlyIdentifier: 'ABC1234568',
        status: 'offline',
        created: '15 min ago',
        isOwner: true,
        messageId: '0000-0000-00000000-00000001',
        isMuted: true,
    },
    {
        title: 'Office',
        message: encodeBoardCharacters("I'm adaptable."),
        author: 'Selina Kyle',
        id: '0000-0000-00000000-00000002',
        friendlyIdentifier: 'ABC1234569',
        status: 'online',
        created: 'yesterday',
        isOwner: false,
        messageId: '0000-0000-00000000-00000002',
    },
    {
        title: 'Hallway',
        message: encodeBoardCharacters('Madness, as you know is like gravity. All it takes is a little push.'),
        author: 'Joker',
        id: '0000-0000-00000000-00000003',
        friendlyIdentifier: 'ABC1234561',
        status: 'online',
        created: 'last week',
        isOwner: false,
        messageId: '0000-0000-00000000-00000003',
    },
    {
        title: 'Great Room',
        message: encodeBoardCharacters("Grow stronger from the pain. Don't let it destroy you."),
        author: 'Bane',
        id: '0000-0000-00000000-00000004',
        friendlyIdentifier: 'ABC1234563',
        status: 'offline',
        created: '15 min ago',
        isOwner: false,
        messageId: '0000-0000-00000000-00000004',
    },
    {
        title: 'Great Room',
        id: '0000-0000-00000000-00000005',
        status: 'offline',
        isOwner: false,
    },
];
var basicBoards = [
    {
        message: encodeBoardCharacters("Friends don't owe friends, silly. They just do favors because they want to."),
        author: 'Oswald Cobblepot',
        id: '0000-0000-00000000-00000000',
        created: '8 min ago',
    },
    {
        message: encodeBoardCharacters('I know plenty about bats, Alfred. Tell me what you know about owls.'),
        author: 'Bruce Wayne',
        id: '0000-0000-00000000-00000001',
        created: '15 min ago',
    },
    {
        message: encodeBoardCharacters("I'm adaptable."),
        author: 'Selina Kyle',
        id: '0000-0000-00000000-00000002',
        created: 'yesterday',
    },
];
export var Default = function () {
    var _a = useState(0), currentPage = _a[0], setPage = _a[1];
    return (React.createElement(ToastProvider, null,
        React.createElement(BoardGallery, { boards: basicBoards, currentPage: currentPage, setPage: setPage })));
};
export var BoardSelection = function () {
    var _a = useState(0), currentPage = _a[0], setPage = _a[1];
    return (React.createElement(ToastProvider, null,
        React.createElement(BoardGallery, { boards: boards, currentPage: currentPage, setPage: setPage, handleCopy: action('copy'), handleSettings: action('settings'), handlePublish: action('publish'), handleLeave: action('leave'), handleRename: action('rename'), handleShare: action('share'), handleFavorite: action('favorite'), handleDuplicate: action('duplicate'), handleDelete: action('delete') })));
};
export var WithSettingsActions = function () {
    var _a = useState(0), currentPage = _a[0], setPage = _a[1];
    return (React.createElement(ToastProvider, null,
        React.createElement(BoardGallery, { boards: boards, currentPage: currentPage, setPage: setPage, handleCopy: action('copy'), handleSettings: action('settings'), handlePublish: action('publish'), handleLeave: action('leave'), handleRename: action('rename'), handleShare: action('share'), handleFavorite: action('favorite'), handleDuplicate: action('duplicate'), handleDelete: action('delete'), handleMuted: action('muted'), enableSettingsActions: true })));
};
export var OneBoard = function () {
    var _a = useState(0), currentPage = _a[0], setPage = _a[1];
    return (React.createElement(BoardGallery, { boards: [boards[0]], currentPage: currentPage, setPage: setPage, handleCopy: action('copy'), handleSettings: action('settings'), handlePublish: action('publish'), handleLeave: action('leave'), handleRename: action('rename'), handleShare: action('share'), handleFavorite: action('favorite'), handleDuplicate: action('duplicate'), handleDelete: action('delete'), handleMuted: action('muted') }));
};
export var WhiteBoards = function () {
    var _a = useState(0), currentPage = _a[0], setPage = _a[1];
    return (React.createElement(ToastProvider, null,
        React.createElement(BoardGallery, { boards: boards.map(function (board) { return (__assign(__assign({}, board), { boardStyle: 'white' })); }), currentPage: currentPage, setPage: setPage, handleCopy: action('copy'), handleSettings: action('settings'), handlePublish: action('publish'), handleLeave: action('leave'), handleRename: action('rename'), handleShare: action('share'), handleFavorite: action('favorite'), handleDuplicate: action('duplicate'), handleDelete: action('delete'), handleMuted: action('muted') })));
};
