import { BoardPreview } from '../';
import React, { useState } from 'react';
import { encodeBoardCharacters } from '../../utils';
export default {
    title: 'Components/BoardPreview',
    component: BoardPreview,
};
export var Default = function () {
    var _a = useState(false), isFavorite = _a[0], setIsFavorite = _a[1];
    return (React.createElement(BoardPreview, { handleFavorite: function () { return setIsFavorite(!isFavorite); }, isFavorite: isFavorite, characters: encodeBoardCharacters('I Think,              Therefore I am.') }));
};
export var ChangingBoard = function () {
    var _a = React.useState(encodeBoardCharacters('')), chars = _a[0], setChars = _a[1];
    function shuffle(a) {
        var _a;
        for (var i = a.length - 1; i > 0; i--) {
            var j = Math.floor(Math.random() * (i + 1));
            _a = [a[j], a[i]], a[i] = _a[0], a[j] = _a[1];
        }
        return a;
    }
    var shuffleAndShow = function () {
        setChars(shuffle(combinationChars1));
        setTimeout(function () { return shuffleAndShow(); }, 2000);
    };
    React.useEffect(function () {
        setChars(encodeBoardCharacters(''));
        shuffleAndShow();
    }, []);
    return React.createElement(BoardPreview, { characters: chars });
};
export var Colors = function () {
    var _a = useState(false), isFavorite = _a[0], setIsFavorite = _a[1];
    return (React.createElement(BoardPreview, { handleFavorite: function () { return setIsFavorite(!isFavorite); }, isFavorite: isFavorite, borderColor: "yellow", characters: [
            [63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63],
            [0, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0],
            [
                0,
                0,
                65,
                66,
                67,
                68,
                0,
                0,
                0,
                0,
                69,
                69,
                0,
                0,
                0,
                0,
                68,
                67,
                66,
                65,
                0,
                0,
            ],
            [
                0,
                0,
                65,
                66,
                67,
                68,
                0,
                0,
                0,
                0,
                69,
                69,
                0,
                0,
                0,
                0,
                68,
                67,
                66,
                65,
                0,
                0,
            ],
            [0, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0],
            [63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63],
        ] }));
};
export var Combination = function () { return (React.createElement(BoardPreview, { borderColor: "green", characters: [
        [
            67,
            68,
            65,
            63,
            68,
            65,
            63,
            68,
            65,
            37,
            37,
            37,
            37,
            37,
            37,
            37,
            37,
            65,
            68,
            63,
            65,
            67,
        ],
        [
            63,
            68,
            65,
            63,
            68,
            65,
            63,
            68,
            65,
            48,
            0,
            38,
            0,
            0,
            38,
            0,
            48,
            65,
            68,
            63,
            65,
            68,
        ],
        [
            68,
            65,
            63,
            68,
            65,
            63,
            68,
            65,
            48,
            0,
            0,
            0,
            47,
            47,
            0,
            0,
            0,
            48,
            65,
            68,
            63,
            65,
        ],
        [
            68,
            65,
            63,
            68,
            65,
            63,
            68,
            65,
            48,
            0,
            40,
            0,
            0,
            0,
            0,
            40,
            0,
            48,
            65,
            68,
            63,
            65,
        ],
        [
            63,
            68,
            65,
            63,
            68,
            65,
            63,
            68,
            65,
            48,
            0,
            40,
            40,
            40,
            40,
            0,
            48,
            65,
            68,
            63,
            65,
            68,
        ],
        [
            67,
            63,
            68,
            65,
            63,
            68,
            65,
            63,
            68,
            65,
            44,
            44,
            44,
            44,
            44,
            44,
            65,
            68,
            63,
            65,
            68,
            67,
        ],
    ] }, "1 Day Ago")); };
var allCharacters = [
    [
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
        18,
        19,
        20,
        21,
        22,
    ],
    [
        23,
        24,
        25,
        26,
        27,
        28,
        29,
        30,
        31,
        32,
        33,
        34,
        35,
        36,
        37,
        38,
        39,
        40,
        41,
        42,
        44,
        46,
    ],
    [
        47,
        48,
        49,
        50,
        52,
        53,
        54,
        55,
        56,
        59,
        60,
        62,
        63,
        64,
        65,
        66,
        67,
        68,
        69,
        70,
        71,
        0,
    ],
    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
];
export var AllCharacters = function () { return (React.createElement(BoardPreview, { borderColor: "green", characters: allCharacters }, "1 Day Ago")); };
export var VestaboardWhite = function () { return (React.createElement(BoardPreview, { boardStyle: "white", borderColor: "green", characters: allCharacters }, "1 Day Ago")); };
var combinationChars1 = [
    [
        67,
        68,
        65,
        63,
        68,
        65,
        63,
        68,
        65,
        37,
        37,
        37,
        37,
        37,
        37,
        37,
        37,
        65,
        68,
        63,
        65,
        67,
    ],
    [
        63,
        68,
        65,
        63,
        68,
        65,
        63,
        68,
        65,
        48,
        0,
        38,
        0,
        0,
        38,
        0,
        48,
        65,
        68,
        63,
        65,
        68,
    ],
    [
        68,
        65,
        63,
        68,
        65,
        63,
        68,
        65,
        48,
        0,
        0,
        0,
        47,
        47,
        0,
        0,
        0,
        48,
        65,
        68,
        63,
        65,
    ],
    [
        68,
        65,
        63,
        68,
        65,
        63,
        68,
        65,
        48,
        0,
        40,
        0,
        0,
        0,
        0,
        40,
        0,
        48,
        65,
        68,
        63,
        65,
    ],
    [
        63,
        68,
        65,
        63,
        68,
        65,
        63,
        68,
        65,
        48,
        0,
        40,
        40,
        40,
        40,
        0,
        48,
        65,
        68,
        63,
        65,
        68,
    ],
    [
        67,
        63,
        68,
        65,
        63,
        68,
        65,
        63,
        68,
        65,
        44,
        44,
        44,
        44,
        44,
        44,
        65,
        68,
        63,
        65,
        68,
        67,
    ],
];
