import { BoardPreview, BoardPreviewMask, ToastProvider } from '../';
import React, { useState } from 'react';
import { encodeBoardCharacters } from '../../utils';
import { DragHandleSharp } from '@mui/icons-material';
export default {
    title: 'Components/BoardPreviewMask',
    component: BoardPreview,
};
var characters = encodeBoardCharacters('I Think,              Therefore I am.');
export var Empty = function () { return (React.createElement(ToastProvider, null,
    React.createElement(BoardPreviewMask, { boardId: "0000-0000-00000000" },
        React.createElement(BoardPreview, { characters: characters })))); };
export var Default = function () {
    var _a = useState('0'), hourValue = _a[0], setHourValue = _a[1];
    var _b = useState('0'), minuteValue = _b[0], setMinuteValue = _b[1];
    var _c = useState('0'), secondValue = _c[0], setSecondValue = _c[1];
    return (React.createElement(ToastProvider, null,
        React.createElement(BoardPreviewMask, { characters: characters, boardId: "0000-0000-00000000", handleSend: function () { }, handleShare: function () { }, handlePin: function () { }, handleDuplicate: function () { }, handleDelete: function () { }, hourValue: hourValue, onHourValueChange: setHourValue, minuteValue: minuteValue, onMinuteValueChange: setMinuteValue, secondValue: secondValue, onSecondValueChange: setSecondValue },
            React.createElement(BoardPreview, { characters: characters }))));
};
export var WithDragHandle = function () { return (React.createElement(ToastProvider, null,
    React.createElement(BoardPreviewMask, { characters: characters, boardId: "0000-0000-00000000", handleShare: function () { }, handlePin: function () { }, handleDuplicate: function () { }, topRightAction: React.createElement("div", { style: {
                display: 'flex',
                position: 'absolute',
                right: 16,
                top: 8,
                zIndex: 10,
                backgroundColor: 'transparent',
                textTransform: 'none',
                color: 'white',
            } },
            React.createElement("div", { style: {
                    color: 'white',
                    fontSize: 10,
                    marginRight: 10,
                    marginTop: 10,
                } }, "Drag to change order"),
            React.createElement(DragHandleSharp, { fontSize: 'large' })) },
        React.createElement(BoardPreview, { characters: characters })))); };
export var Draft = function () { return (React.createElement(ToastProvider, null,
    React.createElement(BoardPreviewMask, { isDraft: true, boardId: "0000-0000-00000000", handleSend: function () { }, handleDiscard: function () { }, handleEdit: function () { }, characters: characters },
        React.createElement(BoardPreview, { characters: characters })))); };
export var Live = function () { return (React.createElement(ToastProvider, null,
    React.createElement(BoardPreviewMask, { boardId: "0000-0000-00000000", handleShare: function () { }, handlePin: function () { }, handleDuplicate: function () { }, characters: characters },
        React.createElement(BoardPreview, { characters: characters })))); };
export var White = function () { return (React.createElement(ToastProvider, null,
    React.createElement(BoardPreviewMask, { characters: characters, boardId: "0000-0000-00000000", handleSend: function () { }, handleShare: function () { }, handlePin: function () { }, handleDuplicate: function () { }, handleDelete: function () { } },
        React.createElement(BoardPreview, { characters: characters, boardStyle: "white" })))); };
export var DefaultShowMask = function () { return (React.createElement(ToastProvider, null,
    React.createElement(BoardPreviewMask, { characters: characters, boardId: "0000-0000-00000000", handleSend: function () { }, handleShare: function () { }, handlePin: function () { }, handleDuplicate: function () { }, handleDelete: function () { }, defaultShowMask: true },
        React.createElement(BoardPreview, { characters: characters, boardStyle: "black" })))); };
