import { CadencePicker, DayOfWeek, Interval, MonthOfYear, parseTimeString, } from '../CadencePicker';
import React from 'react';
import { VestaboardContextProvider } from '../../context/VestaboardSubscriptionContext';
import { action } from '@storybook/addon-actions';
export var Default = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { onChange: action('cadenceOnChange') })));
};
export var Minutes = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { onChange: action('cadenceOnChange'), intervals: [
                Interval.Minute_1,
                Interval.Minutes_2,
                Interval.Minutes_3,
                Interval.Minutes_4,
                Interval.Minutes_5,
                Interval.Minutes_10,
                Interval.Minutes_20,
                Interval.Minutes_30,
            ] })));
};
export var WithDefaultTimesAndNoCadence = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { defaultEndTime: {
                hour: '04',
                minutes: '50',
                amPm: 'PM',
            }, defaultStartTime: {
                hour: '04',
                minutes: '00',
                amPm: 'PM',
            }, onChange: action('cadenceOnChange') })));
};
export var WithInitialDailyValue = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { cadence: {
                interval: Interval.Day,
                startAtTimes: [
                    {
                        hour: '05',
                        minutes: '55',
                        amPm: 'PM',
                    },
                ],
            }, onChange: action('cadenceOnChange') })));
};
export var WithInitialDailyValueTwentyFourHourTime = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { isTwentyFourHourTime: true, cadence: {
                interval: Interval.Day,
                startAtTimes: [
                    {
                        hour: '05',
                        minutes: '55',
                        amPm: 'PM',
                    },
                ],
            }, onChange: action('cadenceOnChange') })));
};
export var WithInitialHourlyValue = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { cadence: {
                interval: Interval.Hour,
                startAtTime: parseTimeString('11:55'),
                endAtTime: parseTimeString('12:55'),
            }, onChange: action('cadenceOnChange') })));
};
export var WithWeekdayFilterDefaults = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { allowWeekdaySelection: true, defaultDays: [
                DayOfWeek.Monday,
                DayOfWeek.Tuesday,
                DayOfWeek.Wednesday,
                DayOfWeek.Thursday,
                DayOfWeek.Friday,
                DayOfWeek.Saturday,
                DayOfWeek.Sunday,
            ], defaultInterval: Interval.Day, onChange: action('cadenceOnChange') })));
};
export var WithWeekdayFilter = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { allowWeekdaySelection: true, cadence: {
                interval: Interval.Hour,
                startAtTime: parseTimeString('11:55'),
                endAtTime: parseTimeString('12:55'),
                daysOfTheWeek: [
                    DayOfWeek.Monday,
                    DayOfWeek.Tuesday,
                    DayOfWeek.Wednesday,
                    DayOfWeek.Thursday,
                    DayOfWeek.Friday,
                ],
            }, onChange: action('cadenceOnChange') })));
};
export var ByHourWithStartTimeAndEndTimeDisabled = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { allowWeekdaySelection: true, disableStartTime: true, disableEndTime: true, cadence: {
                interval: Interval.Hour,
                daysOfTheWeek: [
                    DayOfWeek.Monday,
                    DayOfWeek.Tuesday,
                    DayOfWeek.Wednesday,
                    DayOfWeek.Thursday,
                    DayOfWeek.Friday,
                ],
            }, onChange: action('cadenceOnChange') })));
};
export var WithMultipleTimesDisallowed = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { allowMultipleTimes: false, cadence: {
                interval: Interval.Day,
                startAtTimes: [
                    {
                        hour: '12',
                        minutes: '55',
                        amPm: 'PM',
                    },
                ],
            }, onChange: action('cadenceOnChange') })));
};
export var WithMultipleTimesDisallowedAndNoDefaultValue = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { allowMultipleTimes: false, onChange: action('cadenceOnChange') })));
};
export default {
    title: 'Components/CadencePicker',
    component: Default,
};
export var DayOnce = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { allowMultipleTimes: false, allowWeekdaySelection: true, cadence: {
                interval: Interval.Day,
                daysOfTheWeek: [
                    DayOfWeek.Monday,
                    DayOfWeek.Tuesday,
                    DayOfWeek.Wednesday,
                    DayOfWeek.Thursday,
                    DayOfWeek.Friday,
                ],
                startAtTimes: [
                    {
                        hour: '05',
                        minutes: '55',
                        amPm: 'PM',
                    },
                ],
            }, onChange: action('cadenceOnChange') })));
};
export var HideFrequencySelectorDay = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { onChange: action('cadenceOnChange'), allowWeekdaySelection: true, cadence: {
                interval: Interval.Day,
                daysOfTheWeek: [
                    DayOfWeek.Monday,
                    DayOfWeek.Tuesday,
                    DayOfWeek.Wednesday,
                    DayOfWeek.Thursday,
                    DayOfWeek.Friday,
                ],
                startAtTimes: [
                    {
                        hour: '05',
                        minutes: '55',
                        amPm: 'PM',
                    },
                ],
            }, hideFrequencySelector: true })));
};
export var DefaultYear = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { onChange: action('cadenceOnChange'), defaultInterval: Interval.Year, intervals: [
                Interval.Minute_1,
                Interval.Minutes_2,
                Interval.Minutes_3,
                Interval.Minutes_4,
                Interval.Minutes_5,
                Interval.Minutes_10,
                Interval.Minutes_20,
                Interval.Minutes_30,
                Interval.Year,
            ] })));
};
export var YearDisableDayChange = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { onChange: action('cadenceOnChange'), defaultInterval: Interval.Year, disableShowOn: true, defaultShowOn: {
                month: MonthOfYear.February,
                day: 14,
            }, intervals: [
                Interval.Minute_1,
                Interval.Minutes_2,
                Interval.Minutes_3,
                Interval.Minutes_4,
                Interval.Minutes_5,
                Interval.Minutes_10,
                Interval.Minutes_20,
                Interval.Minutes_30,
                Interval.Year,
            ] })));
};
export var YearHideDayChange = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { onChange: action('cadenceOnChange'), defaultInterval: Interval.Year, hideShowOn: true, defaultShowOn: {
                month: MonthOfYear.February,
                day: 14,
            }, intervals: [
                Interval.Minute_1,
                Interval.Minutes_2,
                Interval.Minutes_3,
                Interval.Minutes_4,
                Interval.Minutes_5,
                Interval.Minutes_10,
                Interval.Minutes_20,
                Interval.Minutes_30,
                Interval.Year,
            ] })));
};
export var YearOnceStringChange = function () {
    return (React.createElement(VestaboardContextProvider, null,
        React.createElement(CadencePicker, { onChange: action('cadenceOnChange'), defaultInterval: Interval.Year, hideShowOn: true, defaultShowOn: {
                month: MonthOfYear.February,
                day: 14,
            }, yearlyString: "Once", intervals: [
                Interval.Minute_1,
                Interval.Minutes_2,
                Interval.Minutes_3,
                Interval.Minutes_4,
                Interval.Minutes_5,
                Interval.Minutes_10,
                Interval.Minutes_20,
                Interval.Minutes_30,
                Interval.Year,
            ] })));
};
