import { IngredientTextEditor, useIngredientEditor, } from '../IngredientTextEditor/IngredientTextEditor';
import React from 'react';
import { Button } from '@mui/material';
export default {
    title: 'Components/IngredientTextEditor',
    component: IngredientTextEditor,
};
export var Default = function () {
    var ingredientValues = {
        Temperature: '70F',
        FollowerCount: '100',
        Name: 'Bob Weir',
    };
    var ingredients = [
        {
            maxIngredientLength: 7,
            ingredientName: 'Time',
        },
        {
            maxIngredientLength: 4,
            ingredientName: 'Temperature',
        },
        {
            maxIngredientLength: 15,
            ingredientName: 'MoonPhase',
        },
        {
            maxIngredientLength: 13,
            ingredientName: 'FollowerCount',
        },
        {
            maxIngredientLength: 8,
            ingredientName: 'Name',
        },
        {
            maxIngredientLength: 1,
            ingredientName: 'Newline',
        },
    ];
    var _a = useIngredientEditor({
        ingredients: ingredients,
        ingredientValues: ingredientValues,
    }), editor = _a.editor, getEditorState = _a.getEditorState;
    return (React.createElement(IngredientTextEditor
    // Slate editor object from useIngredientEditor hook
    , { 
        // Slate editor object from useIngredientEditor hook
        editor: editor, selectText: "Select Variable", ingredients: [
            {
                maxIngredientLength: 7,
                ingredientName: 'Time',
            },
            {
                maxIngredientLength: 4,
                ingredientName: 'Temperature',
            },
            {
                maxIngredientLength: 15,
                ingredientName: 'MoonPhase',
            },
            {
                maxIngredientLength: 13,
                ingredientName: 'FollowerCount',
            },
            {
                maxIngredientLength: 8,
                ingredientName: 'Name',
            },
            {
                maxIngredientLength: 1,
                ingredientName: 'Newline',
            },
        ], 
        // *optional (values left out will result in the ingredient placeholder being left in ex: {{Time}} etc)
        ingredientValues: ingredientValues, 
        // Pass in the output from raw here if you want to store the value in a database
        //ex JSON.parse('[{"type":"paragraph","children":[{"text":"hi it is "},{"type":"ingredient","ingredientName":"Time","children":[{"text":""}]},{"text":""}]}]')
        initialValue: undefined, placeholder: "Enter your text here", 
        // Value is the string value, raw is the array from slate, optional
        submit: function (value, length, raw) { return console.log(value, length, raw); }, submitTitle: 'Save' }));
};
export var NoSubmit = function () {
    var ingredientValues = {
        Temperature: '70F',
        FollowerCount: '100',
        Name: 'Bob Weir',
    };
    var ingredients = [
        {
            maxIngredientLength: 7,
            ingredientName: 'Time',
        },
        {
            maxIngredientLength: 4,
            ingredientName: 'Temperature',
        },
        {
            maxIngredientLength: 15,
            ingredientName: 'MoonPhase',
        },
        {
            maxIngredientLength: 13,
            ingredientName: 'FollowerCount',
        },
        {
            maxIngredientLength: 8,
            ingredientName: 'Name',
        },
        {
            maxIngredientLength: 1,
            ingredientName: 'Newline',
        },
    ];
    // Get Editor state is a function you can call on submit
    // const { text, length, raw } = getEditorState()
    var _a = useIngredientEditor({
        ingredients: ingredients,
        ingredientValues: ingredientValues,
    }), editor = _a.editor, getEditorState = _a.getEditorState;
    return (React.createElement(React.Fragment, null,
        React.createElement(IngredientTextEditor
        // Slate editor object from useIngredientEditor hook
        , { 
            // Slate editor object from useIngredientEditor hook
            editor: editor, selectText: "Select Variable", ingredients: [
                {
                    maxIngredientLength: 7,
                    ingredientName: 'Time',
                },
                {
                    maxIngredientLength: 4,
                    ingredientName: 'Temperature',
                },
                {
                    maxIngredientLength: 15,
                    ingredientName: 'MoonPhase',
                },
                {
                    maxIngredientLength: 13,
                    ingredientName: 'FollowerCount',
                },
                {
                    maxIngredientLength: 8,
                    ingredientName: 'Name',
                },
                {
                    maxIngredientLength: 1,
                    ingredientName: 'Newline',
                },
            ], 
            // *optional (values left out will result in the ingredient placeholder being left in ex: {{Time}} etc)
            ingredientValues: ingredientValues, 
            // Pass in the output from raw here if you want to store the value in a database
            //ex JSON.parse('[{"type":"paragraph","children":[{"text":"hi it is "},{"type":"ingredient","ingredientName":"Time","children":[{"text":""}]},{"text":""}]}]')
            initialValue: undefined, placeholder: "Enter your text here" }),
        React.createElement(Button, { onClick: function () { return console.log(getEditorState()); } }, "Get Editor State")));
};
