var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useState } from 'react';
import { Input } from '../';
import { VolumeMute } from '@mui/icons-material';
export default {
    title: 'Components/Input',
    component: Input,
};
export var Default = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    return React.createElement(Input, { value: value, onValueChange: setValue, label: "Title" });
};
export var Error = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Title", error: "Invalid title" }));
};
export var Password = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Password", type: "password" }));
};
export var MultiLine = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Title", multiline: true }));
};
export var Date = function () {
    var _a = useState('1988-10-02'), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Date", type: "date" }));
};
export var Time = function () {
    var _a = useState('07:30'), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Time", type: "time" }));
};
export var DateTime = function () {
    var _a = useState('1988-10-02T07:30'), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Date & Time", type: "datetime-local" }));
};
export var DateTimeWithPlaceholder = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Date & Time", type: "datetime-local", placeholder: "Select date and time" }));
};
export var DateTimeWithStartAdornment = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Date & Time", type: "datetime-local", startAdornment: React.createElement(VolumeMute, { color: "primary" }) }));
};
export var DateTimeWithStartAdornmentAndPlaceholder = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    var _b = useState([]), inputs = _b[0], setInputs = _b[1];
    return (React.createElement(Input, { value: value, onValueChange: function (value) {
            setValue(value);
            setInputs(__spreadArray(__spreadArray([], inputs, true), [value], false));
        }, label: "Date & Time", type: "datetime-local", placeholder: "Schedule", startAdornment: React.createElement(VolumeMute, { color: "primary" }) }));
};
export var Number = function () {
    var _a = useState('1'), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, label: "Number", type: "number" }));
};
export var Disabled = function () {
    var _a = useState('1'), value = _a[0], setValue = _a[1];
    return React.createElement(Input, { value: value, onValueChange: setValue, label: "Age", disabled: true });
};
export var NoBorder = function () {
    var _a = useState('1'), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, disableBorder: true, textColor: "shuttleGray", fontSize: "small" }));
};
export var ReadOnly = function () {
    var _a = useState('Try to type'), value = _a[0], setValue = _a[1];
    return (React.createElement(Input, { value: value, onValueChange: setValue, readOnly: true, label: "You can't change this" }));
};
