import { Body, Button, Modal, Spacer, SubTitle2 } from '../../';
import React, { useState } from 'react';
import { Box } from '@mui/material';
export default {
    title: 'Components/Modal',
    component: Modal,
};
export var Default = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(Modal, { visible: visible, onClose: function () { return setVisible(false); } },
            React.createElement(SubTitle2, null, "Hello World"))));
};
export var Transparent = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(Modal, { transparent: true, visible: visible, onClose: function () { return setVisible(false); } },
            React.createElement(SubTitle2, null, "Hello World...transparent"))));
};
export var TransparentBlur = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(SubTitle2, null, "This should be blurry when open"),
        React.createElement(Modal, { transparent: true, visible: visible, onClose: function () { return setVisible(false); }, blur: true },
            React.createElement(SubTitle2, null, "Hello World...transparent blur"))));
};
export var FullScreenDesktopMobile = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(SubTitle2, null, "This should be blurry when open"),
        React.createElement(Modal, { transparent: true, visible: visible, goBack: function () { return setVisible(false); }, blur: true, fullScreenDesktop: true, fullScreenMobile: true },
            React.createElement(Box, { style: {
                    display: 'flex',
                    alignItems: 'center',
                    justifyContent: 'center',
                    padding: 20,
                } },
                React.createElement(SubTitle2, null, "Hello World...transparent blur. This should go to the edges of the screen before wrapping")))));
};
export var NoClose = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(Modal, { transparent: true, visible: visible, fullScreenMobile: true },
            React.createElement(SubTitle2, null, "Hello World...you cannot close this"))));
};
export var GoBack = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(Modal, { fullScreenMobile: true, transparent: true, visible: visible, goBack: function () { return setVisible(false); }, blur: true },
            React.createElement(SubTitle2, null, "Hello World... click back"))));
};
export var MobileFullscreen = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(Modal, { fullScreenMobile: true, visible: visible, onClose: function () { return setVisible(false); } },
            React.createElement(SubTitle2, null, "Hello World...mobile full screen lots of text to wrap"))));
};
export var Overflow = function () {
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setVisible(true); } }, "Show Modal"),
        React.createElement(Modal, { visible: visible, onClose: function () { return setVisible(false); } },
            React.createElement(React.Fragment, null,
                React.createElement(SubTitle2, null, "Hello World"),
                React.createElement(Spacer, { size: "large" }),
                React.createElement(Body, null, "It was the best of times, it was the worst of times, it was the age of wisdom, it was the age of foolishness, it was the epoch of belief, it was the epoch of incredulity, it was the season of Light, it was the season of Darkness, it was the spring of hope, it was the winter of despair, we had everything before us, we had nothing before us, we were all going direct to Heaven, we were all going direct the other way--in short, the period was so far like the present period, that some of its noisiest authorities insisted on its being received, for good or for evil, in the superlative degree of comparison only."),
                React.createElement(Spacer, { size: "large" }),
                React.createElement(Body, null, "There were a king with a large jaw and a queen with a plain face, on the throne of England; there were a king with a large jaw and a queen with a fair face, on the throne of France. In both countries it was clearer than crystal to the lords of the State preserves of loaves and fishes, that things in general were settled for ever."),
                React.createElement(Spacer, { size: "large" }),
                React.createElement(Body, null, "It was the year of Our Lord one thousand seven hundred and seventy-five. Spiritual revelations were conceded to England at that favoured period, as at this. Mrs. Southcott had recently attained her five-and-twentieth blessed birthday, of whom a prophetic private in the Life Guards had heralded the sublime appearance by announcing that arrangements were made for the swallowing up of London and Westminster. Even the Cock-lane ghost had been laid only a round dozen of years, after rapping out its messages, as the spirits of this very year last past (supernaturally deficient in originality) rapped out theirs. Mere messages in the earthly order of events had lately come to the English Crown and People, from a congress of British subjects in America: which, strange to relate, have proved more important to the human race than any communications yet received through any of the chickens of the Cock-lane brood."),
                React.createElement(Spacer, { size: "large" }),
                React.createElement(Body, null, "France, less favoured on the whole as to matters spiritual than her sister of the shield and trident, rolled with exceeding smoothness down hill, making paper money and spending it. Under the guidance of her Christian pastors, she entertained herself, besides, with such humane achievements as sentencing a youth to have his hands cut off, his tongue torn out with pincers, and his body burned alive, because he had not kneeled down in the rain to do honour to a dirty procession of monks which passed within his view, at a distance of some fifty or sixty yards. It is likely enough that, rooted in the woods of France and Norway, there were growing trees, when that sufferer was put to death, already marked by the Woodman, Fate, to come down and be sawn into boards, to make a certain movable framework with a sack and a knife in it, terrible in history. It is likely enough that in the rough outhouses of some tillers of the heavy lands adjacent to Paris, there were sheltered from the weather that very day, rude carts, bespattered with rustic mire, snuffed about by pigs, and roosted in by poultry, which the Farmer, Death, had already set apart to be his tumbrils of the Revolution. But that Woodman and that Farmer, though they work unceasingly, work silently, and no one heard them as they went about with muffled tread: the rather, forasmuch as to entertain any suspicion that they were awake, was to be atheistical and traitorous.")))));
};
