import React from 'react';
import { NativeVisualEditorBridge } from '../NativeVisualEditorBridge';
import { Box, Button, Divider, Typography } from '@mui/material';
export default {
    title: 'Components/NativeVisualEditorBridge',
    component: NativeVisualEditorBridge,
};
var createBoardWithCharacter = function (character) {
    return JSON.stringify(new Array(5).fill(new Array(22).fill(character)));
};
var ImmediatelyLaunchingVisualEditor = function (props) {
    React.useEffect(function () { return props.launch(); }, []);
    return React.createElement("span", null);
};
export var Default = function () {
    var _a = React.useState(null), message = _a[0], setMessage = _a[1];
    var _b = React.useState(null), prefilledMessage = _b[0], setPrefilledMessage = _b[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Box, null,
            React.createElement("select", { value: prefilledMessage !== null && prefilledMessage !== void 0 ? prefilledMessage : undefined, onChange: function (e) { return setPrefilledMessage(e.target.value); } },
                React.createElement("option", { value: '' }, "-- No prefilled message --"),
                React.createElement("option", { value: createBoardWithCharacter(63) }, "All red"),
                React.createElement("option", { value: createBoardWithCharacter(66) }, "All green"),
                React.createElement("option", { value: createBoardWithCharacter(67) }, "All blue")),
            React.createElement(NativeVisualEditorBridge, { renderWebVisualEditor: function (open, editor) { return React.createElement("span", null, editor); }, onComplete: function (id, text, characters) {
                    setMessage({ id: id, text: text, characters: JSON.parse(characters !== null && characters !== void 0 ? characters : '[]') });
                } }, function (launch) { return (React.createElement(Button, { color: "primary", onClick: function () { return launch(prefilledMessage !== null && prefilledMessage !== void 0 ? prefilledMessage : '[]'); } }, "Launch Visual Editor")); })),
        React.createElement(Box, null,
            React.createElement(Typography, { style: { color: 'white' } }, JSON.stringify(message))),
        React.createElement(Divider, null),
        React.createElement(Box, null,
            React.createElement(Button, { color: "primary", onClick: function () {
                    window.location.href =
                        'https://platform.vestaboard.com/deeplink/settings/timezone';
                } }, "Open Timezone Settings"))));
};
