import React, { useEffect, useState } from 'react';
import { Toast, ToastProvider, useToasts } from '..';
import Box from '@mui/material/Box';
import { Button } from '@mui/material';
export default {
    title: 'Components/Toast',
    component: Toast,
};
export var Success = function () {
    var _a = useState(true), open = _a[0], setOpen = _a[1];
    return (React.createElement(Toast, { severity: "success", message: "Hello World", open: open, onClose: function () { return setOpen(false); } }));
};
export var Error = function () {
    var _a = useState(true), open = _a[0], setOpen = _a[1];
    return (React.createElement(Toast, { severity: "error", message: "This is fine", open: open, onClose: function () { return setOpen(false); } }));
};
export var AutoHide = function () {
    var _a = useState(true), open = _a[0], setOpen = _a[1];
    return (React.createElement(Toast, { autoHideDurationSeconds: 3, severity: "success", message: "Will close in 3 seconds", open: open, onClose: function () { return setOpen(false); } }));
};
var StackedInner = function () {
    var addToast = useToasts().addToast;
    useEffect(function () {
        addToast("".concat(new Date().toString()), {
            appearance: 'success',
            autoDismiss: true,
        });
    }, []);
    return React.createElement(Box, null);
};
export var Stacked = function () {
    return (React.createElement(ToastProvider, null,
        React.createElement(StackedInner, null)));
};
var AdjustOffsetInner = function () {
    var _a = useToasts(), addToast = _a.addToast, setToastOffset = _a.setToastOffset;
    useEffect(function () {
        addToast("".concat(new Date().toString()), {
            appearance: 'success',
        });
    }, []);
    return (React.createElement(Box, null,
        React.createElement(Button, { style: { color: 'white' }, onClick: function () {
                addToast("".concat(new Date().toString()), {
                    appearance: 'success',
                });
            } }, "Open Toast"),
        React.createElement(Button, { style: { color: 'white' }, onClick: function () {
                setToastOffset(0);
                addToast("".concat(new Date().toString()), {
                    appearance: 'success',
                });
            } }, "0 offset"),
        React.createElement(Button, { style: { color: 'white' }, onClick: function () {
                setToastOffset(40);
                addToast("".concat(new Date().toString()), {
                    appearance: 'success',
                });
            } }, "40 offset"),
        React.createElement(Button, { style: { color: 'white' }, onClick: function () {
                setToastOffset(80);
                addToast("".concat(new Date().toString()), {
                    appearance: 'success',
                });
            } }, "80 offset"),
        React.createElement(Button, { style: { color: 'white' }, onClick: function () {
                setToastOffset(120);
                addToast("".concat(new Date().toString()), {
                    appearance: 'success',
                });
            } }, "120 offset")));
};
export var AdjustOffset = function () { return (React.createElement(ToastProvider, null,
    React.createElement(AdjustOffsetInner, null))); };
