import { SwatchPicker, WysiwygEditor } from '../..';
import React, { useEffect, useState } from 'react';
import { encodeBoardCharacters, encodeBoardCharactersAsync } from '../../utils';
import { TransparentTextArea } from '../TransparentTextArea';
import { createBoard } from '../../utils/createBoard';
export default {
    title: 'Components/WysiwygEditor',
    component: WysiwygEditor,
};
export var Default = function () {
    var _a = useState(createBoard()), value = _a[0], setValue = _a[1];
    return React.createElement(WysiwygEditor, { value: value, setValue: setValue, mode: "type" });
};
export var Animated = function () {
    var _a = useState(encodeBoardCharacters('I Think,              Therefore I am.')), value = _a[0], setValue = _a[1];
    return (React.createElement(WysiwygEditor, { value: value, setValue: setValue, animated: true, mode: "type" }));
};
export var ReadOnly = function () {
    var value = useState(encodeBoardCharacters('I Think,              Therefore I am.'))[0];
    return React.createElement(WysiwygEditor, { value: value, animated: false, mode: "display" });
};
export var PaintMode = function () {
    var _a = useState(createBoard()), value = _a[0], setValue = _a[1];
    var _b = useState(0), color = _b[0], setColor = _b[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(WysiwygEditor, { color: color, value: value, setValue: setValue, mode: "paint" }),
        React.createElement("div", { style: { height: 40 } }),
        React.createElement(SwatchPicker, { value: color, setValue: setColor, isPaintMode: true, endPaintMode: function () { } })));
};
export var Auto = function () {
    var _a = useState(''), value = _a[0], setValue = _a[1];
    var _b = useState(createBoard()), boardValue = _b[0], setBoardValue = _b[1];
    useEffect(function () {
        encodeBoardCharactersAsync({
            message: value,
        }).then(setBoardValue);
    }, [value, setBoardValue]);
    return (React.createElement(React.Fragment, null,
        React.createElement(WysiwygEditor, { value: boardValue, setValue: setBoardValue, mode: "display" }),
        React.createElement("div", { style: { height: 40 } }),
        React.createElement(TransparentTextArea, { value: value, onValueChange: setValue, placeholder: "Type for auto-arrangement or click Visual above to control placement.", countDown: 132 })));
};
export var White = function () {
    var _a = useState(createBoard()), value = _a[0], setValue = _a[1];
    return (React.createElement(WysiwygEditor, { boardStyle: "white", value: value, setValue: setValue, mode: "type" }));
};
export var TwelveByTwo = function () {
    var _a = useState(createBoard({
        rows: 2,
        columns: 12,
    })), value = _a[0], setValue = _a[1];
    return (React.createElement(WysiwygEditor, { value: value, setValue: setValue, mode: "type", rows: 2, columns: 12 }));
};
export var TwelveByThree = function () {
    var _a = useState(createBoard({
        rows: 3,
        columns: 12,
    })), value = _a[0], setValue = _a[1];
    return (React.createElement(WysiwygEditor, { value: value, setValue: setValue, mode: "type", rows: 3, columns: 12 }));
};
export var FifteenByThree = function () {
    var _a = useState(createBoard({
        rows: 3,
        columns: 15,
    })), value = _a[0], setValue = _a[1];
    return (React.createElement(WysiwygEditor, { value: value, setValue: setValue, mode: "type", rows: 3, columns: 15 }));
};
export var EighteenByTwo = function () {
    var _a = useState(createBoard({
        rows: 2,
        columns: 18,
    })), value = _a[0], setValue = _a[1];
    return (React.createElement(WysiwygEditor, { value: value, setValue: setValue, mode: "type", rows: 2, columns: 18 }));
};
