/// <reference types="react" />
export interface ITypography {
    children: React.ReactNode;
    color?: string;
    maxWidth?: number;
    fontWeight?: number | string;
}
export declare const typographyStyles: {
    title: (props: ITypography) => {
        color: string;
        fontSize: number;
        fontWeight: string | number;
        fontFamily: string;
    };
    subTitle: (props: ITypography) => {
        color: string;
        fontSize: number;
        fontWeight: string | number;
        fontFamily: string;
    };
    subTitle2: (props: ITypography) => {
        color: string;
        fontSize: number;
        fontWeight: string | number;
        fontFamily: string;
    };
    body: (props: ITypography) => {
        color: string;
        fontSize: number;
        fontFamily: string;
        fontWeight: string | number | undefined;
    };
    medium: (props: ITypography) => {
        color: string;
        fontSize: number;
        fontWeight: string | number | undefined;
        fontFamily: string;
    };
    mediumTruncated: (props: ITypography) => {
        color: string;
        fontSize: number;
        fontFamily: string;
        fontWeight: string | number | undefined;
        whiteSpace: string;
        maxWidth: number | undefined;
        overflow: string;
        textOverflow: string;
    };
    small: (props: ITypography) => {
        color: string;
        fontSize: number;
        fontFamily: string;
        fontWeight: string | number | undefined;
    };
};
