import * as React from 'react';
export interface SubscriptionConfigTokenData {
    subscription: {
        id: string;
        created: number;
        title: string | null;
        description: string | null;
        icon: string | null;
        userData: string | null;
        board: {
            id: string;
            boardStyle: string;
            timezone: {
                city: string;
            };
            tenant: {
                id: string;
            };
        }[];
        otherSubscriptions: {
            id: string;
            subscriptionConfigurationToken: string;
        }[];
        marketplaceListing: {
            id: string;
            title: string;
            description: string;
            icon: string | null;
            configuration: string;
            installable: {
                id: string;
                title: string | null;
                configurationSchema: string;
            };
            messageSet: {
                id: string;
                title: string;
            } | null;
        };
        installation: {
            id: string;
            created: number;
            apiCredential: {
                key: string;
                secret: string;
            };
        };
    };
}
interface IUseVestaboardSubscriptionConfigInformation {
    subscriptionConfigToken?: string;
}
export declare const useVestaboardSubscriptionConfigInformation: (props?: IUseVestaboardSubscriptionConfigInformation) => {
    data: SubscriptionConfigTokenData | undefined;
    loading: boolean;
    refetch: () => Promise<void>;
};
interface IVestaboardSubscriptionContext {
    loading: boolean;
    refetch: () => Promise<any>;
    data?: SubscriptionConfigTokenData;
}
export declare const useVestaboardChannelContext: () => IVestaboardSubscriptionContext | undefined;
export declare const useVestaboardTimezone: () => {
    value: string | null;
    loading: boolean;
};
export declare const VestaboardContextProvider: (props: {
    children?: React.ReactNode;
}) => React.JSX.Element;
export {};
