var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as React from 'react';
import { QueryParamProvider } from 'use-query-params';
import { useVestaboardQueryParams } from '../hooks/useVestaboardParams';
var cached = null;
export var useVestaboardSubscriptionConfigInformation = function (props) {
    var _a = React.useState(cached || undefined), data = _a[0], setData = _a[1];
    var _b = React.useState(false), loading = _b[0], setLoading = _b[1];
    var subscriptionConfigToken = useVestaboardQueryParams().subscriptionConfigToken;
    var fetch = React.useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var res, json;
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (cached || loading || data) {
                        return [2 /*return*/];
                    }
                    setLoading(true);
                    return [4 /*yield*/, window.fetch("https://platform.vestaboard.com/v2.0/subscription-configuration-token", {
                            headers: {
                                'X-Vestaboard-Subscription-Configuration-Token': (_b = (_a = props === null || props === void 0 ? void 0 : props.subscriptionConfigToken) !== null && _a !== void 0 ? _a : subscriptionConfigToken) !== null && _b !== void 0 ? _b : undefined,
                            },
                        })];
                case 1:
                    res = _c.sent();
                    return [4 /*yield*/, res.json()];
                case 2:
                    json = _c.sent();
                    cached = json;
                    setData(json);
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); }, [loading, data]);
    var refetch = function () { return fetch(); };
    React.useEffect(function () {
        if (subscriptionConfigToken || (props === null || props === void 0 ? void 0 : props.subscriptionConfigToken)) {
            fetch();
        }
    }, []);
    return {
        data: data,
        loading: loading,
        refetch: refetch,
    };
};
var VestaboardSubscriptionContext = React.createContext(undefined);
export var useVestaboardChannelContext = function () {
    return React.useContext(VestaboardSubscriptionContext);
};
var useVestaboardChannelContextPicker = function (picker) {
    var channelContext = useVestaboardChannelContext();
    if (!channelContext)
        throw Error('unexpected - must be used inside a VestaboardChannelContextProvider');
    var data = channelContext.data, loading = channelContext.loading;
    return {
        value: data ? picker(data) : null,
        loading: loading,
    };
};
export var useVestaboardTimezone = function () {
    return useVestaboardChannelContextPicker(function (data) { var _a, _b; return (_b = (_a = data === null || data === void 0 ? void 0 : data.subscription.board[0]) === null || _a === void 0 ? void 0 : _a.timezone) === null || _b === void 0 ? void 0 : _b.city; });
};
var VestaboardChannelContextProvider = function (props) {
    var _a = useVestaboardSubscriptionConfigInformation(), loading = _a.loading, refetch = _a.refetch, data = _a.data;
    return (React.createElement(VestaboardSubscriptionContext.Provider, { value: { loading: loading, refetch: refetch, data: data } }, props.children));
};
export var VestaboardContextProvider = function (props) {
    return (React.createElement(QueryParamProvider, null,
        React.createElement(VestaboardChannelContextProvider, null, props.children)));
};
