import { useEffect } from 'react';
export var useOutsideClick = function (ref, callback) {
    useEffect(function () {
        var handleClickOutside = function (event) {
            if (ref &&
                ref.current &&
                !ref.current.contains(event.target)) {
                callback();
            }
        };
        document.addEventListener('mousedown', handleClickOutside);
        return function () {
            document.removeEventListener('mousedown', handleClickOutside);
        };
    }, [ref, callback]);
    return { ref: ref };
};
