interface IUseUpdateDetails {
    subscriptionId: string;
    title?: string;
    iconUrl?: string;
}
/**
 * _useUpdateDetails_
 *
 * Posts updates to Installable details i.e.(title and icon url) to the React Native app's WebView component
 * iconUrl via the window `postMessage()` method.
 *
 * @example
 *
 * ```tsx
 *
 * import { useUpdateDetails } from '@vestaboard/installable-kit/hooks'
 *
 * const { updateDetails } = useUpdateDetails()
 *
 * updateDetails('New Title')
 *
 * ```
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/API/Window/postMessage
 */
export declare const useUpdateDetails: () => {
    updateTitle: ({ title, iconUrl, subscriptionId }: IUseUpdateDetails) => null;
};
export {};
