import { IBoard } from './Board';
export interface ShareMessageInput {
    messageId: string;
}
export interface ShareMessageResponse {
    rawToken: string;
    messageId: string;
    encryptionToken: string;
}
export interface SendMessageInput {
    characters: IBoard;
}
export interface SendMessageResponse {
    message: {
        id: string;
        created: number;
    };
}
export interface MessageData {
    id: string;
    text: any;
    characters: string;
    created: number;
}
export interface MessageSetData {
    id: string;
    created: number;
    title: string;
    messages: MessageData[];
}
export interface MessageSetResponse {
    messageSet: MessageSetData;
}
export interface SuggestMessageSetMessageInput {
    messageSetId: string;
    characters: IBoard;
    text?: string;
}
export interface ListFavoritesResponse {
    personId: string;
    favorites: string[];
}
export interface AddFavoriteInput {
    messageId: string;
}
export interface RemoveFavoriteInput {
    messageId: string;
}
